// ************************************************************************************************************************ //
//
//	File:			AI.h
//	Description:	General header for settings for AI (defined by Rank and Class)
//	Author:			Beny
//
// ************************************************************************************************************************ //


#ifndef	__AI_H__
#define	__AI_H__


#include <inc\sc_global.h>


//
// ++++++++++++++++++++++++++++++++++++++++++ RANK-specific AI properties ++++++++++++++++++++++++++++++++++++++++++
//


//Difficulty multipliers (values dependent on difficulty are multiplied by this value)
#define	DIF_MULT_EASY		0.2f
#define	DIF_MULT_NORMAL		0.5f
#define	DIF_MULT_HARD		0.7f
#define	DIF_MULT_VIETNAM	0.8f



//Rank values							//Defaults, description

//Rank 0:
#define	RNK_1_AIMTIME		6.0f		//0.7,  maximalni cas pro zamireni
#define	RNK_1_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_1_AIMTIMEDIST	2.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_1_WEAKSHOT_TIME	12.0f		//1.5,  shooting will be weaker for selected time
#define	RNK_1_WEAKSHOT_IMPR	2.5f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_1_DNG_STOPSHOOT	13.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_1_DNG_DONTPEEP	15.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_1_RECEIVED_DMG	3.0f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_1_FORGET_ENEMY	15.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 1:
#define	RNK_2_AIMTIME		5.0f		//0.7,  maximalni cas pro zamireni
#define	RNK_2_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_2_AIMTIMEDIST	3.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_2_WEAKSHOT_TIME	10.0f		//1.5,  shooting will be weaker for selected time
#define	RNK_2_WEAKSHOT_IMPR	2.0f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_2_DNG_STOPSHOOT	12.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_2_DNG_DONTPEEP	13.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_2_RECEIVED_DMG	2.5f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_2_FORGET_ENEMY	25.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 2:
#define	RNK_3_AIMTIME		4.0f		//0.7,  maximalni cas pro zamireni
#define	RNK_3_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_3_AIMTIMEDIST	4.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_3_WEAKSHOT_TIME	7.0f		//1.5,  shooting will be weaker for selected time
#define	RNK_3_WEAKSHOT_IMPR	2.0f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_3_DNG_STOPSHOOT	15.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_3_DNG_DONTPEEP	10.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_3_RECEIVED_DMG	2.0f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_3_FORGET_ENEMY	30.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 3:
#define	RNK_4_AIMTIME		3.0f		//0.7,  maximalni cas pro zamireni
#define	RNK_4_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_4_AIMTIMEDIST	5.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_4_WEAKSHOT_TIME	5.0f		//1.5,  shooting will be weaker for selected time
#define	RNK_4_WEAKSHOT_IMPR	1.7f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_4_DNG_STOPSHOOT	15.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_4_DNG_DONTPEEP	9.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_4_RECEIVED_DMG	1.5f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_4_FORGET_ENEMY	30.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 4:
#define	RNK_5_AIMTIME		2.5f		//0.7,  maximalni cas pro zamireni
#define	RNK_5_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_5_AIMTIMEDIST	5.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_5_WEAKSHOT_TIME	4.0f		//1.5,  shooting will be weaker for selected time
#define	RNK_5_WEAKSHOT_IMPR	1.5f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_5_DNG_STOPSHOOT	17.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_5_DNG_DONTPEEP	7.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_5_RECEIVED_DMG	1.3f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_5_FORGET_ENEMY	35.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 5:
#define	RNK_6_AIMTIME		2.0f		//0.7,  maximalni cas pro zamireni
#define	RNK_6_CANSHOOT		0.1f		//0.1,  nikdy nenastavovat na nulu
#define	RNK_6_AIMTIMEDIST	5.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
#define	RNK_6_WEAKSHOT_TIME	3.5f		//1.5,  shooting will be weaker for selected time
#define	RNK_6_WEAKSHOT_IMPR	1.5f		//2.0,  multiplicated during "first weak shooting batch"
#define	RNK_6_DNG_STOPSHOOT	17.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
#define	RNK_6_DNG_DONTPEEP	6.0f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
#define	RNK_6_RECEIVED_DMG	1.2f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
#define	RNK_6_FORGET_ENEMY	35.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl

//Rank 6:
//#define	RNK_6_AIMTIME		1.0f		//0.7,  maximalni cas pro zamireni
//#define	RNK_6_CANSHOOT		0.2f		//0.1,  nikdy nenastavovat na nulu
//#define	RNK_6_AIMTIMEDIST	6.0f		//8.0,  pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu
//#define	RNK_6_WEAKSHOT_TIME	2.0f		//1.5,  shooting will be weaker for selected time
//#define	RNK_6_WEAKSHOT_IMPR	1.3f		//2.0,  multiplicated during "first weak shooting batch"
//#define	RNK_6_DNG_STOPSHOOT	15.0f		//25.0, pri jake hodnote danger_around postava prerusi strelbu z ukrytu
//#define	RNK_6_DNG_DONTPEEP	4.5f		//5.0,  pri jake hodnote danger_around uz postava nevystrci hlavu z ukrytu
//#define	RNK_6_RECEIVED_DMG	1.0f		//1.0,  kolikrat se nasobi zasah (hitpointy), ktere dostane
//#define	RNK_6_FORGET_ENEMY	15.0f		//20.0  jak rychle zapomene nepritele od doby, co ho naposledy videl



//
// ++++++++++++++++++++++++++++++++++++++++++ CLASS-specific AI properties +++++++++++++++++++++++++++++++++++++++++
//

//Class values (shooting imprecission)

//Class Soldier
#define	CLS_SOLDIER_SI_XY			0.5f		//0.3
#define	CLS_SOLDIER_SI_Z			0.3f		//0.1
#define	CLS_SOLDIER_SI_CORTIME_MIN	3.0f		//0 (= no corrections)
#define	CLS_SOLDIER_SI_CORTIME_MAX	5.0f		//0

//Class Sapper
#define	CLS_SAPPER_SI_XY			0.4f		//0.3
#define	CLS_SAPPER_SI_Z				0.2f		//0.1
#define	CLS_SAPPER_SI_CORTIME_MIN	3.0f		//0 (= no corrections)
#define	CLS_SAPPER_SI_CORTIME_MAX	5.0f		//0

//Class Rocketeer
#define	CLS_ROCKET_SI_XY			0.3f		//0.3
#define	CLS_ROCKET_SI_Z				0.2f		//0.1
#define	CLS_ROCKET_SI_CORTIME_MIN	0.0f		//0 (= no corrections)
#define	CLS_ROCKET_SI_CORTIME_MAX	0.0f		//0

//Class Commander
#define	CLS_COMMAND_SI_XY			0.3f		//0.3
#define	CLS_COMMAND_SI_Z			0.1f		//0.1
#define	CLS_COMMAND_SI_CORTIME_MIN	1.0f		//0 (= no corrections)
#define	CLS_COMMAND_SI_CORTIME_MAX	2.0f		//0

//Class Machine Gunner
#define	CLS_MACHINE_SI_XY			0.4f		//0.3
#define	CLS_MACHINE_SI_Z			0.2f		//0.1
#define	CLS_MACHINE_SI_CORTIME_MIN	2.0f		//0 (= no corrections)
#define	CLS_MACHINE_SI_CORTIME_MAX	4.0f		//0

//Class Sniper
#define	CLS_SNIPER_SI_XY			0.2f		//0.3
#define	CLS_SNIPER_SI_Z				0.1f		//0.1
#define	CLS_SNIPER_SI_CORTIME_MIN	0.0f		//0 (= no corrections)
#define	CLS_SNIPER_SI_CORTIME_MAX	0.0f		//0




//
// ++++++++++++++++++++++++++++++++++++++++++ Basic definitions ++++++++++++++++++++++++++++++++++++++++++
//

//Difficulties
#define	DIF_EASY		0
#define	DIF_NORMAL		1
#define	DIF_HARD		2
#define	DIF_VIETNAM		3

//Maximum Rank Id
#define	RNK_MAX			6
//Maximum Class Id
#define	CLS_MAX			6
//Random SubClass Id
#define	SUB_RND			0
//Maximum SubClass Id
#define	SUB_MAX			'E'

//Rank IDs (Rank affects: courage, aim time, hitpoints)
#define	RNK_1			1			//VC local - zdravi 50%, normalni reakce, spatne kryti, spatnaamoralka
#define	RNK_2			2			//VC mainforce - zdravi 100%, normalni reakce, normalni kryti, normalni moralka
#define	RNK_3			3			//VC elite - zdravi 150%, rychlejsi reakce, dobre kryti, vysoka moralka
#define	RNK_4			4			//NVA recruit - zdravi 90%, normalni reakce, normalni kryti, normalni moralka
#define	RNK_5			5			//NVA regular - zdravi 120%, rychlejsi reakce, dobre kryti, vysoka moralka
#define	RNK_6			6			//NVA veteran - zdravi  200%, super reakce, dobre kryti, vysoka moralka

//Class IDs (Class affects: shooting precission, weapons, movement)
#define	CLS_SOLDIER		1
#define	CLS_MACHINEGUN	2
#define	CLS_SAPPER		3
#define	CLS_ROCKETEER	4
#define	CLS_COMMANDER	5
#define	CLS_SNIPER		6

//SetRankClass() flags
#define	PL_AI_BLIND				0x00000001			//AI will not react on visual input
#define	PL_AI_DEAF				0x00000002			//-||- sonic input
#define	PL_AI_NOSEND			0x00000004			//don't send info about enemies to other group members
#define	PL_AI_NORECEIVE			0x00000008			//don't receive info about enemies from other group members
#define	PL_AI_NOSHOOT			0x00000010			//disable shooting
#define	PL_AI_HITALLY			0x00000020			//AI will hit allies
#define	PL_AI_INVISIBLE			0x00000040			//player is invisible for enemies
#define	PL_AI_DONTUSEMWP		0x00001000			//sets mwp_search_dist zero value
#define	PL_AI_DONTCHECKCORPSE	0x00002000			//sets deadbodycheck_searchdistance to zero
#define	PL_AI_DONTSETCOMMON		0x10000000			//disables setting of common ai properties. Normally should NOT be used (set this flag only for well-taken reasons)
#define	PL_AI_NOREACTION		(PL_AI_BLIND | PL_AI_DEAF)
#define	PL_AI_SOLITAIRE			(PL_AI_NOSEND | PL_AI_NORECEIVE)





//
// ++++++++++++++++++++++++++++++++++++++++++ Basic definitions ++++++++++++++++++++++++++++++++++++++++++
//


#define	STR_LENGTH		256

//
#define	VC_INI_BASE		"cvp_"
#define	US_INI_BASE		"cup_"

#define	VC_EQP_BASE		"vc"
#define	US_EQP_BASE		"us"

#define	SOL_CLS_BASE	"sol_"
#define	MGU_CLS_BASE	"mgu_"

#define	HEAD_EQP_ROOT	"G\\characters\\_heads\\_eqpini\\"
#define	BODY_EQP_ROOT	"G\\characters\\"

//TMP heads
//"hwm_002"
//"hvm_003"



//pass ptr to this struct to GetPlayerIniEqp() to fill it
typedef struct {
	char	bodyIni[STR_LENGTH];
	char	bodyEqp[STR_LENGTH];
	char	headIni[STR_LENGTH];
	char	headEqp[STR_LENGTH];
	dword	weapon;
} s_PlayerIniEqp;


//character definition
typedef struct {
	dword	rankId;
	char	*iniName;
	char	subId;
} s_charDef;

//weapon definition
typedef struct {
	dword	rankId;
	dword	weapId;
	char	subId;
} s_weapDef;

//head+hat definition
typedef struct {
	dword	rankId;
	char	*headIni;
	char	*hatEqp;
} s_headDef;





#endif	//__AI_H__
