#ifndef MAX_MULTIPLAYER_H //az na konec scriptu !!!!
#define MAX_MULTIPLAYER_H

#include <inc\maxovo\!max_defs.h>
#include <inc\maxovo\!max_support.h>
#include <inc\maxovo\!max_render_hud.h>

#define HUD_MIN_TIME	2.0
#define HUD_MAX_TIME	4.0

#define RESPAWN_AFTER_CONNECT_TIME_LIMIT	15.0

#define ITEM_TYPE_END_TIME				1
#define ITEM_TYPE_END_SCORE				2
#define ITEM_TYPE_END_TEAMSCORE			3
#define ITEM_TYPE_REINFORCEMENTS		4
#define ITEM_TYPE_REINFORCEMENTS_MIN	5
#define ITEM_TYPE_OBJECT_TIMER			6
#define ITEM_TYPE_ROUND_TIME			7
#define ITEM_TYPE_RESPAWN_OBJECT_TIME	8
#define ITEM_TYPE_RESPAWN_VEHICLES_TIME	9
#define ITEM_TYPE_DIFFICULTY			10

#define SYNCH_GAME_PHASE			1
#define SYNCH_GAME_TIMER			2
#define SYNCH_ROUND_TIMER			3
#define SYNCH_REINFORCEMENT			4
#define SYNCH_WINNING_SIDE			5
#define SYNCH_SIDE1					6
#define SYNCH_SIDE2					7
#define SYNCH_SIDES_READY			8

#define SYNCH_OBJECTS_STATUS		100

#define SYNCH_SYNCHRO_OBJECT		200

#define GAME_PHASE_WAITING			1	//ceka se na hrace
#define GAME_PHASE_INITIALIZING		2	//provede se inicializace
#define GAME_PHASE_BEGIN			3	//5 sekund countdown
#define GAME_PHASE_RUNNING			4	//probiha hrani
#define GAME_PHASE_ENDING			5	//vypise se kdo vyhral
#define GAME_PHASE_WHAT_NEXT		6	//zjisti se podle rules co se provede dal
#define GAME_PHASE_NEXTMAP			7	//nextmap? :)
#define GAME_PHASE_RESTARTING		8	//kdyz je hra neaktivni a nekdo se pripoji -> restart

#define GAME_PHASE_BEGIN_LENGHT		 5.0 //jak dloho to bude ve fazi BEGIN
#define GAME_PHASE_RUNNING_LENGHT	 0.5 // za jak dlouho se updatuji game_timer pri nastaveni faze RUNNING
#define GAME_PHASE_ENDING_LENGHT	10.0 //jak dloho to bude ve fazi ENDING
#define GAME_PHASE_RESTARTING_LENGTH 5.0 //jak dloho to bude ve fazi RESTARTING

#define VEHICLE_FLAG_US				"G\\mp\\general\\veh_flag_us.bes"
#define VEHICLE_FLAG_VC				"G\\mp\\general\\veh_flag_vc.bes"
#define VEHICLE_FLAG_DM				"G\\mp\\general\\veh_flag_dm.bes"

#ifndef ICON_PRIMARY_1
#define ICON_PRIMARY_1				"g\\mp\\icons\\map\\ICO_PRIMARY_1.tga"
#endif

#ifndef ICON_PRIMARY_2
#define ICON_PRIMARY_2				"g\\mp\\icons\\map\\ICO_PRIMARY_2.tga"
#endif

#ifndef ICON_SECONDARY_1
#define ICON_SECONDARY_1			"g\\mp\\icons\\map\\ICO_SECONDARY_1.tga"
#endif

#ifndef ICON_SECONDARY_2
#define ICON_SECONDARY_2			"g\\mp\\icons\\map\\ICO_SECONDARY_2.tga"
#endif

#define P_KILL_ENEMY				  1	//implementovano
#define P_KILL_ENEMY_BEST			  1	//implementovano
#define P_KILL_ENEMY_KNIFE			  2	//implementovano
#define P_SUICIDE					 -1	//implementovano
#define P_KILL_ALLY_ACCIDENT		 -1	//implementovano
#define P_KILL_ALLY					 -1	//implementovano
#define P_HEAL_COMMA				  1	//implementovano

#define	P_OBJECTIVE_PRIMARY			  5
#define	P_OBJECTIVE_TEAM			  2

#define P_ACTIVATE					  0 //aktivovani (polozeni bomby) - implementovano
#define P_DEACTIVATE				  0 //deaktivovani (odstraneni bomby) - implementovano

#define MAX_MUL_PLAYERS		64

typedef struct {
	dword	id;
	char	name[MAX_STRING_LEN];
	char	op_name[MAX_STRING_LEN];
	BOOL	is_active;
} s_MAX_MUL_respawn;

typedef struct {
	sc_nod	nod;
	BOOL	is_synchro;
	int		hud_pos;
	BOOL	hud_is_rendering;
	s_MAX_MUL_object_status	*SRV_object_status, *CLN_object_status; // v max_defs.h
} s_MAX_MUL_object;

typedef struct {
	dword pl_handle;
	float time;
}s_respawning; // pro pauzu pred respawnutim

typedef struct {
	dword	pl_handle;
	int		repeat; // kolik dalsi respawnu ma jeste pockat (pro ctf, kdyz ma treba 4s k respawnu, tak se respawne az v dalsim kole)
}s_reinforcements; // pro pauzu pred respawnutim

int			MAX_MUL_num;
sc_player	MAX_MUL_list[MAX_MUL_PLAYERS];

s_MAX_RULE_data	g_MAX_RULE_data;

dword		SRV_best_player;
int			SRV_best_team;
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_coop_player_killed(dword pl_handle) {
	MAX_SUP_send_message_to_group (SC_P_SIDE_ALL, SC_P_GROUP_ALL, SC_ENUMPLS_FL_AI_ONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_RESPAWNEDONLY, MSG_PLAYER_KILLED, MAX_SUP_get_pl_id_from_handle(pl_handle));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_add_points_side(dword side, float points) {
	int			i, num;
	sc_player	tmp_list[MAX_MUL_PLAYERS];
	dword		pl_handle;

	num = SC_EnumPlayers(side, SC_P_GROUP_ALL, tmp_list, MAX_MUL_PLAYERS, SC_ENUMPLS_FL_PC_ONLY);

	for (i=0; i<num; i++) {
		pl_handle = MAX_SUP_get_handle_from_pl_id(tmp_list[i]);
		SC_MP_P_ChangePoint(pl_handle, points);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_is_this_actual_mp_mode(char *mode) {
	if (SC_IsMpGame()) {
		char	*mode_name;
		char	mode_name_local[MAX_STRING_LEN_LONG];

		mode_name = SC_MP_GetModeName();
		strcpy(mode_name_local, mode_name);
		to_upcase(mode_name_local);

		to_upcase(mode);
		if (SC_StringSame(mode_name_local, mode)) return TRUE;
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_MUL_get_actual_mp_mode() {
	if (SC_IsMpGame()) {
		char	*mode_name;
		char	mode_name_local[MAX_STRING_LEN_LONG];

		mode_name = SC_MP_GetModeName();
		strcpy(mode_name_local, mode_name);
		to_upcase(mode_name_local);

		if (SC_StringSame(mode_name_local, GAME_TYPE_DM_NAME))		return GAME_TYPE_DM;
		if (SC_StringSame(mode_name_local, GAME_TYPE_TDM_NAME))		return GAME_TYPE_TDM;
		if (SC_StringSame(mode_name_local, GAME_TYPE_COOP_NAME))	return GAME_TYPE_COOP;
		if (SC_StringSame(mode_name_local, GAME_TYPE_CTF_NAME))		return GAME_TYPE_CTF;
		if (SC_StringSame(mode_name_local, GAME_TYPE_ASSAULT_NAME))	return GAME_TYPE_ASSAULT;
		if (SC_StringSame(mode_name_local, GAME_TYPE_SAD_NAME))		return GAME_TYPE_SAD;
		if (SC_StringSame(mode_name_local, GAME_TYPE_JS_NAME))		return GAME_TYPE_JS;

	}

	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_players_all(dword side, dword *num, sc_player *list) {
	sc_player	tmp_list[MAX_MUL_PLAYERS];

	if ((list == NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, tmp_list, *num, SC_ENUMPLS_FL_PC_ONLY);
	} else if ((list != NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, list, *num, SC_ENUMPLS_FL_PC_ONLY);
	} else {
		SC_message("MAX_MUL_get_players_all() - error");
	}
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_players_respawned(dword side, dword *num, sc_player *list) {
	sc_player	tmp_list[MAX_MUL_PLAYERS];

	if ((list == NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, tmp_list, *num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_PC_ONLY);
	} else if ((list != NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, list, *num, SC_ENUMPLS_FL_PC_ONLY);
	} else {
		SC_message("MAX_MUL_get_players_respawned() - error");
	}
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_players_allive(dword side, dword *num, sc_player *list) {
	sc_player	tmp_list[MAX_MUL_PLAYERS];

	if ((list == NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, tmp_list, *num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_PC_ONLY);
	} else if ((list != NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, list, *num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_PC_ONLY);
	} else {
		SC_message("MAX_MUL_get_players_allive() - error");
	}
	
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_get_players_allive_coma(dword side, dword *num, sc_player *list) {
	sc_player	tmp_list[MAX_MUL_PLAYERS];
	int			i, j;
	s_SC_P_status	status;

	if ((list == NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, tmp_list, *num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_PC_ONLY);
	} else if ((list != NULL) && (*num <= MAX_MUL_PLAYERS)) {
		*num = SC_EnumPlayers(side, SC_P_GROUP_ALL, list, *num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_PC_ONLY);
	} else {
		SC_message("MAX_MUL_get_players_allive() - error");
	}

	for (i=0; i<*num; i++) {
		if (SC_P_GetStatus((list)?list[i]:tmp_list[i], &status)) {
			if (status.health_status != SC_P_HEALTHSTATUS_DEAD) continue;

			/*if (num == 1) {
				num = 0;
			}*/

			/*for (j=i; j<*num-1; j++) {
				if (list)
					list[j] = list[j+1];
				else
					tmp_list[j] = tmp_list[j+1];

				i--;
				*num--;
			}*/

			if (list)
				list[i] = list[(*num) - 1];
			else
				tmp_list[i] = tmp_list[(*num) - 1];

			(*num)--;
			i--;
		}
	}
	
}
//-------------------------------------------------------------------------------------------------------------------------------
int MAX_MUL_get_score_side(dword side) {
	sc_player	list[MAX_MUL_PLAYERS];
	int			num, i;
	int			tmp_score;

	//if (!SC_IsMpClient()) {
		num = MAX_MUL_PLAYERS;
		MAX_MUL_get_players_respawned(side, &num, list);

		tmp_score = 0;
		for (i=0; i<num; i++) {
			tmp_score += SC_MP_P_GetPoints(MAX_SUP_get_handle_from_pl_id(list[i]));
		}

		return tmp_score;
	//} else {
	//	return 0;
	//}
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_group_count(dword side, dword group, dword flags, dword message_p1, dword message_p2) { // podobne MAX_SUP_send_message_to_group(), ale param3 je pocet playeru, kterym se to posila
	int			i, num;
	sc_player	list[MAX_PLAYERS];

	num = SC_EnumPlayers(side, group, list, MAX_PLAYERS, flags);
	for (i=0; i<num; i++)
		SC_P_ScriptMessage(list[i], message_p1, message_p2, num, NULL);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_set_maintask_to_follow_PC(sc_player player, sc_player pc_id) { //neni tu max_target_pl_dist
	s_maintask	maintask;

	CLEAR(maintask);
	maintask.coop_id	= 200;
	maintask.pc_id		= pc_id;
	maintask.flags		= 0;//SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST;
	maintask.step		=  20.0;
	maintask.wait		=  2.0;
	maintask.search_dist	= 10.0;
	maintask.search_z_dist	=  2.0;
	maintask.nextmove_interval = 1.0;
	maintask.nextmove_interval_rand	= 2.0;
	maintask.last_perc_in_group_moves = 100.0;
	MAX_SUP_set_custom_maintask_s_maintask(player, maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_set_maintask_to_follow_PC_building(sc_player player, sc_player pc_id) {
	s_maintask	maintask;

	CLEAR(maintask);
	maintask.coop_id	= 200;
	maintask.pc_id		= pc_id;
	maintask.flags		= 0;//SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST;
	maintask.step		=  20.0;
	maintask.wait		=  2.0;
	maintask.search_dist	= 10.0;
	maintask.search_z_dist	=  2.0;
	maintask.nextmove_interval = 1.0;
	maintask.nextmove_interval_rand	= 2.0;
	maintask.last_perc_in_group_moves = 100.0;
	maintask.max_target_pl_dist	= 3.0;
	MAX_SUP_set_custom_maintask_s_maintask(player, maintask);
}
//-------------------------------------------------------------------------------------------------------------------------------
sc_player MAX_MUL_set_maintask_to_follow_nearest_PC(sc_player player, dword side, dword group, float max_dist) {
	int			i, num;
	sc_player	list[MAX_PLAYERS];

	num = MAX_PLAYERS;	// respawnou se panaci v baraku, ktery tank vyhodi do luftu
	num = SC_EnumPlayers(side, group, list, num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_PC_ONLY);

	if (max_dist <= 0.0)
		MAX_SUP_get_sort_players_dist_player(player, list, num);
	else
		num = MAX_SUP_get_sort_players_dist_player(player, list, num, max_dist);

	if (num == 0) {
		//SC_message("MAX_MUL_set_maintask_to_follow_nearest_PC(side: %d, group: %d, max_dist: %f) - nenasel zadne PC", side, group, max_dist);
		return NULL;
	} else {
		MAX_MUL_set_maintask_to_follow_PC(player, list[0]);
		MAX_SUP_send_message_to_player(player, MSG_PLAYER_FOLLOWING, list[0]);
	}

	return player;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_RULE_sides_ready(s_MAX_RULE_data *MAX_RULE_data) {
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		return FALSE;
	}

	MAX_MUL_num = SC_EnumPlayers(SC_P_SIDE_US, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, 0);
	if (MAX_MUL_num > 0) {
		MAX_MUL_num = SC_EnumPlayers(SC_P_SIDE_VC, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, 0);
		if (MAX_MUL_num > 0) return TRUE;
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_RULE_side_ready(s_MAX_RULE_data *MAX_RULE_data) {
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		return FALSE;
	}

	MAX_MUL_num = SC_EnumPlayers(SC_P_SIDE_US, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, 0);
	if (MAX_MUL_num > 1) {
		return TRUE;
	}

	MAX_MUL_num += SC_EnumPlayers(SC_P_SIDE_VC, SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, 0);
	if (MAX_MUL_num > 1) {
		return TRUE;
	}

	return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_RULE_side_wins_opp_death(s_MAX_RULE_data *MAX_RULE_data) {
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		return FALSE;
	}

	MAX_MUL_num = MAX_MUL_PLAYERS;
	MAX_MUL_num = SC_EnumPlayers(MAX_SUP_get_opp_side(MAX_RULE_data->side), SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_num, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY);

	if (MAX_MUL_num == 0) return TRUE; else return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_RULE_side_wins_opp_death_all(s_MAX_RULE_data *MAX_RULE_data) {
	if (MAX_RULE_data->reinit == TRUE) {
		MAX_RULE_data->reinit = FALSE;
		return FALSE;
	}

	MAX_MUL_num = SC_EnumPlayers(MAX_SUP_get_opp_side(MAX_RULE_data->side), SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, SC_ENUMPLS_FL_NORESPAWNEDONLY|SC_ENUMPLS_FL_AI_ONLY);
	if (MAX_MUL_num > 0) return FALSE;
	MAX_MUL_num = SC_EnumPlayers(MAX_SUP_get_opp_side(MAX_RULE_data->side), SC_P_GROUP_ALL, MAX_MUL_list, MAX_MUL_PLAYERS, SC_ENUMPLS_FL_RESPAWNEDONLY|SC_ENUMPLS_FL_ALIVEONLY|SC_ENUMPLS_FL_AI_ONLY);

	if (MAX_MUL_num == 0) return TRUE; else return FALSE;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_map_init(dword game_type, char *map_name, char *map_transform) {
	s_SC_MP_Map_Init		init_info;
	s_SC_MP_Map_Group		group[10];
	/*s_SC_MP_Map_Item		item;
	s_SC_MP_Map_Objective	objective;*/


	switch(game_type) {
	case GAME_TYPE_DM:
		init_info.user_groups = 0;
		break;
	case GAME_TYPE_TDM:
		init_info.user_groups = 0;
		break;
	case GAME_TYPE_COOP:
		init_info.user_groups = 1;
		break;
	case GAME_TYPE_CTF:
		init_info.user_groups = 0;
		break;
	case GAME_TYPE_ASSAULT:
		init_info.user_groups = 1;
		break;
	case GAME_TYPE_SAD:
		init_info.user_groups = 1;
		break;
	case GAME_TYPE_JS:
		init_info.user_groups = 1;
		break;

	default:
		break;

	}

	//if (init_info.user_groups == 0) return;


	init_info.bitmap_file = map_name;
	init_info.tranform_file = map_transform;

	init_info.user_group = group;

	CLEAR(group);

	if (init_info.user_groups >= 1) {
		group[0].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+1;
		group[0].side_mask = SC_MP_MAP_SIDEMASK_SIDE1 | SC_MP_MAP_SIDEMASK_SIDE2;
		//group[0].text_ansi = "Primary";
		group[0].text_nr = 1651;
	}

	if (init_info.user_groups >= 2) {
		group[1].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+2;
		group[1].side_mask = SC_MP_MAP_SIDEMASK_SIDE1 | SC_MP_MAP_SIDEMASK_SIDE2;
		//group[1].text_ansi = "Secondary";
		group[1].text_nr = 1652;
	}

	/*group[2].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+3;
	group[2].side_mask = SC_MP_MAP_SIDEMASK_SIDE1;
	group[2].text_ansi = "US special";

	group[3].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+4;
	group[3].side_mask = SC_MP_MAP_SIDEMASK_SIDE2;
	group[3].text_ansi = "VC special";

	group[4].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+5;
	group[4].side_mask = SC_MP_MAP_SIDEMASK_SPECTATOR;
	group[4].text_ansi = "Sumary Spectator";

	group[5].id = SC_MP_MAP_GROUP_ID_FIRSTUSER+6;
	group[5].side_mask = SC_MP_MAP_SIDEMASK_SIDE1 | SC_MP_MAP_SIDEMASK_SIDE2 | SC_MP_MAP_SIDEMASK_SPECTATOR;
	group[5].text_ansi = "Spolecne vsichni";*/

	SC_MP_Map_Init(&init_info);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_add_item(char *name, dword group, dword side_mask, char *icon1, char *icon2, dword objective) {
	s_SC_MP_Map_Item		item;
	c_Vector3				vec;

	CLEAR(item);

	SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(name), &vec);

	item.group_id =		group;
	item.side_mask =	side_mask;
	item.world_pos.x =	vec.x;
	item.world_pos.y =	vec.y;
	item.icon =			icon1;
	item.icon2 =		icon2;	
	item.objective_id =	objective;

	return SC_MP_Map_AddItem(&item);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_add_item_primary_custom(char *name, dword side_mask, dword objective, char *icon1, char *icon2) {
	return MAX_MUL_add_item(name, SC_MP_MAP_GROUP_ID_FIRSTUSER+1, side_mask, icon1, icon2, objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_add_item_primary(char *name, dword side_mask, dword objective) {
	return MAX_MUL_add_item(name, SC_MP_MAP_GROUP_ID_FIRSTUSER+1, side_mask, ICON_PRIMARY_1, ICON_PRIMARY_2, objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_add_item_secondary(char *name, dword side_mask, dword objective) {
	return MAX_MUL_add_item(name, SC_MP_MAP_GROUP_ID_FIRSTUSER+2, side_mask, ICON_SECONDARY_1, ICON_SECONDARY_2, objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
dword MAX_MUL_add_item_custom(char *name, dword side_mask, dword objective, char *icon1, char *icon2) {
	return MAX_MUL_add_item(name, SC_MP_MAP_GROUP_ID_FIRSTUSER+3, side_mask, icon1, icon2, objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_add_objective(dword objective_id, dword side_mask, char *text, char *picture) {
	s_SC_MP_Map_Objective	objective;

	CLEAR(objective);

	objective.side_mask =		side_mask;
	objective.objective_id =	objective_id;	
	objective.picture =			picture;
	objective.picture_finished=	picture;
	objective.text_ansi =		text;

	SC_MP_Map_AddObjective(&objective);
}

void MAX_MUL_add_objective(dword objective_id, dword side_mask, int text_nr, char *picture) {
	s_SC_MP_Map_Objective	objective;

	CLEAR(objective);

	objective.side_mask =		side_mask;
	objective.objective_id =	objective_id;	
	objective.picture =			picture;
	objective.picture_finished=	picture;
	objective.text_nr =			text_nr;

	SC_MP_Map_AddObjective(&objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_change_objective(dword objective_id, dword side_mask, int text_nr, char *picture) {
	s_SC_MP_Map_Objective	objective;

	CLEAR(objective);

	objective.side_mask =		side_mask;
	objective.objective_id =	objective_id;	
	objective.picture =			picture;
	objective.picture_finished=	picture;
	objective.text_nr =			text_nr;

	SC_MP_Map_ChangeObjectiveTextsPictures(&objective);
}
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_send_message_to_server_to_object(dword from_pl_handle, sc_nod nod, dword message_p1, dword message_p2) {
	s_SC_NodHandle nod_handle;
	BYTE	data[100];
	int		data_size;
	int		i;

	MAX_SUP_get_handle_from_nod(nod, &nod_handle);

	data[0] = MSG_MP_TO_OBJECT;
	data_size = 1;
	for (i=0; i<12; i++) data[i+data_size] = nod_handle.data[i];
	data_size+= 12;
	for (i=0; i<sizeof(dword); i++) data[i+data_size] = ((BYTE *)(&message_p1))[i];
	data_size+= sizeof(dword);
	for (i=0; i<sizeof(dword); i++) data[i+data_size] = ((BYTE *)(&message_p2))[i];
	data_size+= sizeof(dword);

	SC_MP_MsgToSrv(from_pl_handle, data, data_size);
}*/
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_send_message_to_server_to_object2(dword from_pl_handle, sc_nod master_nod, sc_nod nod, dword message_p1, dword message_p2) {
	s_SC_NodHandle master_nod_handle, nod_handle;
	BYTE	data[100];
	int		data_size;
	int		i;

	MAX_SUP_get_handle_from_nod(master_nod, &master_nod_handle);
	MAX_SUP_get_handle_from_nod(nod, &nod_handle);

	data[0] = MSG_MP_TO_OBJECT2;
	data_size = 1;
	for (i=0; i<12; i++) data[i+data_size] = master_nod_handle.data[i];
	data_size+= 12;
	for (i=0; i<12; i++) data[i+data_size] = nod_handle.data[i];
	data_size+= 12;
	for (i=0; i<sizeof(dword); i++) data[i+data_size] = ((BYTE *)(&message_p1))[i];
	data_size+= sizeof(dword);
	for (i=0; i<sizeof(dword); i++) data[i+data_size] = ((BYTE *)(&message_p2))[i];
	data_size+= sizeof(dword);

	SC_MP_MsgToSrv(from_pl_handle, data, data_size);
}*/
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
/*void MAX_MUL_send_message_to_client_to_object(sc_nod nod, dword message_p1) {
	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)&message_p1, sizeof(dword));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client_to_object(sc_nod nod, dword message_p1, dword message_p2) {
	dword	data[2];

	data[0] = message_p1;
	data[1] = message_p2;

	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3) {
	dword	data[3];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;

	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client_to_object(sc_nod nod, dword message_p1, dword message_p2, dword message_p3, dword message_p4) {
	dword	data[4];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;
	data[3] = message_p4;

	SC_ObjectScriptMessage_NodToCLNs(nod, (void *)data, sizeof(data));
}*/
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client(dword pl_handle, dword message_p1) {
	SC_MP_MsgToCln(pl_handle, (void *)&message_p1, sizeof(dword));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client(dword pl_handle, dword message_p1, dword message_p2) {
	dword	data[2];

	data[0] = message_p1;
	data[1] = message_p2;

	SC_MP_MsgToCln(pl_handle, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client(dword pl_handle, dword message_p1, dword message_p2, dword message_p3) {
	dword	data[3];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;

	SC_MP_MsgToCln(pl_handle, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_client(dword pl_handle, dword message_p1, dword message_p2, dword message_p3, dword message_p4) {
	dword	data[4];

	data[0] = message_p1;
	data[1] = message_p2;
	data[2] = message_p3;
	data[3] = message_p4;

	SC_MP_MsgToCln(pl_handle, (void *)data, sizeof(data));
}
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_send_message_to_clns(dword side, dword msg1) {
	int			i, num;
	sc_player	list[MAX_MUL_PLAYERS];
	dword		tmp_handle;

	num = MAX_MUL_PLAYERS;
	MAX_MUL_get_players_all(side, &num, list);
	for (i=0; i<num; i++) {
		tmp_handle = MAX_SUP_get_handle_from_pl_id(list[i]);
		MAX_MUL_send_message_to_client(tmp_handle, msg1);
	}
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
void MAX_MUL_receive_message(s_SC_ModeScript_info *info) {
	// param1 - dword to_pl_handle
	// param2 - datasize
	// param3 - void* data
	BYTE	*data;
	int		data_size = info->param2;
	int		i, data_pos;

	data = (BYTE *)info->param3;

	info->param1 = 0;
	info->param2 = 0;
	info->param3 = 0;
	info->param4 = 0;

	data_pos = 0;

	for (i=0; i<sizeof(dword); i++) ((BYTE *)(&info->param1))[i] = data[i+data_pos];
	data_pos += i;
	if (data_pos >= data_size) return;
	for (i=0; i<sizeof(dword); i++) ((BYTE *)(&info->param2))[i] = data[i+data_pos];
	data_pos += i;
	if (data_pos >= data_size) return;
	for (i=0; i<sizeof(dword); i++) ((BYTE *)(&info->param3))[i] = data[i+data_pos];
	data_pos += i;
	if (data_pos >= data_size) return;
	for (i=0; i<sizeof(dword); i++) ((BYTE *)(&info->param4))[i] = data[i+data_pos];
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
BOOL MAX_MUL_get_item(dword game_type, dword item_type, dword *data) {
	char	part1[MAX_STRING_LEN];
	char	part2[MAX_STRING_LEN];
	char	full[MAX_STRING_LEN];

	switch(game_type) {
	case GAME_TYPE_DM:
		if (item_type == ITEM_TYPE_REINFORCEMENTS) return FALSE;
		if (item_type == ITEM_TYPE_ROUND_TIME) return FALSE;
		if (item_type == ITEM_TYPE_END_TEAMSCORE) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		sprintf(part1, "dm");
		break;
	case GAME_TYPE_TDM:
		if (item_type == ITEM_TYPE_REINFORCEMENTS) return FALSE;
		if (item_type == ITEM_TYPE_ROUND_TIME) return FALSE;
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		sprintf(part1, "tdm");
		break;
	case GAME_TYPE_COOP:
		if (item_type == ITEM_TYPE_ROUND_TIME) return FALSE;
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_END_TEAMSCORE) return FALSE;
		if (item_type == ITEM_TYPE_RESPAWN_OBJECT_TIME) return FALSE;
		if (item_type == ITEM_TYPE_RESPAWN_VEHICLES_TIME) return FALSE;
		sprintf(part1, "coop");
		break;
	case GAME_TYPE_CTF:
		//if (item_type == ITEM_TYPE_REINFORCEMENTS) return FALSE;
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_ROUND_TIME) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		sprintf(part1, "ctf");
		break;
	case GAME_TYPE_ASSAULT:
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		//if (item_type == ITEM_TYPE_END_TEAMSCORE) return FALSE;
		sprintf(part1, "assault");
		break;
	case GAME_TYPE_SAD:
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		sprintf(part1, "sad");
		break;
	case GAME_TYPE_JS:
		if (item_type == ITEM_TYPE_END_SCORE) return FALSE;
		if (item_type == ITEM_TYPE_DIFFICULTY) return FALSE;
		sprintf(part1, "js");
		break;

	default:
		break;

	}

	switch(item_type) {
	case ITEM_TYPE_END_TIME:
		sprintf(part2, "endrule.time");
		break;

	case ITEM_TYPE_END_SCORE:
		sprintf(part2, "endrule.score");
		break;

	case ITEM_TYPE_END_TEAMSCORE:
		sprintf(part2, "endrule.teamscore");
		break;

	case ITEM_TYPE_REINFORCEMENTS:
		sprintf(part2, "reinforcement");
		break;

	case ITEM_TYPE_REINFORCEMENTS_MIN:
		sprintf(part2, "reinforcement_min");
		break;

	case ITEM_TYPE_OBJECT_TIMER:
		sprintf(part2, "droppedflaglimit");
		break;

	case ITEM_TYPE_ROUND_TIME:
		sprintf(part2, "round.time");
		break;

	case ITEM_TYPE_RESPAWN_OBJECT_TIME: //sudy a spol
		sprintf(part2, "respawn.objects");
		break;

	case ITEM_TYPE_RESPAWN_VEHICLES_TIME:
		sprintf(part2, "respawn.vehicles");
		break;

	case ITEM_TYPE_DIFFICULTY:
		sprintf(part2, "difficulty");
		break;

	default:
		break;
	}

	if (data == NULL) return TRUE; // pokud me zajima pouze jestli je polozka definovana a nezajima me jeji hodnota

	sprintf(full, "%s.%s", part1, part2);
	SC_MP_ModeSettings_GetItem(full, data);

	if ((*data == 0) && ((item_type == ITEM_TYPE_END_TIME) || (item_type == ITEM_TYPE_END_SCORE))) return FALSE;

	//if (*data) return TRUE; else return FALSE;
	return TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------------
#endif //#ifndef MAX_MULTIPLAYER_H