#include <inc/maxovo/!max_defs.h>
#include <inc/maxovo/!max_multiplayer.h>
//#include <inc/maxovo/!max_support.h>

#ifdef RESPAWN_TIMES_IN_MODES_COUNT
	float	local_respawn_timer;
	int		local_mode;
#endif

#ifndef DYNAM_COUNT
	s_SC_NOD_transform	trans;
	BOOL				hidden;
#endif

#ifdef MAX_EXTERN_SCRIPT_H
int ScriptMain_obj_control(s_SC_OBJ_info *info, ...) {
	/*SC_message("zzz");
	SC_message("zzz: %d | %d | %d | %d | %f", (int)info, info->message, info->master_nod, info->nod, info->param4.z);
	return TRUE;*/
#else
int ScriptMain(s_SC_OBJ_info *info) {
#endif
	int		i;

	switch(info->message) {
//------------------------------------------------------------------
	case SC_OBJ_MSG_INIT:
		//info->next_exe_time = -1.0;
#if (ENABLE_IN_MODE_COUNT != RESPAWN_TIMES_IN_MODES_COUNT)
		SC_message("max_multiplayer_object_control.cxx - FATAL ERROR : ENABLE_IN_MODE_COUNT != RESPAWN_TIMES_IN_MODES_COUNT");
#endif
#ifndef DYNAM_COUNT
		hidden = FALSE;
#endif
#ifdef RESPAWN_TIMES_IN_MODES_COUNT
		local_respawn_timer = -1.0;
		local_mode = -1;
#endif

		if (SC_IsMpGame()) {
			char	*mode_name;
			char	mode_name_local[MAX_STRING_LEN_LONG];

			mode_name = SC_MP_GetModeName();
			strcpy(mode_name_local, mode_name);
			to_upcase(mode_name_local);

			for (i=0; i<ENABLE_IN_MODE_COUNT; i++) {
				to_upcase(ENABLE_IN_MODE[i]);
				if (SC_StringSame(mode_name_local, ENABLE_IN_MODE[i])) {
#ifdef RESPAWN_TIMES_IN_MODES_COUNT
					local_mode = i;
#endif
					break;
				}
			}

			if (i >= ENABLE_IN_MODE_COUNT) {
				SC_DUMMY_Set_DoNotRenHier2(info->master_nod, TRUE);
#ifdef DYNAMIC_COUNT
				{
					s_SC_MarokObjState	state;
					sc_nod				nod;

					for (i=0; i<DYNAMIC_COUNT; i++) {
						nod = SC_NOD_Get(info->master_nod, DYNAMIC_OBJ[i]);
						if ((SC_IsMpClient()) && (SC_Marok_IsMpSynchro(nod))) continue;
						SC_Marok_MakeStatic(nod);
						SC_Marok_GetState(nod, &state);
						state.placement.pos.z -= 100.0;
						SC_Marok_SetState(nod, &state);
					}
				}
#else
				hidden = TRUE;
				SC_NOD_GetTransform(info->master_nod, &trans);
				trans.loc.z -= 100.0;
				SC_NOD_SetTransform(info->master_nod, &trans);
				trans.loc.z += 100.0;
#endif
			}
		}
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_RELEASE:
#ifndef DYNAMIC_COUNT //nedefinovano
		if (hidden)
			SC_NOD_SetTransform(info->master_nod, &trans);
#endif

		return TRUE;
//------------------------------------------------------------------
	case SC_OBJ_MSG_JUSTLOADED:
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_USED:
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_HIT:
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_DOTICK:
#ifdef RESPAWN_TIMES_IN_MODES_COUNT
		if (local_respawn_timer >= 0.0) {
			local_respawn_timer -= info->elapsed_time;
			if (local_respawn_timer < 0.0) {
				int	i;

				for (i=0; i<DYNAMIC_COUNT; i++)
					if (!SC_Marok_CanBeRestored(info->master_nod, SC_NOD_Get(info->master_nod, DYNAMIC_OBJ[i]))) break;

				if (i>=DYNAMIC_COUNT)
					SC_ObjectScriptMessage(info->master_nod, MSG_UNI_RESPAWN, 0);
				else
					#ifdef GET_TIME_FROM_INI
					{
						dword	data;
#ifdef IS_VEHICLE
						if (MAX_MUL_get_item(MAX_MUL_get_actual_mp_mode(), ITEM_TYPE_RESPAWN_VEHICLES_TIME, &data))
#else
						if (MAX_MUL_get_item(MAX_MUL_get_actual_mp_mode(), ITEM_TYPE_RESPAWN_OBJECT_TIME, &data))
#endif
							local_respawn_timer = (data==0)?-1.0:(float)data;
					}
					#else
						if ((local_mode >= 0) && (!SC_IsMpClient()))
							local_respawn_timer = RESPAWN_TIMES_IN_MODES[local_mode];
					#endif
			}
		}
#endif
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_DSTR_NETCLIENT:
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_MESSAGE:
		switch (info->param1) {
		case MSG_OBJECT_EXPLODED:
			if (!SC_IsMpGame()) break;

#ifdef RESPAWN_TIMES_IN_MODES_COUNT
	#ifdef GET_TIME_FROM_INI
			{
				dword	data;
#ifdef IS_VEHICLE
				if (MAX_MUL_get_item(MAX_MUL_get_actual_mp_mode(), ITEM_TYPE_RESPAWN_VEHICLES_TIME, &data))
#else
				if (MAX_MUL_get_item(MAX_MUL_get_actual_mp_mode(), ITEM_TYPE_RESPAWN_OBJECT_TIME, &data))
#endif
				local_respawn_timer = (data==0)?-1.0:(float)data;
			}
	#else
			if ((local_mode >= 0) && (!SC_IsMpClient()))
				local_respawn_timer = RESPAWN_TIMES_IN_MODES[local_mode];
	#endif
#endif
			break;

		}
		break;
//------------------------------------------------------------------
	}// switch(info->event_type)

	return FALSE;

}// int ScriptMain(s_OBJ_info *info)
