float	synchro_anim_time[SYNCHRO_OBJECT_COUNT];
float	synchro_update_timer[SYNCHRO_OBJECT_COUNT];

sc_nod	synchro_nod[SYNCHRO_OBJECT_COUNT];

void MAX_MUL_start_synchro(int i) {
	synchro_update_timer[i] = 2.0;
	SC_VEH_StartAnim(synchro_nod[i], synchro_anim[i]);
	synchro_anim_time[i] = SC_VEH_GetAnimCurTime(synchro_nod[i]);
	SC_MP_Synch_SendChanges(SYNCH_SYNCHRO_OBJECT+i, FALSE);
	//SC_MP_Synch_SendChanges(SYNCH_SYNCHRO_OBJECT+i, TRUE);
}

void MAX_MUL_stop_synchro(int i) {
	synchro_update_timer[i] = -1.0;
	SC_VEH_StopAnim(synchro_nod[i]);
	synchro_anim_time[i] = -1.0;
	SC_MP_Synch_SendChanges(SYNCH_SYNCHRO_OBJECT+i, FALSE);
	//SC_MP_Synch_SendChanges(SYNCH_SYNCHRO_OBJECT+i, TRUE);
}

//-------------------------------------------------------------------------------------------------------
int MAX_SYN_synchro_object(s_SC_ModeScript_info *info) {	
	switch(info->event) {
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_INIT:
		{
			int	i;
			for (i=0; i<SYNCHRO_OBJECT_COUNT; i++) {
				synchro_anim_time[i] = -1.0;
				synchro_update_timer[i] = -1.0;
				synchro_nod[i] = SC_NOD_GetNoMessage_Entity(synchro_object[i]);
				SC_MP_Synch_Create(SYNCH_SYNCHRO_OBJECT+i, &synchro_anim_time[i], sizeof(float));
			}
		}
		break;
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_RELEASE:
		{
			int	i;
			for (i=0; i<SYNCHRO_OBJECT_COUNT; i++) 
				SC_MP_Synch_Remove(SYNCH_SYNCHRO_OBJECT+i);
		}
		break;
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_SRV:
		{
			int	i;

			for (i=0; i<SYNCHRO_OBJECT_COUNT; i++) {
				if (MAX_SUP_count_timeout(&synchro_update_timer[i], info->elapsed_time)) {
					synchro_anim_time[i] = SC_VEH_GetAnimCurTime(synchro_nod[i]);
					SC_MP_Synch_SendChanges(SYNCH_SYNCHRO_OBJECT+i, TRUE);
					synchro_update_timer[i] = 2.0;
				}
			}
		}
		break;
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_DOTICK_CLN:
		break;
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_SYNCHCHANGE:
		if (info->param1 >= SYNCH_SYNCHRO_OBJECT) {
			int		i;
			sc_nod	nod;

			i = info->param1-SYNCH_SYNCHRO_OBJECT;
			nod = SC_NOD_GetNoMessage_Entity(synchro_object[i]);

			if (synchro_anim_time[i] >= 0.0) {
				if (!SC_VEH_SetAnimCurTime(nod, synchro_anim_time[i])) {
					SC_VEH_StartAnim(nod, synchro_anim[i]);
					SC_VEH_SetAnimCurTime(nod, synchro_anim_time[i]);
				}
			} else {
				SC_VEH_StopAnim(nod);
			}
		}
		break;
//------------------------------------------------------------------
	case SC_MODESCRIPT_EVENT_LOCALMSG:
		switch(info->param1) {
		case MSG_MUL_START_SYNCHRO:
			{
				int	i;
				for (i=0; i<SYNCHRO_OBJECT_COUNT; i++) {
					if (info->param2 == synchro_nod[i]) {
						MAX_MUL_start_synchro(i);
						break;
					}
				}
			}
			break;

		case MSG_MUL_STOP_SYNCHRO:
			{
				int	i;
				for (i=0; i<SYNCHRO_OBJECT_COUNT; i++) {
					if (info->param2 == synchro_nod[i]) {
						MAX_MUL_stop_synchro(i);
						break;
					}
				}
			}
			break;

		} ////switch(info->param1)
		break;

	} //switch(info->message) {

	return 0;
}