#include <inc/maxovo/!max_defs.h>
#include <inc/maxovo/!max_support.h>

#ifndef CAMERA
sc_nod	uni_anim_nods[PARTS_COUNT];
#else
dword	uni_anim_current_index = 0;
dword	uni_anim_indexes[PARTS_COUNT];
#endif
dword	uni_anim_manm_id;
float	uni_anim_anim_length;

float	uni_anim_g_time;
int		uni_anim_g_i,uni_anim_g_j;

BOOL	uni_anim_make_stop;

#ifdef START_INACTIVE
BOOL	uni_anim_running;
#endif

#ifdef CALLBACK_COUNT
int		uni_anim_g_call_back;
#endif

sc_nod	uni_anim_master_nod;

//s_SC_NOD_transform uni_anim_g_trans;
//s_SC_NOD_transform uni_anim_orig_trans;

#ifndef CAMERA
void init_nodes() {
	for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++) uni_anim_nods[uni_anim_g_i] = NULL;

	for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++) {
		uni_anim_g_j = SC_MANM_GetIndex(uni_anim_manm_id, OBJECT_NAME[uni_anim_g_i]);
		if (uni_anim_nods[uni_anim_g_j] == NULL) {
			uni_anim_nods[uni_anim_g_j] = SC_NOD_Get(uni_anim_master_nod, OBJECT_NAME[uni_anim_g_i]);
		#ifdef MAX_SCRIPT_DEBUG // to je humus :)
		} else {
			sprintf(_debug_tmp, "!max_uni_anim.cxx : SC_OBJ_MSG_INIT - INDEX ERROR - %s", OBJECT_NAME[uni_anim_g_i]);
			SC_Log(3, _debug_tmp);
			SC_message(_debug_tmp);
		#endif
		}
	}
}
#else
void init_cameras() {
	for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++)
		uni_anim_indexes[uni_anim_g_i] = SC_MANM_GetIndex(uni_anim_manm_id, OBJECT_NAME[uni_anim_g_i]);
}
#endif

#ifdef CALL_BACK_TO_MAIN_SCRIPT
	BOOL call_back_to_main_script(s_SC_OBJ_info *info);
#endif

int ScriptMain(s_SC_OBJ_info *info) {

	if ((info->message == SC_OBJ_MSG_INIT) || (info->message == SC_OBJ_MSG_JUSTLOADED)) {
		#ifdef MASTER_OBJECT_LINK
			uni_anim_master_nod = SC_NOD_GetNoMessage_Entity(MASTER_OBJECT_LINK);
		#else
			uni_anim_master_nod = info->master_nod;
		#endif
	}

	#ifdef CALL_BACK_TO_MAIN_SCRIPT
		if (!call_back_to_main_script(info)) return 0;
	#endif

	switch(info->message) {
//------------------------------------------------------------------
		case SC_OBJ_MSG_INIT:
			info->next_exe_time = 0.0;

			#ifndef CAMERA
			{
				sc_nod	tmp_nod;
				for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++) {
					tmp_nod = SC_NOD_Get(uni_anim_master_nod, OBJECT_NAME[uni_anim_g_i]);
					if (MAX_SUP_is_active_destruction(tmp_nod) > 0) SC_Marok_MakeStatic(tmp_nod);
				}
			}
			#endif

			#ifdef CALLBACK_COUNT
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "max_uni_anim.cxx : %s : SC_OBJ_MSG_INIT - CALL_BACK_ID == MSG_MANM_FINISHED -> potreba zmenit", SC_NOD_GetName(uni_anim_master_nod));
				for (uni_anim_g_i=0; uni_anim_g_i<CALLBACK_COUNT; uni_anim_g_i++)
					if (CALL_BACK_ID[uni_anim_g_i] == MSG_MANM_FINISHED) {
						SC_Log(3, _debug_tmp);
						SC_message(_debug_tmp);
					}
			#endif
			#endif

			uni_anim_manm_id = SC_MANM_Create(ANIM_NAME);
			if (!uni_anim_manm_id){
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_INIT - FATAL ERROR, ANIMATION NOT FOUND", SC_NOD_GetName(uni_anim_master_nod));
					SC_Log(3, _debug_tmp);
					SC_message(_debug_tmp);
				#endif
				//stat=20;
				return FALSE;
			}

			#ifdef CALLBACK_COUNT
				uni_anim_g_call_back = 0;
			#endif

			#ifndef CAMERA
				//SC_NOD_GetTransform(uni_anim_master_nod, &uni_anim_g_trans);
				//uni_anim_orig_trans = uni_anim_g_trans;
				#ifdef START_INACTIVE
					uni_anim_running = FALSE;
					info->next_exe_time = -1.0;
				//#else
				//	uni_anim_g_trans.loc.x = 0.0;
				//	uni_anim_g_trans.loc.y = 0.0;
				//	uni_anim_g_trans.loc.z = 0.0;
				//	uni_anim_g_trans.rot.x = 0.0;
				//	uni_anim_g_trans.rot.y = 0.0;
				//	uni_anim_g_trans.rot.z = 0.0;
				//	SC_NOD_SetTransform(uni_anim_master_nod, &uni_anim_g_trans);
				#endif
				init_nodes();
			#else
				uni_anim_current_index = 0;
				init_cameras();
			#endif

			uni_anim_anim_length = SC_MANM_GetLength(uni_anim_manm_id, 0);
			
			uni_anim_make_stop = FALSE;
			uni_anim_g_time = 0.0;

			#ifndef CAMERA
			#ifndef START_INACTIVE
				for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++)
					SC_MANM_SetRelative(uni_anim_manm_id, uni_anim_g_i, uni_anim_nods[uni_anim_g_i], uni_anim_g_time);
			#endif
			#endif

			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_RELEASE:
			//#ifndef CAMERA
			//	SC_NOD_SetTransform(uni_anim_master_nod, &uni_anim_orig_trans);
			//#endif
			SC_MANM_Release(uni_anim_manm_id);
			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_JUSTLOADED:
			uni_anim_manm_id = SC_MANM_Create(ANIM_NAME);

			#ifndef CAMERA
				{
					sc_nod	tmp_nod;
					for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++) {
						tmp_nod = SC_NOD_Get(uni_anim_master_nod, OBJECT_NAME[uni_anim_g_i]);
						if (MAX_SUP_is_active_destruction(tmp_nod) > 0) SC_Marok_MakeStatic(tmp_nod);
					}
				}

				init_nodes();

				#ifdef START_INACTIVE
/*##*/				if (!uni_anim_running) goto skok1;
				#endif

				//SC_NOD_GetTransform(uni_anim_master_nod, &uni_anim_g_trans);
				//uni_anim_g_trans.loc.x = 0.0;
				//uni_anim_g_trans.loc.y = 0.0;
				//uni_anim_g_trans.loc.z = 0.0;
				//uni_anim_g_trans.rot.x = 0.0;
				//uni_anim_g_trans.rot.y = 0.0;
				//uni_anim_g_trans.rot.z = 0.0;
				//SC_NOD_SetTransform(uni_anim_master_nod, &uni_anim_g_trans);

				for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++)
					SC_MANM_SetRelative(uni_anim_manm_id, uni_anim_g_i, uni_anim_nods[uni_anim_g_i], uni_anim_g_time);

			#else
				init_cameras();
			#endif

/*##*/skok1:
			return TRUE;
//------------------------------------------------------------------
		case SC_OBJ_MSG_USED:
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_HIT:
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_DOTICK:
			#ifndef CAMERA
				#ifdef START_INACTIVE
					if (!uni_anim_running) {
						uni_anim_running = TRUE;

						//uni_anim_g_trans.loc.x = 0.0;
						//uni_anim_g_trans.loc.y = 0.0;
						//uni_anim_g_trans.loc.z = 0.0;
						//uni_anim_g_trans.rot.x = 0.0;
						//uni_anim_g_trans.rot.y = 0.0;
						//uni_anim_g_trans.rot.z = 0.0;
						//SC_NOD_SetTransform(uni_anim_master_nod, &uni_anim_g_trans);
					}
				#endif
			#endif

			if (uni_anim_make_stop) {
				info->next_exe_time = -1.0;
				uni_anim_make_stop = FALSE;
			}
			info->next_exe_time = 0.0;
#ifdef ANIM_TIME_MULT
			uni_anim_g_time += info->elapsed_time * ANIM_TIME_MULT;
#else
			uni_anim_g_time += info->elapsed_time;
#endif
			#ifdef CALLBACK_COUNT
				if ( (uni_anim_g_call_back < CALLBACK_COUNT) && (uni_anim_g_time >= CALL_BACK_TIME[uni_anim_g_call_back]) ) {
					SC_LevelScriptMsg(MSG_MANM_CALL_BACK, CALL_BACK_ID[uni_anim_g_call_back], uni_anim_master_nod, NULL);
					uni_anim_g_call_back++;
				}
			#endif

			#ifndef CAMERA
				for (uni_anim_g_i=0; uni_anim_g_i<PARTS_COUNT; uni_anim_g_i++)
					SC_MANM_SetRelative(uni_anim_manm_id, uni_anim_g_i, uni_anim_nods[uni_anim_g_i], uni_anim_g_time);

			#else
				SC_MANM_Camera_Set(uni_anim_manm_id, uni_anim_indexes[uni_anim_current_index], uni_anim_g_time);
			#endif

			if (uni_anim_g_time > uni_anim_anim_length) {
				SC_LevelScriptMsg(MSG_MANM_FINISHED, 0, info->master_nod, NULL);

			#ifdef LOOPED
				uni_anim_g_time = 0.0;
			#ifdef WAIT
				info->next_exe_time = WAIT;
			#endif // WAIT
			#else  // LOOPED
				info->next_exe_time = -1.0;
			#endif // LOOPED
			}
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_DSTR_NETCLIENT:
			break;
//------------------------------------------------------------------
		case SC_OBJ_MSG_MESSAGE:
			switch(info->param1) {
			case MSG_MANM_STOP:
				#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_STOP] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				if (info->param2 == 0) {
					info->next_exe_time = -1.0;
				} else {
					uni_anim_make_stop = TRUE;
					info->next_exe_time = /*(float)*/info->param2;
				}
				break;

			case MSG_MANM_RESUME:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_RESUME] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				info->next_exe_time = /*(float)*/info->param2;
				break;

			case MSG_MANM_CHANGE_INDEX:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_CHANGE_INDEX] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				#ifdef CAMERA
					uni_anim_current_index = info->param2;
				#else
					SC_message("!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_CHANGE_INDEX] pro objekt!!! - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
				#endif
				break;

			case MSG_MANM_CHANGE_CALLBACK:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_CHANGE_CALLBACK] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif

				#ifdef CALLBACK_COUNT
				for (uni_anim_g_i=0; uni_anim_g_i<CALLBACK_COUNT; uni_anim_g_i++)
					if (CALL_BACK_ID[uni_anim_g_i] == info->param2) {
						uni_anim_g_call_back = uni_anim_g_i;
						break;
					}

				#endif
				break;

			case MSG_MANM_RESTART:
				#ifdef MAX_SCRIPT_DEBUG
					sprintf(_debug_tmp, "!max_uni_anim.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_MANM_CHANGE_INDEX] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
					SC_Log(3, _debug_tmp);
				#endif
				info->next_exe_time = 0.0;
				uni_anim_g_time = 0.0;
				uni_anim_make_stop = FALSE;
				break;

			} // switch(info->param1)
			break;
//------------------------------------------------------------------
	}// switch(info->event_type)

	return FALSE;

}// int ScriptMain(s_OBJ_info *info)
