//#include <inc/maxovo/!max_defs.h>
#include <inc/maxovo/!max_support.h>
#include <inc/maxovo/!max_gameplay.h>
#include <inc/sc_interdef.h>

#define MAX_DIST_PLAYER_FROM_C4		100.0f

//BOOL	IS_MP_CLIENT;
//BOOL	IS_MP_GAME;

float	update_timer;

dword	pl_handle_placer;
dword	old_c4_state;
float	time_out;

BOOL	this_client_disabled;

sc_nod		C4_nod;
float		C4_time_tick;
c_Vector3	C4_pos;
BOOL		C4_rendering = FALSE;

void c4_sound_tick(float elapsed_time, s_MAX_MUL_object_status *object_status) {
	if ((C4_nod) && (!C4_rendering)) {
		MAX_SUP_show_nod(C4_nod);
		C4_rendering = TRUE;
	}
	if (MAX_SUP_count_timeout(&C4_time_tick, elapsed_time)) {
		C4_time_tick = (object_status->timer > 10.0)?1.0:0.5;
		SC_SND_PlaySound3D(499, &C4_pos);
		if (C4_nod) {
			s_SC_FlareInfo flare_info;

			CLEAR(flare_info);

			flare_info.live_time = C4_time_tick/2.0;
			flare_info.light_radius = 1.0;

			flare_info.nod = C4_nod;

			flare_info.flare_type = 4;

			flare_info.light_r = 1.0;
			flare_info.light_g = 0.0;
			flare_info.light_b = 0.0;

			flare_info.light_ConstF = 0.1;
			flare_info.light_LinearF = 1.0;

			SC_Flare_Create(&flare_info);
			//SC_CreatePtc_Ext(73, C4_nod, 0.0, 0.0, 0.2, 5.0);
		}
	}
}
//-------------------------------------------------------------------------------------------------------
void send_message_to_c4(sc_player player) {
	s_C4_UseMsg	c4;

	CLEAR(c4);
	c4.id = C4_MSGDW_ID;

	SC_P_SendWeapScriptMsg(player, WEAP_O_C4,(void*)&c4, sizeof(s_C4_UseMsg));
}
//-------------------------------------------------------------------------------------------------------
void do_explosion_c4(sc_nod nod, dword author_handle) {
	s_SC_Expl_CreateInfo expl_info;

	CLEAR(expl_info);
	expl_info.author_handle = author_handle;
	SC_NOD_GetWorldPos(nod, &expl_info.sph.pos);

	MAX_UNI_set_explosion_force(&expl_info, EXPLOSION_C4);

	expl_info.ptc_id = 195;

	SC_Explosion_Make(&expl_info);
	MAX_SUP_send_message_to_object(nod, MSG_UNI_DESTR_ADD_HP, 1000);
}
//-------------------------------------------------------------------------------------------------------
void reset_c4(sc_nod master_nod, s_MAX_MUL_object_status *object_status) {
	if (this_client_disabled)
		MAX_SUP_enable_player();

	if (!IS_MP_CLIENT) {
		if (object_status->state == STATE_PLACING) {
			object_status->timer = -1.0;
			object_status->pl_handle = 0;
			object_status->state = STATE_INIT;

			MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_INIT, master_nod, 0);
		} else if (object_status->state == STATE_DEFUSING) {
			object_status->state = STATE_ACTIVE;

			MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_ACTIVE, master_nod, 0);
		}
		object_status->update = TRUE;
	}
	
	if (IS_MP_GAME) update_timer = -1.0;
}
//-------------------------------------------------------------------------------------------------------
/*void increase_c4_count(sc_player player) {
	int count;
	count = SC_AMMO_Get(player, 36);

	if (count <= 0) {
		int	i;
		dword	weapons[20];
		int		weap_count;

		weap_count = SC_P_GetWeapons(info->param1, weapons, 20);
		for (i=0; i<weap_count; i++)
			if (weapons[i] == WEAP_O_C4)
				break;

		if (i>=weap_count) {
			SC_AMMO_Set(player, 36, count + 1);
		} else {
			weapons[weap_count] = WEAP_O_C4;
			SC_P_SetWeapons(player, weapons, weap_count, );
		}
	}
	else
		SC_AMMO_Set(player, 36, count + 1);
}*/
//-------------------------------------------------------------------------------------------------------
/*void decrease_c4_count(sc_player player) {
	int count;
	count = SC_AMMO_Get(player, 36);

	if (count == 1)
		SC_Wea
	else
		SC_AMMO_Set(player, 36, count - 1);
}*/
//-------------------------------------------------------------------------------------------------------
#ifdef MAX_EXTERN_SCRIPT_H
int ScriptMain_c4(s_SC_OBJ_info *info, ...) {
	s_MAX_MUL_object_status *object_status;

	object_status = (s_MAX_MUL_object_status *)*(&info-1);
#else
int ScriptMain(s_SC_OBJ_info *info) {
	s_MAX_MUL_object_status	tmp_object_status;
	s_MAX_MUL_object_status *object_status = &tmp_object_status;
#endif

	switch(info->message) {
//------------------------------------------------------------------
	case SC_OBJ_MSG_INIT:
		//SC_message("%d, %d | %d | %d", &info, object_status, &info-1);
		//SC_message("%f", object_status->timer);
		//SC_FPV_SetUserDefAnim(WEAP_O_C4, 1, "G\\Weapons\\c4\\fpvanim\\use.stg", "G\\Weapons\\c4\\fpvanim\\use_prone.stg", NULL);
		//SC_FPV_SetUserDefAnim(WEAP_O_C4, 2, "G\\Weapons\\c4\\fpvanim\\take_prone.stg", "G\\Weapons\\c4\\fpvanim\\take_prone.stg", NULL);

		object_status->timer = -1.0;
		object_status->state = STATE_INIT;
		object_status->pl_handle = 0;

		update_timer = -1.0;
		time_out = -1.0;
		old_c4_state = object_status->state;

		IS_MP_CLIENT = SC_IsMpClient();
		IS_MP_GAME   = SC_IsMpGame();

		C4_rendering = FALSE;

		C4_nod = SC_NOD_GetNoMessage(info->master_nod, "C4_nod");
		//C4_nod = SC_NOD_Get(info->master_nod, MASTER_NAME[0]);
		if (C4_nod) {
			SC_NOD_GetWorldPos(C4_nod, &C4_pos);
			MAX_SUP_hide_nod(C4_nod);
		} else {
			SC_NOD_GetWorldPos(SC_NOD_Get(info->master_nod, MASTER_NAME[0]), &C4_pos);
		}

		this_client_disabled = FALSE;
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_RELEASE:
		break;

	case SC_OBJ_MSG_JUSTLOADED:
		IS_MP_CLIENT = SC_IsMpClient();
		IS_MP_GAME   = SC_IsMpGame();

		C4_nod = SC_NOD_GetNoMessage(info->master_nod, "c4_nod");
		if (C4_nod)
			SC_NOD_GetWorldPos(C4_nod, &C4_pos);
		else
			SC_NOD_GetWorldPos(SC_NOD_Get(info->master_nod, MASTER_NAME[0]), &C4_pos);

		//SC_FPV_SetUserDefAnim(WEAP_O_C4, 1, "G\\Weapons\\c4\\fpvanim\\use.stg", "G\\Weapons\\c4\\fpvanim\\use_prone.stg", NULL);
		//SC_FPV_SetUserDefAnim(WEAP_O_C4, 2, "G\\Weapons\\c4\\fpvanim\\take_prone.stg", "G\\Weapons\\c4\\fpvanim\\take_prone.stg", NULL);

		update_timer = -1.0; // muze nastat pouze v SINGLE GAME -> neni treba updatovat status na serveru
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_USED:
		if (!IS_MP_GAME) {
			SC_P_SetSelectedWeapon(info->param1, WEAP_O_C4, TRUE);
		}
		if ((object_status->timer < 0.0) && ((object_status->state == STATE_INIT)||(object_status->state == STATE_DEFUSED))) { // provede se vzdy(single i MP)
			send_message_to_c4(info->param1);
		}

		if (!IS_MP_GAME) {
			if ((object_status->timer < 0.0) && ((object_status->state == STATE_INIT)||(object_status->state == STATE_DEFUSED))) {
				//if (info->param1) time_out = SC_P_Play3pvAnim(info->param1, ANIM_PLACING_3PV); // v MP je cas od 3PV, v single to je od FPV
				time_out = 3.0;

				object_status->state = STATE_PLACING;
				object_status->pl_handle = MAX_SUP_get_handle_from_pl_id(info->param1);
				object_status->update = TRUE;

				pl_handle_placer = object_status->pl_handle;

				MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_PLACING, info->master_nod, 0);

				//SC_FPV_SetAction(info->param1, SC_FPV_ACTION_USERDEF1, 0);
				//decrease_c4_count(info->param1);
			}

			if ((object_status->timer > 0.0) && (object_status->state == STATE_ACTIVE)) {
				//if (info->param1) time_out = SC_P_Play3pvAnim(info->param1, ANIM_DEFUSING_3PV); // v MP je cas od 3PV, v single to je od FPV
				time_out = 3.0;

				object_status->state = STATE_DEFUSING;
				object_status->pl_handle = MAX_SUP_get_handle_from_pl_id(info->param1);
				object_status->update = TRUE;

				SC_FPV_SetAction(info->param1, SC_FPV_ACTION_USERDEF2, 0);

				MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_DEFUSING, info->master_nod, 0);
				//increase_c4_count(info->param1);
			} else {
				/*if (((old_c4_state == STATE_INIT)||(old_c4_state == STATE_DEFUSED)) && (object_status->state == STATE_PLACING)) {
					MAX_SUP_disable_total_player();
					this_client_disabled = TRUE;
				}*/   // dela se to ve weap scriptu !!!!!!!!!!!!!!!!!!!

				if ((old_c4_state == STATE_ACTIVE) && (object_status->state == STATE_DEFUSING)) {
					MAX_SUP_disable_total_player();
					this_client_disabled = TRUE;
				}

			}
		}
		
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_VALIDATE_USE:
		// param1 is sc_player which wants to use it
		// param2 - return value, TRUE means enable, FALSE means disable, default is TRUE ( is set when this msg is called )
#ifdef NO_DEFUSE
		if (object_status->state == STATE_ACTIVE) {
			info->param2 = FALSE;
			return TRUE;
		}
#endif
		info->param3 = 28;
		if (IS_MP_GAME)	{
			if ((object_status->timer < 0.0) && ((object_status->state == STATE_INIT)||(object_status->state == STATE_DEFUSED)))
				if (SC_P_GetSelectedWeapon(info->param1) != WEAP_O_C4) info->param2 = FALSE;

		} else {
			dword	weapons[10];
			int		i, weap_count;
			weap_count = SC_P_GetWeapons(info->param1, weapons, 10);

			for (i=0; i<weap_count; i++) {
				if (weapons[i] == WEAP_O_C4) {
					info->param2 = TRUE;
					return TRUE;
				}
			}
			info->param2 = FALSE;
		}
		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_DOTICK:

		info->next_exe_time = 0.1;

		if (MAX_SUP_count_timeout(&time_out, info->elapsed_time)) {
			switch (object_status->state) {
			case STATE_INIT: // v pripade, ze by klient neco prosvihl ... a tady hlavne, kdyz ho nekdo zabije pri pokladani
				if (this_client_disabled)
					MAX_SUP_enable_player();

				break;

			case STATE_PLACING: // sem by se teoreticky klient nemel nikdy dostat, ale ...
				//podminka jestli neni mrtvy a je v nejkakem rozumnem okoli
				{
					s_SC_P_status	status;

					if ( (object_status->pl_handle > 0) && (SC_P_GetStatus(MAX_SUP_get_pl_id_from_handle(object_status->pl_handle), &status)) ) {
						if (status.hp <= 0.0) {
							reset_c4(info->master_nod, object_status);
							return FALSE;
						} else {
							c_Vector3	c4_pos;
							SC_NOD_GetWorldPos(info->master_nod, &c4_pos);

							if (SC_2VectorsDist(&status.pos, &c4_pos) > MAX_DIST_PLAYER_FROM_C4) {
								reset_c4(info->master_nod, object_status);
								return FALSE;
							}
						}
					} else {
						reset_c4(info->master_nod, object_status);
						return FALSE;
					}
				}

				if (!IS_MP_CLIENT) {
#ifdef C4_TIMER
					object_status->timer = C4_TIMER;
#else
					object_status->timer = 30.0;
#endif
					object_status->state = STATE_ACTIVE;
					object_status->side  = MAX_SUP_get_opp_side(object_status->side);
					object_status->update = TRUE;
					if (IS_MP_GAME) update_timer = 5.0;

					MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_ACTIVE, info->master_nod, 0);
				}
				break;

			case STATE_ACTIVE:
				//c4_sound_tick(info->elapsed_time, object_status);
				if (this_client_disabled)// v pripade, ze by klient neco prosvihl ...
					MAX_SUP_enable_player();

				break;

			case STATE_DEFUSING:
				//c4_sound_tick(info->elapsed_time, object_status);
				{
					s_SC_P_status	status;

					if ( (object_status->pl_handle > 0) && (SC_P_GetStatus(MAX_SUP_get_pl_id_from_handle(object_status->pl_handle), &status)) ) {
						if (status.hp <= 0.0) {
							reset_c4(info->master_nod, object_status);
							return FALSE;
						} else {
							c_Vector3	c4_pos;
							SC_NOD_GetWorldPos(info->master_nod, &c4_pos);
							
							if (SC_2VectorsDist(&status.pos, &c4_pos) > MAX_DIST_PLAYER_FROM_C4) {
								reset_c4(info->master_nod, object_status);
								return FALSE;
							}
						}
					} else {
						reset_c4(info->master_nod, object_status);
						return FALSE;
					}
				}

				if (!IS_MP_CLIENT) {
					object_status->timer = -1.0;
					object_status->state = STATE_DEFUSED;
					object_status->side  = MAX_SUP_get_opp_side(object_status->side);
					object_status->update = TRUE;
					if (IS_MP_GAME) update_timer = -1.0;

					MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_DEFUSED, info->master_nod, 0);
				}
				break;
			}

		}

		if (old_c4_state != object_status->state) {
			if (((old_c4_state == STATE_INIT)||(old_c4_state == STATE_DEFUSED)) && (object_status->state == STATE_PLACING)) {
				/*sc_player	player_id;

				player_id = SC_PC_Get();

				if (MAX_SUP_get_handle_from_pl_id(player_id) == object_status->pl_handle) {
					MAX_SUP_disable_total_player();
					this_client_disabled = TRUE;
				} */
				
				if ((object_status->pl_handle) && (IS_MP_CLIENT))
					time_out = 3.0;
					//time_out = SC_P_Play3pvAnim(MAX_SUP_get_pl_id_from_handle(object_status->pl_handle), ANIM_PLACING_3PV) + 1.0;

				//dela script zbrane (c4)
			}

			if ((old_c4_state == STATE_PLACING) && (object_status->state == STATE_ACTIVE)) {
				if (this_client_disabled)
					MAX_SUP_enable_player();

				time_out = -1.0;
			}

			if ((old_c4_state == STATE_ACTIVE) && (object_status->state == STATE_DEFUSING)) {
				sc_player	player_id;

				player_id = SC_PC_Get();

				if (MAX_SUP_get_handle_from_pl_id(player_id) == object_status->pl_handle) {
					MAX_SUP_disable_total_player();
					this_client_disabled = TRUE;
				} 
				
				if ((object_status->pl_handle) && (IS_MP_CLIENT))
					time_out = 3.0;
					//time_out = SC_P_Play3pvAnim(MAX_SUP_get_pl_id_from_handle(object_status->pl_handle), ANIM_DEFUSING_3PV) + 1.0;
			}

			if ((old_c4_state == STATE_DEFUSING) && (object_status->state != STATE_DEFUSING)) {
				if (this_client_disabled)
					MAX_SUP_enable_player();

				time_out = -1.0;
			}

			old_c4_state = object_status->state;
		}

		if ( (C4_nod) && (C4_rendering) && ( (object_status->state == STATE_INIT)||(object_status->state == STATE_DEFUSED)||(object_status->state == STATE_DESTROYED) ) ) {
			MAX_SUP_hide_nod(C4_nod);
			C4_rendering = FALSE;
		}

		if (object_status->timer >= 0.0) {
			object_status->timer -= info->elapsed_time;

			if ( (object_status->state == STATE_ACTIVE) || (object_status->state == STATE_DEFUSING) ) {
				c4_sound_tick(info->elapsed_time, object_status);
			}

			if ((IS_MP_GAME) && (IS_MP_CLIENT)) return 0; // na klientech se bude pouze odecitat lokalni timer

			if (object_status->state == STATE_DESTROYED) {  //uz to nekdo znicil
				object_status->timer = -1.0;
				object_status->update = TRUE;
				update_timer = -1.0;
				return FALSE;
			}
			if (object_status->timer < 0.0) {
				object_status->state = STATE_DESTROYED;
				//object_status->pl_handle = pl_handle_placer;
				do_explosion_c4(info->master_nod, pl_handle_placer);
				object_status->update = TRUE;
				update_timer = -1.0;

				MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_DESTROYED, info->master_nod, 0);
				return 1;
			}
			//SC_message("timer af");
		}

		if (!SC_IsMpGame()) {
			if (object_status->state == STATE_ACTIVE) {
				ushort	tmp_ustr[MAX_STRING_LEN_LONG*2];
				ushort	help[MAX_STRING_LEN_LONG*2];

				swprintf(tmp_ustr, SC_AnsiToUni("%02d:%02d", help), (dword)(object_status->timer/60.0f),((dword)object_status->timer)%60);

				SC_HUD_SetLeftTopIcon(0, HUD_ICON_C4, tmp_ustr);
			}
			if (object_status->state == STATE_DESTROYED) {
				SC_HUD_SetLeftTopIcon(0, SC_HUD_LEFTTOP_DISABLED, NULL);
				object_status->state = 999;
			}
		}

		if ((IS_MP_GAME) && (IS_MP_CLIENT)) return 0; // na klientech se to dal nesmi dostat

		if (update_timer >= 0.0) {
			update_timer -= info->elapsed_time;
			if (update_timer < 0.0) {
				object_status->update = TRUE;
				update_timer = 5.0;
			}
		}

		break;
//------------------------------------------------------------------
	case SC_OBJ_MSG_FROMCLNNOD:
	case SC_OBJ_MSG_FROMSRVNOD:
		{
		int		i;
			dword	*data;
			dword	data_size = info->param2;

			data = (dword *)info->param1;

			info->param1 = 0;
			info->param2 = 0;
			info->param3 = 0;
			CLEAR(info->param4);

			if (data_size >=  4) info->param1 = data[0];
			if (data_size >=  8) info->param2 = data[1];
			if (data_size >= 12) info->param3 = data[2];

			info->message = SC_OBJ_MSG_MESSAGE;
		}
	case SC_OBJ_MSG_MESSAGE:
		switch(info->param1) {
		case MSG_UNI_DESTR_USE:
		case MSG_UNI_DESTR_USE_MP:
			#ifdef MAX_SCRIPT_DEBUG
				sprintf(_debug_tmp, "!max_uni_c4.cxx : %s : SC_OBJ_MSG_MESSAGE[MSG_UNI_DESTR_USE] - param1: %d | param2: %d | nod: %s", SC_NOD_GetName(info->master_nod), info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0);
				SC_Log(3, _debug_tmp);
			#endif
			{
				dword		glob_side;
				sc_player	player;

				if (info->param1 == MSG_UNI_DESTR_USE_MP)
					player = MAX_SUP_get_pl_id_from_handle(info->param2);
				else
					player = info->param2;

				SC_P_GetSideGroupMemberId(player, &glob_side, NULL, NULL);

				if ((object_status->side != SC_P_SIDE_ALL) && (object_status->side != glob_side)) {
					return FALSE;
				}
			

				if ((object_status->timer < 0.0) && ((object_status->state == STATE_INIT)||(object_status->state == STATE_DEFUSED))) {

					//if (info->param2) time_out = SC_P_Play3pvAnim(MAX_SUP_get_pl_id_from_handle(info->param2), ANIM_PLACING_3PV);
					time_out = 3.0;

					object_status->state = STATE_PLACING;
					object_status->pl_handle = info->param2;
					object_status->update = TRUE;

					pl_handle_placer = object_status->pl_handle;

					MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_PLACING, info->master_nod, 0);

					//send_message_to_c4(player);
				}

				if ((object_status->timer > 0.0) && (object_status->state == STATE_ACTIVE)) {
					if (SC_PC_Get() == player) //jsem to ja kdo to poklada -> prehraji FPV animace
						SC_FPV_SetAction(player, SC_FPV_ACTION_USERDEF2, 0);

					if (info->param2) time_out = SC_P_Play3pvAnim(MAX_SUP_get_pl_id_from_handle(info->param2), ANIM_DEFUSING_3PV);
					//time_out = 3.0;

					object_status->state = STATE_DEFUSING;
					object_status->pl_handle = info->param2;
					object_status->update = TRUE;

					MAX_SUP_send_message_to_level(MSG_UNI_C4, STATE_DEFUSING, info->master_nod, 0);
				}
			}
			break;

		} //switch(info->param1) {
		
		break;
	} //switch(info->message) {

	return 0;
}