float	PL_PENDL_time		= 0.1f;
BOOL	PL_PENDL_bDead		= TRUE;
BOOL	PL_PENDL_bEnabled	= TRUE;
BOOL	PL_PENDL_bBlocked	= FALSE;
int		PL_PENDL_current_point = 0;

#ifdef MAX_SCRIPT_DEBUG
dword	PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id;
#endif

#ifdef PENDL_RETRY_AFTER_FIGHT
float	PL_PENDL_retry_after_fight;
s_SC_P_AI_status	PL_PENDL_status;
#endif

void define_pendl();

void PL_PENDL_set(int i) {	//index maintasku v poli

	if (i >= PENDL_POINTS) {
		#ifdef MAX_SCRIPT_DEBUG
			sprintf(_debug_tmp, "pl_pendl.cxx : PL_PENDL_set(%d) - spatny index | s/g/m: %d/%d/%d", i, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
			SC_Log(3, _debug_tmp);
			SC_message(_debug_tmp);
		#endif
		return;
	}

	PL_PENDL_current_point = i;
	PL_PENDL_time = pendl_points[PL_PENDL_current_point].wait;
	PL_PENDL_bBlocked = TRUE;
}

void PL_PENDL_next() {	//index maintasku v poli

	if (PL_PENDL_current_point < PENDL_POINTS-1) 
		PL_PENDL_current_point++;
	else if ((PL_PENDL_current_point >= PENDL_POINTS-1) && (PENDL_LOOPED))
		PL_PENDL_current_point = 0;
	else {
		#ifdef MAX_SCRIPT_DEBUG
			sprintf(_debug_tmp, "pl_pendl.cxx : PL_PENDL_next() - uz zadny next neni | s/g/m: %d/%d/%d", PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
			SC_Log(3, _debug_tmp);
			SC_message(_debug_tmp);
		#endif
		return;
	}

	//PL_PENDL_current_point = i;
	PL_PENDL_time = pendl_points[PL_PENDL_current_point].wait;
	PL_PENDL_bBlocked = TRUE;
}

void PL_PENDL_restart() {
	define_pendl();
	PL_PENDL_time = 0.1f;
	PL_PENDL_current_point = 0;
}

void PL_PENDL_enable() {
	PL_PENDL_bEnabled = TRUE;
	PL_PENDL_time = pendl_points[PL_PENDL_current_point].wait;
}

void PL_PENDL_disable() {
	PL_PENDL_bEnabled = FALSE;
}

BOOL PL_PENDL_is_enabled() {
	return PL_PENDL_bEnabled;
}

int PL_PENDL(s_SC_Pscript_info *info) {

	switch(info->message) {

		case SC_PLSCR_MSG_SCRIPT_INIT:
			define_pendl();
			PL_PENDL_time			= 0.1;
			PL_PENDL_bDead			= TRUE;
			PL_PENDL_bEnabled		= TRUE;
			PL_PENDL_current_point	= 0;
			PL_PENDL_bBlocked		= FALSE;

			#ifdef PENDL_RETRY_AFTER_FIGHT
				PL_PENDL_retry_after_fight = -1.0;
			#endif

			break;

		case SC_PLSCR_MSG_JUSTLOADED:
			define_pendl();
			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:
			break;

		case SC_PLSCR_MSG_PL_CREATED:
			break;

		case SC_PLSCR_MSG_PL_RELEASED:
			PL_PENDL_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
			PL_PENDL_time	= pendl_points[0].wait;
			PL_PENDL_bDead	= FALSE;
			PL_PENDL_current_point = 0;
			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			PL_PENDL_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_AI_SCRIPTMODE_EVENT: // zpusobeno nejakym nebezpecim (granat)
			#ifdef PENDL_RETRY_AFTER_FIGHT
				switch(info->param1) {
				case SC_PL_AI_SCRIPTMODE_EVENT_MOVINGPERIL:
					if (PL_PENDL_is_enabled()) {
						PL_PENDL_disable();
						#ifdef PENDL_MOVE_STYLE_WALK
							MAX_SUP_set_move_phase_run(info->player);
						#endif
						SC_P_Ai_StopMoving(info->player);
						if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
						PL_PENDL_retry_after_fight = PENDL_RETRY_AFTER_FIGHT;
						return 1;
					} //if
					break;
				} // switch
			#endif
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:

			if (PL_PENDL_bDead) return 0;

			#ifdef PENDL_RETRY_AFTER_FIGHT
				SC_P_Ai_GetStatus(info->player, &PL_PENDL_status);
				if ((PL_PENDL_is_enabled()) && ((PL_PENDL_status.dangers_all > 0) || (PL_PENDL_status.enemies > 0) || (PL_PENDL_status.impulses > 0))) {
					PL_PENDL_disable();
					#ifdef PENDL_MOVE_STYLE_WALK
						MAX_SUP_set_move_phase_run(info->player);
					#endif
					SC_P_Ai_StopMoving(info->player);
					if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
					PL_PENDL_retry_after_fight = PENDL_RETRY_AFTER_FIGHT;
					return 1;
				}

				if (PL_PENDL_retry_after_fight >= 0.0) {
					PL_PENDL_retry_after_fight -= info->elapsed_time;
					if (PL_PENDL_retry_after_fight < 0.0) {
						SC_P_Ai_GetStatus(info->player, &PL_PENDL_status);
						//if (SC_P_ai_getmaintask) return
						if ((PL_PENDL_status.dangers_all == 0) && (PL_PENDL_status.enemies == 0) && (PL_PENDL_status.impulses == 0)) {
							PL_PENDL_enable();
						} else {
							PL_PENDL_retry_after_fight = PENDL_RETRY_AFTER_FIGHT;
							return 1;
						}
					}
				}
			#endif

			if (PL_PENDL_bEnabled == FALSE) return 0;

			if (PL_PENDL_time >= 0.0) {
				PL_PENDL_time -= info->elapsed_time;
				if (PL_PENDL_time < 0.0) {
					#ifdef PENDL_MOVE_STYLE_WALK
						MAX_SUP_set_move_phase_walk(info->player);
					#endif

					if (SC_P_Ai_GetScriptMode(info->player)) {
						if ( (!pendl_points[PL_PENDL_current_point].ignore_speak) && (MAX_SUP_is_speaking(info->player, &PL_PENDL_time)) ) {// pokud nemluvi, tak se do time da doba mluveni
							return FALSE;	// a ukonci se tick
						}
					} else {
						MAX_SUP_clear_maintask(info->player);
						#ifdef PC_CONTROLLED
							//SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM);
							SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_DISABLED);
						#endif
						SC_P_Ai_SetScriptMode(info->player, TRUE);
					}

					SC_P_Ai_MoveAt(info->player, &pendl_points[PL_PENDL_current_point].point, NULL, PL_PENDL_current_point+1);
					PL_PENDL_bBlocked = FALSE;
					PL_PENDL_time = -1.0; // protoze MAX_SUP_is_speaking() !!!!
				}
			}
			
			break;

		case SC_PLSCR_MSG_PL_HIT:
			break;

		case SC_PLSCR_MSG_PL_KILLED:
			PL_PENDL_bDead = TRUE;
			break;

		case SC_PLSCR_MSG_PL_HEALEDFROMCOMA:
			PL_PENDL_bDead = FALSE;
			break;

		case SC_PLSCR_MSG_AI_MOVEAT_CALLBACK:
#ifdef MAX_SCRIPT_DEBUG
			SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
			sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_AI_MOVEAT_CALLBACK - param1: %d | param2: %d | s/g/m: %d/%d/%d", info->param1, info->param2, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
			SC_Log(3, _debug_tmp);
#endif

#ifdef PC_CONTROLLED
			SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM);
#endif
			//#ifdef PENDL_MOVE_STYLE_WALK							!!!!!!!!!!!!!!!!!!!!!!!!
			//	MAX_SUP_set_move_phase_run(info->player);			!!!!!!!!!!!!!!!!!!!!!!!!
			//#endif												!!!!!!!!!!!!!!!!!!!!!!!!

			//if (info->param1 == PL_PENDL_current_point+1) {
			if (!PL_PENDL_bBlocked) { // pokud je zablokovan, znamena to, ze nekdo pouzil SET nebo NEXT a doba v pendl_points.wait jeste neuplynula
				#ifndef PENDL_RETRY_AFTER_FIGHT
					if ( (pendl_points[PL_PENDL_current_point].leave_script) && (SC_P_Ai_GetScriptMode(info->player)) ) SC_P_Ai_SetScriptMode(info->player, FALSE);
				#endif
				if (info->param2 == SC_PL_AI_MOVEAT_CALLBACK_FINISHED) {
					//if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
					if (PL_PENDL_current_point < PENDL_POINTS-1) {
						if ((pendl_points[PL_PENDL_current_point].look_dir.x != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.y != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.z != 0.0))
							MAX_SUP_player_look_at_vec(info->player, &pendl_points[PL_PENDL_current_point].look_dir, (pendl_points[PL_PENDL_current_point].look_time == 0.0) ? pendl_points[PL_PENDL_current_point+1].wait*0.8 : pendl_points[PL_PENDL_current_point].look_time);
						PL_PENDL_current_point++;
						PL_PENDL_time = pendl_points[PL_PENDL_current_point].wait;
					} else if ((PL_PENDL_current_point >= PENDL_POINTS-1) && (PENDL_LOOPED)) {
						if ((pendl_points[PL_PENDL_current_point].look_dir.x != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.y != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.z != 0.0))
							MAX_SUP_player_look_at_vec(info->player, &pendl_points[PL_PENDL_current_point].look_dir, (pendl_points[PL_PENDL_current_point].look_time == 0.0) ? pendl_points[0].wait*0.8 : pendl_points[PL_PENDL_current_point].look_time);
						PL_PENDL_current_point = 0;
						PL_PENDL_time = pendl_points[PL_PENDL_current_point].wait;
					} else {
						if ((pendl_points[PL_PENDL_current_point].look_dir.x != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.y != 0.0) || (pendl_points[PL_PENDL_current_point].look_dir.z != 0.0))
							MAX_SUP_player_look_at_vec(info->player, &pendl_points[PL_PENDL_current_point].look_dir, (pendl_points[PL_PENDL_current_point].look_time == 0.0) ? pendl_points[PL_PENDL_current_point].wait*0.8 : pendl_points[PL_PENDL_current_point].look_time);
					}
				} else if (info->param2 == SC_PL_AI_MOVEAT_CALLBACK_FAILED) {
					#ifndef PENDL_RETRY_AFTER_FIGHT
						if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
					#endif
					PL_PENDL_time = 10.0; //retry
					//SC_message("call back %d %d - RETRY!", info->param1, info->param2);
				} else if (info->param2 == SC_PL_AI_MOVEAT_CALLBACK_STOPPED) {
					PL_PENDL_time = 10.0; //bez hlasky pokus o zopakovani
				} else {
					SC_message("haluz call back %d %d - RETRY!", info->param1, info->param2);
				}
			}
			break;

		case SC_PLSCR_MSG_SCRIPT_MESSAGE:
			switch (info->param1) {
			case MSG_PENDL_RESUME:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
				sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_PENDL_RESUME] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
				SC_Log(3, _debug_tmp);
#endif
				PL_PENDL_enable();
				info->next_exe_time = 0.1;
				break;

			case MSG_PENDL_STOP:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
				sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_PENDL_STOP] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
				SC_Log(3, _debug_tmp);
#endif
				if (SC_P_Ai_GetScriptMode(info->player)) SC_P_Ai_SetScriptMode(info->player, FALSE);
				PL_PENDL_disable();

#ifdef PC_CONTROLLED
				SC_P_Ai_TeamCmds_Set(info->player, SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM);
#endif
				break;

			case MSG_PENDL_SET:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
				sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_PENDL_SET] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
				SC_Log(3, _debug_tmp);
#endif
				PL_PENDL_enable();
				PL_PENDL_set(info->param2);
				info->next_exe_time = 0.1;
				break;

			case MSG_PENDL_NEXT:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
				sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_PENDL_NEXT] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
				SC_Log(3, _debug_tmp);
#endif
				PL_PENDL_enable();
				PL_PENDL_next();
				info->next_exe_time = 0.1;
				break;

			case MSG_MT_PENDL_PAUSE:
#ifdef MAX_SCRIPT_DEBUG
				SC_P_GetSideGroupMemberId(info->player, &PL_PENDL_side, &PL_PENDL_group, &PL_PENDL_member_id);
				sprintf(_debug_tmp, "pl_pendl.cxx : SC_PLSCR_MSG_SCRIPT_MESSAGE[MSG_MT_PENDL_PAUSE] - param1: %d | param2: %d | nod: %s | s/g/m: %d/%d/%d", info->param1, info->param2, info->param3 ? SC_NOD_GetName(info->param3) : 0, PL_PENDL_side, PL_PENDL_group, PL_PENDL_member_id);
				SC_Log(3, _debug_tmp);
#endif
				if (PL_PENDL_bEnabled) {
					PL_PENDL_enable();
					PL_PENDL_time = info->param4.x;
					SC_P_Ai_StopMoving(info->player);
				}
				break;

			} // info->param1

			break;

		case SC_PLSCR_MSG_AI_TEAMCMD_VALIDATE:
			info->param1 = 1;
			PL_PENDL_disable();
			SC_P_Ai_SetScriptMode(info->player, FALSE);
			break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)