// ************************************************************************************************************************ //
//																															//
//	File:			Common.cxx																								//
//	Description:	General code used by all types of scripts													        	//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //


#ifndef	__COMMON_CXX__
#define	__COMMON_CXX__


//
#include <inc\sc_global.h>
#include <inc\b&a\Common.h>



// +++ Forwards +++
// +++ Forwards +++
// +++ Forwards +++

sc_player GetRandomPlayer(dword sideId, dword groupId, dword type);


// +++ Macros +++
// +++ Macros +++
// +++ Macros +++

//Set 3 members of an array
#define	Set3(array, a,b,c) { array[0] = a; array[1] = b; array[2] = c; }

//Player handles
#ifndef	idPlayer
#define	idPlayer	SC_PC_Get()
#endif

#ifndef	idRndSquad
#define	idRndSquad	GetRandomPlayer(SC_P_SIDE_US, 0, SMT_RESPAWNED | SMT_ALIVE)
#endif

//

// +++ Functions +++
// +++ Functions +++
// +++ Functions +++


// ************************************************************************************************************************************** //
//											Retrieving/Setting players info/settings
// ************************************************************************************************************************************** //

//
BOOL GetPlayerPos(sc_player pl_id, c_Vector3 *pos)
{
	s_SC_P_status	status;

	if ( !SC_P_GetStatus(pl_id, &status) )
		return FALSE;

	*pos = status.pos;

	return TRUE;
}

BOOL GetPlayerPos(sc_player pl_id, c_Vector3 *pos, float *rz)
{
	s_SC_P_status	status;

	if ( !SC_P_GetStatus(pl_id, &status) )
		return FALSE;

	if (pos)
		*pos = status.pos;

	if (rz)
		*rz = status.rz;

	return TRUE;
}

//returns danger_around
float GetDanger(sc_player pl_id)
{
	s_SC_P_AI_status	status;

	if ( !SC_P_Ai_GetStatus(pl_id, &status) )
		return 0;

	return status.danger_around;
}

//returns TRUE is the player is alive, FALSE is he is in coma or dead
BOOL IsPlayerAlive(sc_player pl_id)
{
	s_SC_P_status	status;

	if ( !SC_P_GetStatus(pl_id, &status) )
		return FALSE;

	return (status.hp > 0);
}

//Set damage multipliers of any player
void SetPlayerDamage(sc_player pl_id, float multCaused, float multReceived)
{
	s_SC_P_ScriptProps	sp;


	CLEAR(sp);
	sp.caused_damage_mult = multCaused;
	sp.received_damage_mult = multReceived;

	SC_P_SetScriptProps(pl_id, &sp);
}

//
BOOL GetPlayerDamage(sc_player pl_id, float *multCaused, float *multReceived)
{
	s_SC_P_ScriptProps	sp;


	if (!pl_id)
		return FALSE;


	SC_P_GetScriptProps(pl_id, &sp);

	*multCaused = sp.caused_damage_mult;
	*multReceived = sp.received_damage_mult;

	return TRUE;
}

//All players in the group, EXCEPT of PC (use SetPlayerDamage() to set PC damage)
//Note: sideId can be set to SC_P_SIDE_ALL and groupId can be set to SC_P_GROUP_ALL to enumerate all sides/groups
void SetGroupDamage(dword sideId, dword groupId, float multCaused, float multReceived)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		i, num = MAX_GROUP_MEMBERS;


	num = SC_EnumPlayers(sideId, groupId, plList, num, SC_ENUMPLS_FL_AI_ONLY);
	for (i = 0; i < num; i++)
	{
		SetPlayerDamage(plList[i], multCaused, multReceived);
	}
}

//Get number of alive members
//Note: sideId can be set to SC_P_SIDE_ALL and groupId can be set to SC_P_GROUP_ALL to enumerate all sides/groups
dword GetGroupAliveMembers(dword sideId, dword groupId)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		i, num = MAX_GROUP_MEMBERS;


	return SC_EnumPlayers(sideId, groupId, plList, num, SC_ENUMPLS_FL_AI_ONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_RESPAWNEDONLY);
}

//
dword UpdateEnemies(sc_player pl_id, dword enemySide, dword enemyGroup)
{
	sc_player	plList[64];
	dword		i, num = 64;


	//
	num = SC_EnumPlayers(enemySide, enemyGroup, plList, num, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY);

	//
	for (i = 0; i < num; i++)
		SC_P_Ai_Situation_UpdateEnemy(pl_id, plList[i]);


	return num;
}

//Send message to group
//Note: sideId can be set to SC_P_SIDE_ALL and groupId can be set to SC_P_GROUP_ALL to enumerate all sides/groups
dword SendMessageToGroup(dword sideId, dword groupId, dword type, dword msg, dword param)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		flags, i, num = MAX_GROUP_MEMBERS;


	flags = 0;
	flags |= (type & SMT_RESPAWNED) ? SC_ENUMPLS_FL_RESPAWNEDONLY : 0;
	flags |= (type & SMT_NOTRESPAWNED) ? SC_ENUMPLS_FL_NORESPAWNEDONLY : 0;
	flags |= (type & SMT_DEAD) ? SC_ENUMPLS_FL_DEADONLY : 0;
	flags |= (type & SMT_ALIVE) ? SC_ENUMPLS_FL_ALIVEONLY : 0;
	flags |= (type & SMT_PC) ? 0 : SC_ENUMPLS_FL_AI_ONLY;


	num = SC_EnumPlayers(sideId, groupId, plList, num, flags );
	for (i = 0; i < num; i++)
	{
		SC_P_ScriptMessage(plList[i], msg, param);
	}

	return num;
}


//Get random player handle
sc_player GetRandomPlayer(dword sideId, dword groupId, dword type)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		flags, num = MAX_GROUP_MEMBERS;


	flags = 0;
	flags |= (type & SMT_RESPAWNED) ? SC_ENUMPLS_FL_RESPAWNEDONLY : 0;
	flags |= (type & SMT_NOTRESPAWNED) ? SC_ENUMPLS_FL_NORESPAWNEDONLY : 0;
	flags |= (type & SMT_DEAD) ? SC_ENUMPLS_FL_DEADONLY : 0;
	flags |= (type & SMT_ALIVE) ? SC_ENUMPLS_FL_ALIVEONLY : 0;
	flags |= (type & SMT_PC) ? 0 : SC_ENUMPLS_FL_AI_ONLY;


	num = SC_EnumPlayers(sideId, groupId, plList, num, flags );

	return (num) ? plList[rand() % num] : NULL;
}


//Sets behaviour of Team Commands for whole group (AI only). Types are defined as SC_P_AI_TEAMCMD_STATE_something in sc_global.h
void SetGroupTeamCmd(dword sideId, dword groupId, dword type)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		i, num = MAX_GROUP_MEMBERS;


	num = SC_EnumPlayers(sideId, groupId, plList, num, SC_ENUMPLS_FL_AI_ONLY);
	for (i = 0; i < num; i++)
	{
		SC_P_Ai_TeamCmds_Set(plList[i], type);
	}
}

//All players in the group, EXCEPT of PC
//Note: sideId can be set to SC_P_SIDE_ALL and groupId can be set to SC_P_GROUP_ALL to enumerate all sides/groups
void SetGroupGetSpch(dword sideId, dword groupId, dword flags)
{
	sc_player	plList[MAX_GROUP_MEMBERS];
	dword		i, num = MAX_GROUP_MEMBERS;


	num = SC_EnumPlayers(sideId, groupId, plList, num, SC_ENUMPLS_FL_AI_ONLY);
	for (i = 0; i < num; i++)
	{
		SC_P_GenSpch_Set(plList[i], flags);
	}
}


//enable entering a vehicle (PC only), default: enabled
void EnterVehicle(BOOL bEnable)
{
	s_SC_PC_Control	ctrl;

	//
	SC_PC_GetControl(&ctrl);

	ctrl.enter_vehicle = bEnable;

	SC_PC_SetControl(&ctrl);
}

//enable leaving a vehicle (PC only), default: enabled
void LeaveVehicle(BOOL bEnable)
{
	s_SC_PC_Control	ctrl;

	//
	SC_PC_GetControl(&ctrl);

	ctrl.leave_vehicle = bEnable;

	SC_PC_SetControl(&ctrl);
}

//enable swapping positions in a vehicle (PC only), default: enabled
void SwapVehicle(BOOL bEnable)
{
	s_SC_PC_Control	ctrl;

	//
	SC_PC_GetControl(&ctrl);

	ctrl.swap_vehicle = bEnable;

	SC_PC_SetControl(&ctrl);
}

//enable using of weapon (PC only), default: enabled
void UseWeapon(BOOL bEnable)
{
	s_SC_PC_Control	ctrl;

	//
	SC_PC_GetControl(&ctrl);

	ctrl.weapons = bEnable;

	SC_PC_SetControl(&ctrl);
}


// ************************************************************************************************************************************** //
//													Player animations
// ************************************************************************************************************************************** //



//Plays a stg animation (non-looped), returns length in seconds
float PlayAnim(sc_player pl, char *filename, dword callbackId, float cbTime)
{
	s_SC_P_Play3pvAnim	anim;


	if (!pl || !filename)
		return 0;

	CLEAR(anim);
	anim.stg_filename		= filename;
	anim.callback_id		= callbackId;
	anim.callback_timetoend	= cbTime;

	//set defaults
	anim.start_anim_time	= 0;
	anim.end_anim_time		= 0;
	anim.begin_interpolate_time = 0.0f;
	anim.end_interpolate_time	= 0.0f;
	anim.weight				= 1;
	anim.disable_hit_anim	= TRUE;

	//play
	return SC_P_Play3pvAnimExt(pl, &anim);
}

//Same as previous version, but it's also possible to specify interpolation times
float PlayAnim(sc_player pl, char *filename, dword callbackId, float cbTime, float inStart, float inEnd)
{
	s_SC_P_Play3pvAnim	anim;


	if (!pl || !filename)
		return 0;

	CLEAR(anim);
	anim.stg_filename		= filename;
	anim.callback_id		= callbackId;
	anim.callback_timetoend	= cbTime;

	//set defaults
	anim.start_anim_time	= 0;
	anim.end_anim_time		= 0;
	anim.begin_interpolate_time = inStart;
	anim.end_interpolate_time	= inEnd;
	anim.weight				= 1;
	anim.disable_hit_anim	= TRUE;

	//play
	return SC_P_Play3pvAnimExt(pl, &anim);
}



// ************************************************************************************************************************************** //
//																	Speech
// ************************************************************************************************************************************** //

//Set speech props
void SpeechProps(float dist, dword type)
{
	s_SC_SpeechProps	sp;

	//
	SC_Speech_GetProps(&sp);
//	sp.flags				= 0;		//possible: SC_SPEECHPROPS_FL_ALLOWFORDEADPLS
	sp.max_subtitle_dist	= dist;
	sp.type					= type;		//normal, 2D, 3D (viz SC_SPEECHPROPS_TYPE_*)
	SC_Speech_SetProps(&sp);
}

//Adds speech for specified player, returns time of next possible speech
float SpeechAdd(sc_player pl_id, dword speechID, float tmTime, float tmGap, dword callbackID)
{
	s_SC_SpeechAdd		sa;


	//
	CLEAR(sa);

	sa.author.plid	= pl_id;
	sa.speech_nr	= speechID;
	sa.timer		= tmTime;
	sa.timer_gap	= tmGap;
	sa.callback_id	= callbackID;

	SC_Speech_Add(&sa);

	return sa.timer;
}

//Adds speech for specified player, returns time of next possible speech
float SpeechAdd(sc_player pl_id, dword speechID, dword authorId, float tmTime, float tmGap, dword callbackID)
{
	s_SC_SpeechAdd		sa;


	//
	CLEAR(sa);

	sa.author.plid	= pl_id;
	sa.force_authorname_id	= authorId;
	sa.speech_nr	= speechID;
	sa.timer		= tmTime;
	sa.timer_gap	= tmGap;
	sa.callback_id	= callbackID;

	SC_Speech_Add(&sa);

	return sa.timer;
}

//Adds speech for specified player, returns time of next possible speech
//Used for xx1/zz1 and xx3/zz3 speech groups (animation name is generated from the speechID)
float SpeechAddAnm(sc_player pl_id, dword speechID, float tmTime, float tmGap, dword callbackID, dword flags)
{
	s_SC_SpeechAdd	sa;
	char			anim[260];
	BOOL			useAnim;


	if ( (flags & SC_SPEECHADD_FL_SETANIMFROMSTATIV) || (flags & SC_SPEECHADD_FL_USEAUTOMATICANIM) )		//xx3
		useAnim = FALSE;
	else
	{
		useAnim = TRUE;
		sprintf(anim, ANM_XX1_BASE, speechID);			//xx1
	}

	//
	CLEAR(sa);

	sa.author.plid	= pl_id;
	sa.speech_nr	= speechID;
	sa.timer		= tmTime;
	sa.timer_gap	= tmGap;
	sa.callback_id	= callbackID;
	sa.playanim_file  = (useAnim) ? anim : NULL;
	sa.playanim_flags = flags;

	SC_Speech_Add(&sa);

	return sa.timer;
}

//Adds speech for specified player, returns time of next possible speech
//Animation can be also specified
float SpeechAddAnm(sc_player pl_id, dword speechID, float tmTime, float tmGap, dword callbackID, dword flags, char *anim)
{
	s_SC_SpeechAdd		sa;


	//
	CLEAR(sa);

	sa.author.plid	= pl_id;
	sa.speech_nr	= speechID;
	sa.timer		= tmTime;
	sa.timer_gap	= tmGap;
	sa.callback_id	= callbackID;
	sa.playanim_file  = anim;
	sa.playanim_flags = flags;

	SC_Speech_Add(&sa);

	return sa.timer;
}

//Stop speech (of player/all, active/inactive)
void SpeechStop(sc_player pl_id, BOOL bActive)
{
	s_SC_Speech_Author	sa;

	if (pl_id)			//stop speech of particular player
	{
		CLEAR(sa);

		sa.plid = pl_id;
		SC_Speech_Remove(&sa, bActive);
	}
	else				//stop any speech
	{
		SC_Speech_RemoveAll(bActive);
	}
}

//Return time when will the player finish his currently buffered speech
float SpeechTime(sc_player pl_id)
{
	s_SC_Speech_Author	sa;

	if (!pl_id)
		return 0;

	CLEAR(sa);
	sa.plid = pl_id;

	return SC_Speech_GetTalkTime(&sa);
}




// ************************************************************************************************************************************** //
//																Sound, Music
// ************************************************************************************************************************************** //


//music is ptr to music .ini file, objName is ptr to name of object that the music is linked to (optional, can be NULL)
BOOL PlayMusic(char *music, char *objName)
{
	sc_nod	node = 0;


	if (!music)
		return FALSE;

	//
	if (objName)
	{
		node = SC_NOD_GetNoMessage(NULL, objName);
		if (!node)
			return FALSE;

		//play
		SC_Music_Play(music, node);
	}
	else
	{
		//play
		SC_Music_Play(music, NULL);
	}


	return TRUE;
}



// ************************************************************************************************************************************** //
//													Effects (particles, explosions, ...)
// ************************************************************************************************************************************** //

BOOL MakeExplosion(char *shName, dword expType, dword ptcId)
{
	s_SC_Expl_CreateInfo	eci;


	CLEAR(eci);

	//get sph
	if ( SC_GetScriptHelper(shName, &eci.sph, NULL) == SC_SCRIPTHELPER_TYPE_ERROR )
		return FALSE;

	eci.author_handle	= (expType & XT_FLG_BYPLAYER) ? SC_PC_Get() : NULL;
	eci.tweap_id		= 0;		//probably set by engine (?)
	eci.ptc_id			= ptcId;
	eci.script_type		= 1;		//means 'not used'

	//set props by type
	switch( expType & ~XT_FLG_BYPLAYER )
	{
	case XT_GRENADE:
		eci.damage			= 100.0f;
		eci.marok_impuls	= 300.0f;
		eci.piercing		= 0.0f;
		break;

	case XT_MORTAR:
		eci.damage			= 200.0f;
		eci.marok_impuls	= 600.0f;
		eci.piercing		= 10.0f;
		break;

	case XT_ABOMB:
		eci.damage			= 1000.0f;
		eci.marok_impuls	= 1000.0f;
		eci.piercing		= 100.0f;
		break;

	default:
		return FALSE;
	}


	//make explosion
	SC_Explosion_Make(&eci);

	return TRUE;
}



// ************************************************************************************************************************************** //
//																Teleportation
// ************************************************************************************************************************************** //


//Teleport player's squad to specified location, returns TRUE if the squad is succesfully teleported, otherwise FALSE
BOOL TeleportSquad(dword nameNr)
{
	dword	side, group, ho, ret;
	char	str[64];
	float	distTele, distPlayer;
	sc_player		plList[MAX_GROUP_MEMBERS];
	dword			i, num = MAX_GROUP_MEMBERS;
	c_Vector3		pos, vec, squad, trig, tele;
	s_sphere		sphTrig, sphTele;
	c_BoxOriented	boxTrig, boxTele;
	s_SC_Area		area;


	//the squad members are in the same side & group as PC player
	SC_P_GetSideGroupMemberId( SC_PC_Get(), &side, &group, NULL);

	//get alive squad members
	num = SC_EnumPlayers(side, group, plList, num, SC_ENUMPLS_FL_AI_ONLY | SC_ENUMPLS_FL_ALIVEONLY);
	if (!num)
		return FALSE;

	//make name
	sprintf(str, TELE_TRIG_NAME_BASE, nameNr);
	//
	ret = SC_GetScriptHelper(str, &sphTrig, &boxTrig);

	//get position of Triggering SH
	switch(ret)
	{
	case SC_SCRIPTHELPER_TYPE_BOX:
		trig = boxTrig.pos;
		break;

	case SC_SCRIPTHELPER_TYPE_SPHERE:
		trig = sphTrig.pos;
		break;

	default:				//error
		SC_message("TeleportSquad(%d): can't get ScriptHelper '%s'!", nameNr, str);
		return FALSE;
	}

	//make name
	sprintf(str, TELE_POS_NAME_BASE, nameNr);
	//
	ret = SC_GetScriptHelper(str, &sphTele, &boxTele);

	//get position of Tele SH
	CLEAR(area);
	switch(ret)
	{
	case SC_SCRIPTHELPER_TYPE_BOX:
		tele = boxTele.pos;

		area.boxes = 1;
		area.box = &boxTele;
		break;

	case SC_SCRIPTHELPER_TYPE_SPHERE:
		tele = sphTele.pos;

		area.sphs = 1;
		area.sph = &sphTele;
		break;

	default:				//error
		SC_message("TeleportSquad(%d): can't get ScriptHelper '%s'!", nameNr, str);
		return FALSE;
	}

	//get dist between trig & tele
	distTele = SC_2VectorsDist(&trig, &tele);


	//PC pos
	if ( !GetPlayerPos( SC_PC_Get(), &pos ) )
		return FALSE;

	//compute average position of the alive squad members
	CLEAR(squad);
	for (i = 0; i < num; i++)
	{
		GetPlayerPos(plList[i], &vec);

		squad.x += vec.x; squad.y += vec.y; squad.z += vec.z;
	}

	squad.x /= num; squad.y /= num; squad.z /= num;

	//get dist between player & squad
	distPlayer = SC_2VectorsDist(&pos, &squad);


	//if the distance to squad is smaller than the distance to tele-point, don't teleport players
	if (distPlayer < distTele+10.0f)
		return FALSE;

	//otherwise teleport the squad
	for (i = 0; i < num; i++)
	{
		//get random position (hideout) within teleportation area
		ho = SC_GetRndHideout(&area, SC_GETHIDEOUT_FL_EMPTYONLY, &pos);
		if ( !ho )
		{
			SC_message("TeleportSquad(%d): can't find any free hideout in the specified area!", nameNr);
			return FALSE;
		}

		//teleport player to that position
		SC_P_SetPos(plList[i], &pos, NULL, NULL);

		//occupy hideout
		SC_P_Ai_OccupyHideout(plList[i], ho);
	}


	return TRUE;
}


// ************************************************************************************************************************************** //
//																Miscelaneous
// ************************************************************************************************************************************** //

//Get position of dummy
BOOL GetDummyPos(char *name, c_Vector3 *vec)
{
	sc_nod	node;

	node = SC_NOD_GetNoMessage(NULL, name);
	if (!node)
		return FALSE;

	SC_NOD_GetWorldPos(node, vec);

	return TRUE;
}

//Get position of dummy
BOOL GetDummyPosRz(char *name, c_Vector3 *vec, float *rz)
{
	sc_nod	node;

	node = SC_NOD_GetNoMessage(NULL, name);
	if (!node)
		return FALSE;

	SC_NOD_GetWorldPos(node, vec);

	*rz = SC_NOD_GetWorldRotZ(node);
	*rz += 3.14f;

	return TRUE;
}


//Enable/disable dynamic blocker with script
BOOL EnableBlocker(char *name, BOOL bEnable)
{
	sc_nod	node;

	node = SC_NOD_Get(NULL, name);

	if (node)
	{
		SC_ObjectScriptMessage(node, SCM_DB_ENABLE, bEnable);
		return TRUE;
	}

	return FALSE;
}

//Fill area with single script-helper
BOOL FillArea(char *shName, s_SC_Area *area, s_sphere *sph, c_BoxOriented *box)
{
	if (!shName || !area)
		return FALSE;

	CLEAR(*area);

	//
	switch( SC_GetScriptHelper(shName, sph, box) )
	{
	case SC_SCRIPTHELPER_TYPE_SPHERE:
		if (!sph)
			return FALSE;

		area->sphs = 1;
		area->sph = sph;
		break;

	case SC_SCRIPTHELPER_TYPE_BOX:
		if (!box)
			return FALSE;

		area->boxes = 1;
		area->box = box;
		break;

	case SC_SCRIPTHELPER_TYPE_ERROR:
	default:
		SC_message("FillArea(): can't get ScriptHelper: %s", shName);
		return FALSE;
	}

	return TRUE;
}

//Save Game
void SaveGame(dword saveId, dword descId, BOOL bNoInfo)
{
	s_SC_MissionSave	sg;

	CLEAR(sg);
	sg.savename_id		= saveId;
	sg.description_id	= descId;
	sg.disable_info		= bNoInfo;

	SC_MissionSave(&sg);
}


#endif	//__COMMON_CXX__
