// ************************************************************************************************************************ //
//
//	File:			Common.h
//	Description:	General header used by all types of scripts
//	Author:			Beny
//
// ************************************************************************************************************************ //



#ifndef	__COMMON_H__
#define	__COMMON_H__




// +++ Defines +++
// +++ Defines +++
// +++ Defines +++

//misc
#define	STR_SIZE			256
#define	MAX_GROUP_MEMBERS	256

//predefined gPhase
#define	GP_START			0				//this phase is set at start of script
#define	GP_INIT				1
#define	GP_IDLE				1000000			//idle
#define	GP_HOLDPOS			1000001			//holding position
#define	GP_PENDL			1000002			//do something while pendling
#define	GP_ATTACK			1000003			//attacking enemy
#define	GP_FOLLOW			1000004			//following player
#define	GP_MOVE				1000005			//moving to some place
#define	GP_WAIT				1000006			//waiting for something
#define	GP_BEGIN			1000007			//begin some action
#define	GP_CHECKENEMY		1000010			//check  for the enemy
#define	GP_ENEMYSPOTTED		1000011			//react on enemy
#define	GP_CHECK			1000012			//check (anything)
#define	GP_DIALOGUE			1000020			//proceed a dialogue
#define	GP_DEAD				1000090			//player is dead (e.g. when waiting for next respawn)
#define	GP_CAMANIM_START	1000100			//load camera animation
#define	GP_CAMANIM_PLAY		1000101			//play camera animation
#define	GP_OBJANIM_START	1000110			//load object animation
#define	GP_OBJANIM_PLAY		1000111			//play object animation
#define	GP_REPEAT			1000200			//repeat some action
#define	GP_DBG				2000000			//for debug purposes only


//script messages
#define	SCM_RESPAWN			1000000			//respawn player
#define	SCM_DERESPAWN		1000001			//derespawn player
#define	SCM_BEGIN			1000002			//begin an action specified by param2
#define	SCM_FOLLOW			1000003			//set follow mode (depends on param2)
#define	SCM_LOUDSHOT		1000004			//LoudShot was made, param2 = LSID
#define	SCM_DOANIM			1000005			//play set of player 3pv animations, actual animations depends on level, the set is specified by param2
#define	SCM_INTERACTION		1000006			//interaction w/ player was used, param2 = pl_id, param3 = context param
#define	SCM_SPEECHDONE		1000007			//param2 = speech id
#define	SCM_GOTO			1000008			//param2 = context id
#define	SCM_CHANGE_SGM		1000010			//change side/group/member id
#define	SCM_TELEPORT		1000011			//teleport player, param2 = context id
#define	SCM_HOLD			1000012			//hold pos
#define	SCM_RADIO_BEGIN		1000020			//begin radio communication (for radioman)
#define	SCM_RADIO_END		1000021			//end radio communication (for radioman)
#define	SCM_SH_TRIGGERED	1000100			//script helper was triggered (PC got inside the box/sph)
#define	SCM_SH_START		1000101			//starts processing of hPcTrigger SH which has SH_START_INACTIVE #defined. It can be also used to re-enable SH which has been already triggered
#define	SCM_SH_STOP			1000102			//stops processing of hPcTrigger SH
#define	SCM_SH_PLAYANIM		1000107			//msg to SH - play an animation set
#define	SCM_SH_ANIMEND		1000110			//animation, that was started by SH, has finished
#define	SCM_SH_PLAYPTC		1000120			//play particle; param1 = SCM_SH_PLAYPTC; param2 = ptcId, param3 = time; define PTC_REPEAT to play it forever
#define	SCM_SH_STOPPTC		1000121			//stop playing particle - only for particles played executed by SCM_SH_PLAYPTC with PTC_REPEAT;
#define	SCM_DB_ENABLE		1000200			//enable/disable dynamic blocker
#define	SCM_DOOR_SET		1000210			//set door status (see door states in this file - DOOR_SET_*)
#define	SCM_VEH_PLAYANIM	1000301			//play vehicle animation, param2 = path to animation
#define	SCM_VEH_STOPANIM	1000302			//stop vehicle animation, no params
#define	SCM_OBJ_HIT			1000400			//object was hit, param2 = node
#define	SCM_OBJ_INTERACTION	1000401			//interaction w/ object was used, param2 = node
#define	SCM_OBJ_PLAYANIM	1000405			//start manm animation; param2 = (char*)animName; param3 = (char*)objName
#define	SCM_OBJ_STOPANIM	1000406			//stop manm animation;
#define	SCM_OBJ_ANIMEND		1000407			//objects reports end of the animation (if SEND_MSG_AFTER_ANIM is #defined)


//ScriptMessageTo*()
#define	SMT_ALLAI			0x00000000
#define	SMT_RESPAWNED		0x00000001
#define	SMT_NOTRESPAWNED	0x00000002
#define	SMT_DEAD			0x00000004
#define	SMT_ALIVE			0x00000008
#define	SMT_PC				0x00000100		//when set, the message is sent to PC as well (otherwise only to AI)

//MainTasks
#define	MT_NONE				0				//no task
#define	MT_HOLD				1				//hold position
#define	MT_PENDL			2				//guard
#define	MT_ATTACK			3				//attack
#define	MT_FOLLOW			4				//follow
#define	MT_MOVE				5				//tactical move


//MakeExplosion() explosion types
#define	XT_GRENADE			0x00000001		//one of following values
#define	XT_MORTAR			0x00000002
#define	XT_ABOMB			0x00000003
#define	XT_FLG_BYPLAYER		0x10000000		//can be combined with types above

//door states
#define	DOOR_SET_CLOSED		0				//closed, not locked
#define	DOOR_SET_LOCKED		1				//closed and locked
#define	DOOR_SET_OPEN		2				//open (not locked of coz)
#define	DOOR_IMP_CLOSE		3				//give the door an impulse to open it
#define	DOOR_IMP_OPEN		4				//give the door an impulse to close it
#define	DOOR_SET_UNLOCKED	5				//unlocked


//teleportation place name base
#define	TELE_TRIG_NAME_BASE	"hTele%02d"
#define	TELE_POS_NAME_BASE	"tele%02d"


//
#define	ANM_XX1_BASE		"G\\Anims\\Speech\\%d.stg"


#endif	//__COMMON_H__
