// ************************************************************************************************************************ //
//																															//
//	File:			Door.cxx																								//
//	Description:	Script for door, it can open, close or lock door											        	//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//define door state
#ifndef	DOOR_INIT_STATE
#define	DOOR_INIT_STATE		DOOR_SET_CLOSED
#endif

//default use distance
#define	OBJ_USE_DIST		2.0f


//
dword	gPhase = GP_START;


//
void SetDoor(sc_nod door, dword doorState)
{
	switch(doorState)
	{
	case DOOR_SET_OPEN:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);	//to be sure...
		SC_Door_SetOpenState(door, 1.0f);
		break;

	case DOOR_SET_LOCKED:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);	//to be sure...
		SC_Door_SetOpenState(door, 0.0f);
		SC_Door_SetState(door, SC_DOOR_STATE_LOCKED);	//lock
		break;

	case DOOR_SET_UNLOCKED:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);	//
		break;

	case DOOR_IMP_CLOSE:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);	//to be sure...
		SC_Door_Impulse(door, -1.0f);					//close the door if open
		break;

	case DOOR_IMP_OPEN:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);	//to be sure...
		SC_Door_Impulse(door, 1.0f);					//open the door
		break;

	case DOOR_SET_CLOSED:
	default:
		SC_Door_SetState(door, SC_DOOR_STATE_NORMAL);
		SC_Door_SetOpenState(door, 0.0f);
		break;
	}
}

//
int ScriptMain(s_SC_OBJ_info *info)
{
	switch(info->message)
	{
	case SC_OBJ_MSG_DOTICK:
		switch(gPhase)
		{
		case GP_START:
			info->next_exe_time = 0.1f;
			gPhase = GP_INIT;
			break;

		case GP_INIT:
			SetDoor(info->master_nod, DOOR_INIT_STATE);
			gPhase = GP_IDLE;
			break;

		case GP_IDLE:
		default:
			break;
		}
		break;

	case SC_OBJ_MSG_MESSAGE:
		switch(info->param1)
		{
		case SCM_DOOR_SET:
			SetDoor(info->master_nod, info->param2);
			break;
		}
		break;

	case SC_OBJ_MSG_USED:
		break;


	//
	case SC_OBJ_MSG_INIT:
		info->next_exe_time = 0.1f;

#ifdef	OBJ_USE_TEXT
		SC_ActiveObj_Create(info->master_nod, OBJ_USE_DIST, OBJ_USE_TEXT);
#endif
		break;

	case SC_OBJ_MSG_JUSTLOADED:
		break;

	case SC_OBJ_MSG_RELEASE:
		break;


	default:
		return FALSE;
	}

	return TRUE;

}//int ScriptMain(s_SC_OBJ_info *info)
