// ************************************************************************************************************************ //
//																															//
//	File:			Player.cxx																								//
//	Description:	Common code used by player scripts	    													        	//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //



//
#include <inc\b&a\Player.h>
#include <inc\b&a\Common.cxx>



// +++ Globals +++
dword	gPhase = GP_START;
dword	gMainTask = MT_NONE;
dword	gPathIdx = 0, gMoveIdx = 0;
BOOL	gPendlForward = TRUE;
BOOL	bDead = FALSE;





// +++ Functions +++
// +++ Functions +++
// +++ Functions +++


// ************************************************************************************************************************************** //
//												Creation, Init, Respawn, Setting of misc stuff
// ************************************************************************************************************************************** //

//Create player (pc or ai)
BOOL CreatePlayer(s_SC_Pscript_info *info, s_CreatePlayerInfo *cpInfo)
{
	s_SC_P_Create		plCreate;
	s_SC_P_RespawnPos	respPos;
	s_SC_Plscr_info		scrInfo;

	s_SC_P_CreateWeap	weap[16];	//just for weap/ammo redefinition
	s_SC_P_AmmoRedefine	amred[1];
	dword				i;


	//
	if (!info)
		return FALSE;

	//
	CLEAR(plCreate);
	CLEAR(respPos);
	CLEAR(scrInfo);

	//
	SC_PlScr_GetInfo(info->script, &scrInfo);

	//
	SC_NOD_FillRespawnPos(scrInfo.nod, &respPos);


	//
	plCreate.script			= info->script;
	plCreate.type			= (cpInfo->flags & PL_CR_PC) ? SC_P_CREATE_TYPE_PC : SC_P_CREATE_TYPE_AI;
	plCreate.flags			|= (cpInfo->flags & PL_CR_BLOCKER) ? SC_P_CREATE_FL_GENERATE_AI_BLOCKER : 0;		//blocker
	plCreate.flags			|= (cpInfo->flags & PL_CR_PC) ? SC_P_CREATE_FL_TARGET_FOR_AIFIRSTWEEKSHOT : 0;		//first weak shot (only for pc)
	plCreate.flags			|= (cpInfo->flags & PL_CR_COMA) ? SC_P_CREATE_FL_ALLOW_COMA : 0;					//enable 'coma state' (usually for allies)
	plCreate.flags			|= (cpInfo->flags & PL_CR_CANTDIE) ? SC_P_CREATE_FL_NODEADJUSTCOMA : 0;				//stay in coma, do not die
	plCreate.flags			|= (cpInfo->flags & PL_CR_FORCE_IK_DTH) ? SC_P_CREATE_FL_FORCE_USE_IK_DEATH : 0;	//use IK instead of death animation
	plCreate.flags			|= (cpInfo->flags & PL_CR_NODROP) ? SC_P_CREATE_FL_DROP_NOTHING_FROM_DEAD : 0;		//don't drop any items when the player is killed


	plCreate.side			= cpInfo->idSide;
	plCreate.group			= cpInfo->idGroup;
	plCreate.member_id		= cpInfo->idMember;

	plCreate.name_nr		= cpInfo->nameNr;
	plCreate.name_unicode	= NULL;

	if (!plCreate.name_nr)
	{
		if (!cpInfo->nameAnsi)
		{
			switch(cpInfo->idSide)
			{
			case SC_P_SIDE_US:
				plCreate.name_ansi		= "Imperialista";
				break;

			case SC_P_SIDE_VC:
				plCreate.name_ansi		= "Komunista";
				break;

			case SC_P_SIDE_NEUTRAL:
				plCreate.name_ansi		= "Pacifista";
				break;

			case SC_P_SIDE_MP_SPECTATOR:
				plCreate.name_ansi		= "Cumil";
				break;

			default:
				plCreate.name_ansi		= "ufon";
				break;
			}
		}
		else		//just for dbg purposes
		{
			plCreate.name_ansi		= cpInfo->nameAnsi;
		}
	}

	plCreate.inifile		  = cpInfo->iniFile;
	plCreate.eqp_inifile	  = cpInfo->iniEqp;
	plCreate.head_name		  = cpInfo->head;
	plCreate.head_eqp_inifile = cpInfo->headEqp;

	plCreate.respawn		= (cpInfo->flags & PL_CR_RESPAWN) ? &respPos : NULL;

	plCreate.genvoice_group	= cpInfo->genVoice;

	plCreate.weap_select_tweap = cpInfo->numWeap ? cpInfo->weap[0].weap_id : 0;



	//redefine 'weapons' for special characters (medic, engineer)
	if (cpInfo->flags & PL_CR_MEDIC)
	{
		CLEAR(weap);

		for (i = 0; i < cpInfo->numWeap; i++)	//copy weaps
			weap[i] = cpInfo->weap[i];

		//add medkit and redefine ammo
		weap[i].weap_id = 60;					//medkit
		amred[0].ammo_type = 22;				//medkit 'ammo'
		amred[0].max_ammo = 1000;				//ammo amount
		plCreate.ammo_redefines = 1;
		plCreate.ammo_redefine = amred;

		//set weapons
		plCreate.weapons		= cpInfo->numWeap+1;
		plCreate.weap			= weap;

		//set name
		if (!plCreate.name_nr)
			plCreate.name_nr = 2714;
//			plCreate.name_ansi		= "Medic";
	}
	else if (cpInfo->flags & PL_CR_ENGINEER)
	{
		CLEAR(weap);

		for (i = 0; i < cpInfo->numWeap; i++)	//copy weaps
			weap[i] = cpInfo->weap[i];

		//add ammobox and redefine ammo
		weap[i].weap_id = 61;					//ammobox
		amred[0].ammo_type = 23;				//ammobox 'ammo'
		amred[0].max_ammo = 1000;				//ammo amount
		plCreate.ammo_redefines = 1;
		plCreate.ammo_redefine = amred;

		//set weapons
		plCreate.weapons		= cpInfo->numWeap+1;
		plCreate.weap			= weap;

		//set name
		if (!plCreate.name_nr)
			plCreate.name_nr = 2715;
//			plCreate.name_ansi		= "Engineer";
	}
	else if (cpInfo->flags & PL_CR_RADIO)
	{
		CLEAR(weap);

		for (i = 0; i < cpInfo->numWeap; i++)	//copy weaps
			weap[i] = cpInfo->weap[i];

		//add ammobox and redefine ammo
		weap[i].weap_id = 62;					//radio

		//set weapons
		plCreate.weapons		= cpInfo->numWeap+1;
		plCreate.weap			= weap;

		//set name
		if (!plCreate.name_nr)
			plCreate.name_nr = 2717;
//			plCreate.name_ansi		= "Radioman";
	}
	else	//standard case
	{
		plCreate.weapons		= cpInfo->numWeap;
		plCreate.weap			= cpInfo->weap;
	}


	return SC_P_Create(&plCreate);
}


//Respawn at player_entity position
BOOL RespawnPlayer(s_SC_Pscript_info *info, dword flags)
{
	s_SC_Plscr_info		psi;
	s_SC_P_RespawnPos	rp;


	if (!info)
		return FALSE;

	//
	CLEAR(rp);

	SC_PlScr_GetInfo(info->script, &psi);
	SC_NOD_FillRespawnPos(psi.nod, &rp);

	rp.flags |= flags;

	//
	SC_P_Respawn(info->player, &rp);

	return TRUE;
}

//Respawn at given position
BOOL RespawnPlayer(s_SC_Pscript_info *info, c_Vector3 *pos, float rz, dword flags)
{
	s_SC_P_RespawnPos	rp;


	if (!info || !pos)
		return FALSE;

	//
	CLEAR(rp);

	rp.pos	= *pos;
	rp.rz	= rz;
	rp.flags= flags;

	//
	SC_P_Respawn(info->player, &rp);

	return TRUE;
}

void GetAiProps(sc_player pl_id, s_aiProps *aiProps)
{
	s_SC_P_AI_props		aip;


	//
	CLEAR(aip);

	SC_P_Ai_GetProps(pl_id, &aip);

	aiProps->flags = 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SITUPDATE_VISUAL_DISABLED)	? PL_AI_BLIND : 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SITUPDATE_HEAR_DISABLED)	? PL_AI_DEAF : 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SITSHARE_SEND_DISABLED)		? PL_AI_NOSEND : 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SITSHARE_RECEIVE_DISABLED)	? PL_AI_NORECEIVE : 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SHOOTING_DISABLED)			? PL_AI_NOSHOOT : 0;
	aiProps->flags |= (aip.flags & SC_PLAI_PROPS_FL_SHOOTING_HIT_ALLIES)		? PL_AI_HITALLY : 0;

	aiProps->visDist = aip.max_visibility;
	aiProps->timeEnemyForget = aip.forget_time_enemy;
	aiProps->hearDist = aip.hear_enemy_detection_max_distance;
	aiProps->shootImprecisionXY = aip.shoot_imprecision_xy;
	aiProps->shootImprecisionZ = aip.shoot_imprecision_z;
}


//NEW version - it ONLY sets the s_aiProps params that are non-zero!!!
//For other params use SetRankClass() function
void SetAiProps(sc_player pl_id, s_aiProps *aiProps)
{
	s_SC_P_AI_props		aip;


	CLEAR(aip);

	//
	SC_P_Ai_GetProps(pl_id, &aip);

	if (aiProps->visDist > 0)
		aip.max_visibility						= aiProps->visDist;				//100.0

	if (aiProps->hearDist > 0)
		aip.hear_enemy_detection_max_distance	= aiProps->hearDist;			//30.0

	if (aiProps->timeEnemyForget > 0)
		aip.forget_time_enemy					= aiProps->timeEnemyForget;		//20.0

	if (aiProps->shootImprecisionXY > 0)
		aip.shoot_imprecision_xy				= aiProps->shootImprecisionXY;	//0.3

	if (aiProps->shootImprecisionZ > 0)
		aip.shoot_imprecision_z					= aiProps->shootImprecisionZ;	//0.1


	if (aiProps->flags)
	{
		aip.flags  = 0;																//0
		aip.flags |= (aiProps->flags & PL_AI_BLIND)		? SC_PLAI_PROPS_FL_SITUPDATE_VISUAL_DISABLED : 0;
		aip.flags |= (aiProps->flags & PL_AI_DEAF)		? SC_PLAI_PROPS_FL_SITUPDATE_HEAR_DISABLED : 0;
		aip.flags |= (aiProps->flags & PL_AI_NOSEND)	? SC_PLAI_PROPS_FL_SITSHARE_SEND_DISABLED : 0;
		aip.flags |= (aiProps->flags & PL_AI_NORECEIVE) ? SC_PLAI_PROPS_FL_SITSHARE_RECEIVE_DISABLED : 0;
		aip.flags |= (aiProps->flags & PL_AI_NOSHOOT)	? SC_PLAI_PROPS_FL_SHOOTING_DISABLED : 0;
		aip.flags |= (aiProps->flags & PL_AI_HITALLY)	? SC_PLAI_PROPS_FL_SHOOTING_HIT_ALLIES : 0;
		aip.flags |= (aiProps->flags & PL_AI_INVISIBLE)	? SC_PLAI_PROPS_FL_ISINVISIBLE_FOR_ENEMY_AI : 0;
	}

	//
	SC_P_Ai_SetProps(pl_id, &aip);
}


/*
//OLD version
//Set Ai properties
void SetAiProps(sc_player pl_id, s_aiProps *aiProps)
{
	s_SC_P_AI_props		aip;


	//
	CLEAR(aip);

	//
	SC_P_Ai_GetProps(pl_id, &aip);

	//																			//Defaults:
	aip.vis[0].distance	= 3.0f;													//2.0
	aip.vis[0].angle	= 4.712f;	//270 deg									//4.712 (270)
	aip.vis[0].angle_perception_lost	= 0.7f;									//3.0
	aip.vis[0].distance_perception_lost	= 1.0f;									//1.0

	aip.vis[1].distance	= 12.0f;												//12.0
	aip.vis[1].angle	= 3.14f;	//180 deg									//2.967 (170)
	aip.vis[1].angle_perception_lost	= 2.0f;									//3.0
	aip.vis[1].distance_perception_lost	= 0.9f;									//0.9

	aip.vis[2].distance	= 50.0f;												//50.0
	aip.vis[2].angle	= 1.75f;	//100 deg									//1.396 (80)
	aip.vis[2].angle_perception_lost	= 2.0f;									//2.5
	aip.vis[2].distance_perception_lost	= 0.8f;									//0.3

	aip.flags  = 0;																//0
	aip.flags |= (aiProps->flags & PL_AI_BLIND)		? SC_PLAI_PROPS_FL_SITUPDATE_VISUAL_DISABLED : 0;
	aip.flags |= (aiProps->flags & PL_AI_DEAF)		? SC_PLAI_PROPS_FL_SITUPDATE_HEAR_DISABLED : 0;
	aip.flags |= (aiProps->flags & PL_AI_NOSEND)	? SC_PLAI_PROPS_FL_SITSHARE_SEND_DISABLED : 0;
	aip.flags |= (aiProps->flags & PL_AI_NORECEIVE) ? SC_PLAI_PROPS_FL_SITSHARE_RECEIVE_DISABLED : 0;
	aip.flags |= (aiProps->flags & PL_AI_NOSHOOT)	? SC_PLAI_PROPS_FL_SHOOTING_DISABLED : 0;
	aip.flags |= (aiProps->flags & PL_AI_HITALLY)	? SC_PLAI_PROPS_FL_SHOOTING_HIT_ALLIES : 0;
	aip.flags |= (aiProps->flags & PL_AI_INVISIBLE)	? SC_PLAI_PROPS_FL_ISINVISIBLE_FOR_ENEMY_AI : 0;


	aip.max_visibility							= aiProps->visDist;				//100.0
	aip.vis_perception_mult						= 2.0f;							//2.0
	aip.vis_perception_mult_script				= 1.0f;							//1.0
	aip.vis_perception_mult_peace				= 0.8f;							//0.8
	aip.vis_perception_mult_peace_fakedanger	= 1.2f;							//1.2
	aip.vis_perception_mult_danger				= 1.8f;							//1.8
	aip.vis_perception_mult_battle				= 1.5f;							//1.5
	aip.vis_perception_mult_danger_item			= 4.0f;							//4.0
	aip.vis_perception_phase_change				= 3.0f;							//3.0
	aip.vis_ammount_decrease_persec				= 0.0f;							//0.05
	Set3(aip.vis_perception_phase, 1, 0.7 , 0.5);								//1.0, 0.7, 0.4
	Set3(aip.vis_perception_move, 0.04, 0.2, 0.4);								//0.02, 0.15, 0.3
	Set3(aip.vis_perception_aim_change,	1.2, 1.2, 1.1);							//1.2, 3.0, 1.5

	aip.forget_time_enemy						= aiProps->timeEnemyForget;		//20.0
	aip.forget_time_danger_shooting				= 10.0f;						//30.0

	aip.danger_around_stop_shooting				= 18.0f;						//25.0
	aip.danger_around_no_peepout				= 5.0f;							//5.0
	aip.danger_visual_to_enemy_value			= 0.3f;							//0.3

	aip.hear_enemy_detection					= 1.5f;							//4.0
	aip.hear_enemy_detection_max_distance		= aiProps->hearDist;			//30.0
	aip.hear_enemy_detection_max_distance_z		= 10.0f;						//10.0
	aip.hear_max_distance						= 0.0f;							//0
	aip.hear_max_distance_z						= 0.0f;							//0

	aip.danger_reaction_time_min				= 0.2f;							//0.2
	aip.danger_reaction_time_max				= 0.6f;							//0.7
	aip.danger_lookat_time_mult					= 1.0f;							//1.0
	aip.danger_lookat_sure_time_min				= 1.0f;							//1.5
	aip.danger_lookat_sure_time_max				= 3.0f;							//3.0

	aip.peace_lookat_visuals_min_ammount		= 0.3f;							//0.3

	aip.battlemode_tohideout_dist_max			= 16.0f;						//16.0
	aip.battlemode_tohideout_z_dist_max			= 2.0f;							//0
	aip.battlemode_tohideout_nearestenemy_mult	= 0.5f;							//0.7
	aip.battlemode_tohideout_fix_dist			= 2.0f;							//3.0
	aip.battlemode_tohideout_movedist_mult_max	= 1.5f;							//1.5

	aip.fakedangermode_tohideout_dist_max		= 5.0f;							//4.0
	aip.fakedangermode_tohideout_z_dist_max		= 1.0f;							//0
	aip.fakedangermode_tohideout_fix_dist		= 2.0f;							//1.5
	aip.fakedangermode_tohideout_time_mult		= 1.0f;							//0.7
	aip.fakedangermode_tohideout_movedist_max	= 0;							//6.0

	aip.enemydead_recognize_immediatelly_dist	= 7.0f;							//10.0
	aip.enemydead_recognize_speed				= 3.0f;							//3.0
	aip.enemydead_forget_speed_mult				= 3.0f;							//2.0

	aip.shoot_imprecision_xy					= aiProps->shootImprecisionXY;	//0.3
	aip.shoot_imprecision_z						= aiProps->shootImprecisionZ;	//0.1
	aip.shoot_imprecision_correction_time_min	= 0.4f;							//0.3
	aip.shoot_imprecision_correction_time_max	= 1.0f;							//0.6

	aip.allydeath_reaction_hear_dist			= 4.0f;							//4.0
	aip.allydeath_reaction_vis_dist				= 12.0f;						//10.0
	aip.allydeath_reaction_do_collision_test	= FALSE;						//FALSE

	//
	SC_P_Ai_SetProps(pl_id, &aip);
}
*/


// ************************************************************************************************************************************** //
//													MainTasks and related stuff
// ************************************************************************************************************************************** //


//
BOOL MT_PendlStart(sc_player pl_id, dword startIdx, BOOL bForward, s_mtPendl *pendlInfo)
{
	s_SC_P_Ai_MainTask	mt;
	s_sphere			sph;
	s_SC_Area			area;
	dword				res;
	char				str[STR_SIZE];


	//get area to get to
	sprintf(str, PND_NAME_BASE, ID_MEMBER, startIdx);

	res = SC_GetScriptHelper(str, &sph, NULL);
	if (res == SC_SCRIPTHELPER_TYPE_ERROR)
	{
		SC_message("vc_%d_%d: can't start pendl! (startIdx = %d)", ID_GROUP, ID_MEMBER, startIdx);
		gPhase = GP_IDLE;
		return FALSE;
	}


	//Set Pendl via MainTask
	CLEAR(mt);

	mt.cooperation_id	= ID_GROUP*100 + ID_MEMBER+1;				//each player will have unique id
	mt.flags			= SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE;		//move in peace-mode only
	mt.move_step		= pendlInfo->moveStep;
	mt.HO_search_dist	= 4.0f;
	mt.HO_search_z_dist	= 1.5f;
	mt.HO_movedist_max	= pendlInfo->moveStep;
	mt.nextmove_interval= pendlInfo->tmWait;
	mt.nextmove_interval_rand = pendlInfo->tmWaitRnd;
	mt.start_delay		= pendlInfo->tmStartDelay;
	

	CLEAR(area);
	area.sphs	= 1;
	area.sph	= &sph;

	mt.target = sph.pos;
	mt.target_area = &area;

	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);

	//
	gPendlForward = bForward;
	gPathIdx = startIdx;

	//
	gMainTask = MT_PENDL;


	return TRUE;
}

//
BOOL MT_PendlContinue(sc_player pl_id, s_mtPendl *pendlInfo)
{
	dword				newPathIdx;
	s_SC_P_Ai_MainTask	mt;
	s_sphere			sph;
	s_SC_Area			area;
	dword				res;
	char				str[STR_SIZE];

	
pendlContinueLabel:

	if (!gPathIdx)
		gPendlForward = TRUE;

	newPathIdx = gPendlForward ? gPathIdx+1 : gPathIdx-1;

	//get area to get to
	sprintf(str, PND_NAME_BASE, ID_MEMBER, newPathIdx);

	res = SC_GetScriptHelper(str, &sph, NULL);
	if (res == SC_SCRIPTHELPER_TYPE_ERROR)
	{
		//dosli jsme na konec - pujdem zpet
		gPendlForward = FALSE;
		goto pendlContinueLabel;
	}


	//update index
	gPathIdx = newPathIdx;


	//Set Pendl via MainTask
	CLEAR(mt);

	mt.cooperation_id	= ID_GROUP*100 + ID_MEMBER+1;				//each player will have unique id
	mt.flags			= SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE;		//move in peace-mode only
	mt.move_step		= pendlInfo->moveStep;
	mt.HO_search_dist	= 4.0f;
	mt.HO_search_z_dist	= 1.5f;
	mt.HO_movedist_max	= pendlInfo->moveStep;
	mt.nextmove_interval= pendlInfo->tmWait;
	mt.nextmove_interval_rand = pendlInfo->tmWaitRnd;
	mt.start_delay		= pendlInfo->tmStartDelay;
	
	CLEAR(area);
	area.sphs	= 1;
	area.sph	= &sph;

	mt.target = sph.pos;
	mt.target_area = &area;


	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);

	//
	gMainTask = MT_PENDL;


	return TRUE;
}


//
BOOL MT_Hold(sc_player pl_id, float fRadius)
{
	s_SC_P_Ai_MainTask	mt;
	s_sphere			sph;
	s_SC_Area			area;


	//
	GetPlayerPos(pl_id, &sph.pos);
	sph.rad = fRadius * 1.1f;


	//Set Pendl via MainTask
	CLEAR(mt);

	mt.cooperation_id	= ID_GROUP*100 + ID_MEMBER+1;				//each player will have unique id
	mt.flags			= SC_P_AI_MAINTASK_FL_PERMANENT;
	mt.move_step		= fRadius;
	mt.HO_search_dist	= fRadius;
	mt.HO_search_z_dist	= 2.0f;
	mt.HO_movedist_max	= fRadius * 1.5f;
	mt.nextmove_interval= 0.01f;
	mt.nextmove_interval_rand = 0.01f;
	mt.start_delay		= 0.01f;
	
	CLEAR(area);
	area.sphs	= 1;
	area.sph	= &sph;

	mt.target = sph.pos;
	mt.target_area = &area;


	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);

	//
	gMainTask = MT_HOLD;


	return TRUE;
}

//
BOOL MT_Attack(sc_player pl_id, s_mtAttack *mtAttack)
{
	s_SC_P_Ai_MainTask	mt;
	s_sphere			sph;
	s_SC_Area			area;


	//Set Attack via MainTask
	CLEAR(mt);

	mt.cooperation_id	= ID_GROUP*100 + ID_MEMBER+1;				//each player will have unique id
	mt.flags			= SC_P_AI_MAINTASK_FL_ALLOW_MOVE_TO_NOCOVER | SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST | SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE_AWAY_FROM_ENEMIES;
	mt.move_step		= mtAttack->moveStep;
	mt.HO_search_dist	= 7.0f;
	mt.HO_search_z_dist	= 0;
	mt.HO_movedist_max	= mtAttack->moveStep * 1.5f;
	mt.nextmove_interval= mtAttack->tmWait;
	mt.nextmove_interval_rand = mtAttack->tmWaitRnd;
	mt.start_delay		= mtAttack->tmStartDelay;

	//
	sph.pos = mtAttack->pos;
	sph.rad = 7.0f;

	CLEAR(area);
	area.sphs	= 1;
	area.sph	= &sph;

	mt.target = sph.pos;
	mt.target_area = &area;

	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);


	//
	gMainTask = MT_ATTACK;


	return TRUE;
}


//
BOOL MT_Follow(sc_player pl_id, sc_player plTarget, dword coopID, float movePerc, float moveStep)
{
	s_SC_P_Ai_MainTask	mt;


	//
	if (!coopID)
	{
		SC_message("MT_Follow(): coopID = 0! Can't set MainTask.");
		return FALSE;
	}

	//Set follow via MainTask
	CLEAR(mt);

	mt.cooperation_id		= coopID;
	mt.flags				= SC_P_AI_MAINTASK_FL_ALLOW_MOVE_TO_NOCOVER | SC_P_AI_MAINTASK_FL_PERMANENT;
	mt.target_pl			= plTarget;
	mt.target_area			= NULL;
	mt.move_step			= moveStep;
	mt.HO_search_dist		= 6.0f;
	mt.HO_search_z_dist		= 0.0f;
	mt.HO_movedist_max		= mt.HO_search_dist * 2;
	mt.max_target_pl_dist	= 3.0f;
	mt.max_target_pl_z_dist	= 1.0f;
	mt.min_enemy_dist		= 3.0f;
	mt.max_enemy_dist		= 0;
	mt.min_danger_dist		= 0;
	mt.max_danger_dist		= 0;
	mt.last_perc_in_group_moves	= movePerc;
	mt.max_pc_distance		= 0.0f;

	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);


	//
	gMainTask = MT_ATTACK;


	return TRUE;
}

//Used for 'synchronized', tactical movement of soldiers
BOOL MT_Move(sc_player pl_id, s_mtMove *mtMove)
{
	s_SC_P_Ai_MainTask	mt;
	s_SC_Area			area;


	//Set move via MainTask
	CLEAR(mt);

	mt.cooperation_id		= mtMove->coopId;
	mt.flags				= SC_P_AI_MAINTASK_FL_NOMOVE_WHEN_CHECKING_FAKEDANGER | SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE_AWAY_FROM_DANGERS;//maybe SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST
	mt.move_step			= mtMove->moveStep;
	mt.HO_search_dist		= 8.0f; //(mtMove->moveStep > 12.0f) ? (mtMove->moveStep / 2) : (7.0f);
	mt.HO_search_z_dist		= 0;
	mt.HO_movedist_max		= mt.HO_search_dist * 2;
	mt.min_enemy_dist		= 3.0f;
	mt.last_perc_in_group_moves	= mtMove->movePerc;
	mt.start_delay			= mtMove->tmStartDelay;
	mt.nextmove_interval	= mtMove->tmWait;
	mt.nextmove_interval_rand = mtMove->tmWaitRnd;

	CLEAR(area);
	area.boxes	= 1;
	area.box	= &mtMove->targetBox;

	mt.target = area.box->pos;
	mt.target_area = &area;


	//set MainTask
	SC_P_Ai_SetMainTask(pl_id, &mt);


	//
	gMainTask = MT_MOVE;


	return TRUE;
}


//
BOOL MT_Delete(sc_player pl_id)
{
	s_SC_P_Ai_MainTask	mt;


	//Delete MT
	CLEAR(mt);
	SC_P_Ai_SetMainTask(pl_id, &mt);

	//
	gMainTask = MT_NONE;


	return TRUE;
}



// ************************************************************************************************************************************** //
//													Miscelaneous utility functions
// ************************************************************************************************************************************** //


//simplified one-line version of SC_P_Ai_SetWatchShoot() for the most common use
BOOL WatchShoot(sc_player pl_id, c_Vector3 *pos, float time, BOOL bShoot)
{
	s_SC_P_AI_WatchShoot	ws;


	if (!pl_id)
		return FALSE;

	//cancel ws
	if (!pos || time <= 0)
	{
		SC_P_Ai_SetWatchShoot(pl_id, NULL);
		return TRUE;
	}

	//
	CLEAR(ws);
	ws.flags	= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT | ((bShoot) ? SC_P_AI_WATCHSHOOT_FL_SHOOT : 0);
	ws.pos		= *pos;
	ws.time		= time;

	SC_P_Ai_SetWatchShoot(pl_id, &ws);

	return TRUE;
}

//simplified one-line version of SC_P_Ai_SetWatchShoot() for shooting on players
BOOL WatchShoot(sc_player pl_id, sc_player target, float time, BOOL bShoot)
{
	s_SC_P_AI_WatchShoot	ws;


	if (!pl_id)
		return FALSE;

	//cancel ws
	if (!target || time <= 0)
	{
		SC_P_Ai_SetWatchShoot(pl_id, NULL);
		return TRUE;
	}

	//
	CLEAR(ws);
	ws.flags	= SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT | ((bShoot) ? SC_P_AI_WATCHSHOOT_FL_SHOOT : 0);
	ws.player	= target;
	ws.time		= time;

	SC_P_Ai_SetWatchShoot(pl_id, &ws);

	return TRUE;
}

