// ************************************************************************************************************************ //
//	
//	File:			hPcPlaySnd.cxx
//	Description:	Script helper: plays specified sound/music when PC player is in the area
//	Author:			Beny
//	
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//
#ifndef	TM_NEXT_EXEC
#define	TM_NEXT_EXEC	0.3f
#endif



//
dword			gPhase = GP_START;
dword			type = SC_SCRIPTHELPER_TYPE_ERROR;
s_sphere		sph;
c_BoxOriented	box;
float			g_tmNextExec = TM_NEXT_EXEC;




//
int ScriptMain(s_SC_ScriptHelper_info *info)
{
	c_Vector3	vec;
	s_SC_PC_Control	pcCtrl;


	//
	info->next_exe_time = g_tmNextExec;

	//
	switch(info->event_type)
	{
	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		switch(gPhase)
		{
		case GP_START:
			if ( !SC_PC_Get() )
				return TRUE;

			switch(type)
			{
			case SC_SCRIPTHELPER_TYPE_SPHERE:
				//test collision with PC player
				GetPlayerPos( SC_PC_Get(), &vec);

				if ( SC_IsNear3D(&sph.pos, &vec, sph.rad) )
				{
					#ifdef PLAY_SOUND2D
						SC_SND_PlaySound2D(PLAY_SOUND2D);
					#endif

					#ifdef PLAY_SOUND3D
					#ifdef PLAY_SOUND3D_POS
						GetDummyPos(PLAY_SOUND3D_POS, &vec);
						SC_SND_PlaySound2D(PLAY_SOUND3D, &vec);
					#endif
					#endif

					#ifdef PLAY_MUSIC
						SC_Music_Play(PLAY_MUSIC, NULL);
					#endif

					gPhase = GP_IDLE;
				}
				break;

			case SC_SCRIPTHELPER_TYPE_BOX:
				//test collision with PC player
				GetPlayerPos( SC_PC_Get(), &vec);

				if ( SC_BoxOriented_ColPoint(&box, &vec) )
				{
					#ifdef PLAY_SOUND2D
						SC_SND_PlaySound2D(PLAY_SOUND2D);
					#endif

					#ifdef PLAY_SOUND3D
					#ifdef PLAY_SOUND3D_POS
						GetDummyPos(PLAY_SOUND3D_POS, &vec);
						SC_SND_PlaySound2D(PLAY_SOUND3D, &vec);
					#endif
					#endif

					#ifdef PLAY_MUSIC
						SC_Music_Play(PLAY_MUSIC, NULL);
					#endif

					gPhase = GP_IDLE;
				}
				break;

			default:
				SC_message("Can't get info about ScriptHelper: '%s'!", info->nod_name);
				gPhase = GP_IDLE;
				break;
			}
			break;

		case GP_IDLE:
			info->next_exe_time = 1.0f;
			break;
		}
		break;

	case SC_SCRHELPER_EVENTTYPE_MSG:
		break;


	case SC_SCRHELPER_EVENTTYPE_INIT:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);
		break;

	case SC_SCRHELPER_EVENTTYPE_RELEASE:
		break;

	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);
		break;

	}

	return TRUE;
}
