// ************************************************************************************************************************ //
//																															//
//	File:			hPcTrigger.cxx																							//
//	Description:	Common ScriptHelper Script. Specified Level/Player message is sent when player gets inside the SH area.	//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//
#ifndef	TM_NEXT_EXEC
#define	TM_NEXT_EXEC	0.3f
#endif


//
dword			gPhase = GP_START;
dword			type = SC_SCRIPTHELPER_TYPE_ERROR;
s_sphere		sph;
c_BoxOriented	box;
float			g_tmNextExec = TM_NEXT_EXEC;

//
dword	g_hManm = NULL, g_iCamera = NULL;
float	g_tmAnmLen = 0, g_tmAnmCurTime = 0;
s_SC_PC_Control	g_pcCtrl;


//
int ScriptMain(s_SC_ScriptHelper_info *info)
{
	c_Vector3	vec;
	s_SC_PC_Control	pcCtrl;


	//
	info->next_exe_time = g_tmNextExec;

	//
	switch(info->event_type)
	{
	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		switch(gPhase)
		{
		case GP_START:

#ifdef	SH_START_INACTIVE				//if #defined, the ScriptHelper is inactive on the beginning. It can be activated by 
			gPhase = GP_IDLE;
			break;
#else
			gPhase = GP_CHECK;
			break;
#endif


		case GP_CHECK:
			if ( !SC_PC_Get() )
				return TRUE;

			switch(type)
			{
			case SC_SCRIPTHELPER_TYPE_SPHERE:
				//test collision with PC player
				GetPlayerPos( SC_PC_Get(), &vec);

				if ( SC_IsNear3D(&sph.pos, &vec, sph.rad) )
				{
					//
					#ifdef SEND_MSG_TO_LEVEL
						SC_LevelScriptMsg(SCM_SH_TRIGGERED, SEND_MSG_TO_LEVEL);
					#endif

					//
					#ifdef SEND_MSG_TO_PLAYER
						SC_P_ScriptMessage(SC_PC_Get(), SCM_SH_TRIGGERED, SEND_MSG_TO_PLAYER);
					#endif


					//Camera animation
					#ifdef CAM_ANIM_FILE
						gPhase = GP_CAMANIM_START;
					#else
						gPhase = GP_IDLE;
					#endif //CAM_ANIM_FILE
				}
				break;

			case SC_SCRIPTHELPER_TYPE_BOX:
				//test collision with PC player
				GetPlayerPos( SC_PC_Get(), &vec);

				if ( SC_BoxOriented_ColPoint(&box, &vec) )
				{
					//
					#ifdef SEND_MSG_TO_LEVEL
						SC_LevelScriptMsg(SCM_SH_TRIGGERED, SEND_MSG_TO_LEVEL);
					#endif

					//
					#ifdef SEND_MSG_TO_PLAYER
						SC_P_ScriptMessage(SC_PC_Get(), SCM_SH_TRIGGERED, SEND_MSG_TO_PLAYER);
					#endif

					//Camera animation
					#ifdef CAM_ANIM_FILE
						gPhase = GP_CAMANIM_START;
					#else
						gPhase = GP_IDLE;
					#endif //CAM_ANIM_FILE
				}
				break;

			default:
				SC_message("Can't get info about ScriptHelper: '%s'!", info->nod_name);
				gPhase = GP_IDLE;
				break;
			}
			break;

	#ifdef CAM_ANIM_FILE
		case GP_CAMANIM_START:
			//Retrieve info about camera
			g_hManm = SC_MANM_Create(CAM_ANIM_FILE);
			g_iCamera = SC_MANM_GetIndex(g_hManm, CAM_CAMERA_NAME);
			g_tmAnmLen = SC_MANM_GetLength(g_hManm, g_iCamera);
			g_tmAnmCurTime = 0;

			//Store and disable PC controls
			SC_PC_GetControl(&g_pcCtrl);
			CLEAR(pcCtrl);
			SC_PC_SetControl(&pcCtrl);

			g_tmNextExec = 0;
			gPhase = GP_CAMANIM_PLAY;
  			break;

		case GP_CAMANIM_PLAY:
			if (g_tmAnmCurTime < g_tmAnmLen)
			{
				SC_MANM_Camera_Set(g_hManm, g_iCamera, g_tmAnmCurTime);

				g_tmAnmCurTime += info->elapsed_time;
				info->next_exe_time = 0.0f;
			}
			else
			{
				//set back PC control
				SC_PC_SetControl(&g_pcCtrl);

				//send message to level.c after animation
				#ifdef SEND_MSG_AFTER_ANIM
					SC_LevelScriptMsg(SCM_SH_ANIMEND, SEND_MSG_AFTER_ANIM);
				#endif

				g_tmNextExec = 1.0f;
				gPhase = GP_IDLE;
			}
			break;
	#endif //CAM_ANIM_FILE


		case GP_IDLE:
			info->next_exe_time = 1.0f;
			break;
		}
		break;

	case SC_SCRHELPER_EVENTTYPE_MSG:
		switch(info->param1)
		{
		case SCM_SH_START:
			gPhase = GP_CHECK;
			break;

		case SCM_SH_STOP:
			gPhase = GP_IDLE;
			break;
		}
		break;


	case SC_SCRHELPER_EVENTTYPE_INIT:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);
		break;

	case SC_SCRHELPER_EVENTTYPE_RELEASE:
		break;

	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);
		break;

	}

	return TRUE;
}
