// ************************************************************************************************************************ //
//																															//
//	File:			hPlayAnim.cxx																							//
//	Description:	Common ScriptHelper Script. Specified set of animations is played when SCM_PLAYANIM is received.		//
//	Author:			Beny																									//
//																															//
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//
#ifndef	TM_NEXT_EXEC
#define	TM_NEXT_EXEC	1.0f
#endif


//
dword			gPhase = GP_START;
float			g_tmNextExec = TM_NEXT_EXEC;

//
dword	g_hManm = NULL, g_iCamera = NULL;
float	g_tmAnmLen = 0, g_tmAnmCurTime = 0;
s_SC_PC_Control	g_pcCtrl;


//
int ScriptMain(s_SC_ScriptHelper_info *info)
{
	c_Vector3	vec;
	s_SC_PC_Control	pcCtrl;


	//
	info->next_exe_time = g_tmNextExec;

	//
	switch(info->event_type)
	{
	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		switch(gPhase)
		{
		case GP_START:
			gPhase = GP_IDLE;
			break;

	#ifdef CAM_ANIM_FILE
		case GP_CAMANIM_START:
			//Retrieve info about camera
			g_hManm = SC_MANM_Create(CAM_ANIM_FILE);
			g_iCamera = SC_MANM_GetIndex(g_hManm, CAM_CAMERA_NAME);
			g_tmAnmLen = SC_MANM_GetLength(g_hManm, g_iCamera);
			g_tmAnmCurTime = 0;

			//Store and disable PC controls
			SC_PC_GetControl(&g_pcCtrl);
			CLEAR(pcCtrl);
			SC_PC_SetControl(&pcCtrl);

			g_tmNextExec = 0;
			gPhase = GP_CAMANIM_PLAY;
  			break;

		case GP_CAMANIM_PLAY:
			if (g_tmAnmCurTime < g_tmAnmLen)
			{
				SC_MANM_Camera_Set(g_hManm, g_iCamera, g_tmAnmCurTime);

				g_tmAnmCurTime += info->elapsed_time;
				info->next_exe_time = 0.0f;
			}
			else
			{
				//set back PC control
				SC_PC_SetControl(&g_pcCtrl);

				//send message to level.c after animation
				#ifdef SEND_MSG_AFTER_ANIM
					SC_LevelScriptMsg(SCM_SH_ANIMEND, SEND_MSG_AFTER_ANIM);
				#endif

				g_tmNextExec = 1.0f;
				gPhase = GP_IDLE;
			}
			break;
	#endif //CAM_ANIM_FILE


		case GP_IDLE:
			info->next_exe_time = 1.0f;
			break;
		}
		break;


	case SC_SCRHELPER_EVENTTYPE_MSG:
		switch(info->param1)
		{
		case SCM_SH_PLAYANIM:			//Play
			switch(info->param2)
			{
			case 0:
			default:
				info->next_exe_time = 0.0f;
				gPhase = GP_CAMANIM_START;
				break;
			}
			break;
		}
		break;


	case SC_SCRHELPER_EVENTTYPE_INIT:
		break;

	case SC_SCRHELPER_EVENTTYPE_RELEASE:
		break;

	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		break;

	}

	return TRUE;
}
