// ************************************************************************************************************************ //
//	
//	File:			hPlayPtc.cxx
//	Description:	Script helper: plays specified particle after the message is sent
//	Author:			Beny
//	
// ************************************************************************************************************************ //


#include <inc\b&a\Common.cxx>


//
#ifndef	TM_NEXT_EXEC
#define	TM_NEXT_EXEC	1.0f
#endif



//
dword			gPhase = GP_IDLE;
dword			type = SC_SCRIPTHELPER_TYPE_ERROR;
s_sphere		sph;
c_BoxOriented	box;
c_Vector3		pos;
float			g_tmNextExec = TM_NEXT_EXEC;

//
dword			g_ptcId = 0;
float			g_ptcTime = 0;


//
int ScriptMain(s_SC_ScriptHelper_info *info)
{
	c_Vector3	vec;
	s_SC_PC_Control	pcCtrl;


	//
	info->next_exe_time = g_tmNextExec;

	//
	switch(info->event_type)
	{
	case SC_SCRHELPER_EVENTTYPE_TIMETICK:
		switch(gPhase)
		{
		case GP_START:
			break;

		case GP_REPEAT:
			info->next_exe_time = g_ptcTime;

			SC_CreatePtcVec_Ext(g_ptcId, &pos, g_ptcTime, 0, 1.0f, 1.0f);
			break;

		case GP_IDLE:
			info->next_exe_time = 1.0f;
			break;
		}
		break;

	case SC_SCRHELPER_EVENTTYPE_MSG:
		switch(info->param1)
		{
		case SCM_SH_PLAYPTC:
			g_ptcId = info->param2;
			g_ptcTime = info->param3;

			#ifdef	PTC_REPEAT
				info->next_exe_time = 0.0f;
				gPhase = GP_REPEAT;
			#else
				SC_CreatePtcVec_Ext(g_ptcId, &pos, g_ptcTime, 0, 1.0f, 1.0f);
			#endif
			break;

		case SCM_SH_STOPPTC:
			info->next_exe_time = 0.01f;
			gPhase = GP_IDLE;
			break;
		}
		break;


	case SC_SCRHELPER_EVENTTYPE_INIT:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);

		switch(type)
		{
		case SC_SCRIPTHELPER_TYPE_SPHERE:	pos = sph.pos; break;
		case SC_SCRIPTHELPER_TYPE_BOX:		pos = box.pos; break;
		default:
			SC_message("hPlayPtc.cxx error: can't get ScriptHelper (%s)", info->nod_name);
			break;
		}
		break;

	case SC_SCRHELPER_EVENTTYPE_RELEASE:
		break;

	case SC_SCRHELPER_EVENTTYPE_JUSTLOADED:
		//get ScriptHelper properties
		type = SC_GetScriptHelper(info->nod_name, &sph, &box);

		switch(type)
		{
		case SC_SCRIPTHELPER_TYPE_SPHERE:	pos = sph.pos; break;
		case SC_SCRIPTHELPER_TYPE_BOX:		pos = box.pos; break;
		default:
			SC_message("hPlayPtc.cxx error: can't get ScriptHelper (%s)", info->nod_name);
			break;
		}
		break;

	}

	return TRUE;
}
