/////////////////////////////
// library include file    //
// by h0nza                //
/////////////////////////////

#ifndef SC_GLOBAL_H
  #include <inc\sc_global.h>
#endif
#include <inc\sc_def.h>
#ifndef LEVEL_H
  #include "level.h"
#endif
#include <inc\all\ai.cxx>

#ifndef IMPRECISION
  #define IMPRECISION 0.6f
#endif

#define TEAM 0

#ifndef RANK
	#define RANK RNK_3
#endif

#ifndef CLS
	#define CLS CLS_SOLDIER
#endif

#ifndef SCLS
	#define SCLS 0
#endif


#ifndef VC
  #ifndef CIVIL
    #define SIDE SC_P_SIDE_US
  #else
    #define SIDE SC_P_SIDE_NEUTRAL
  #endif
#else
  #define SIDE SC_P_SIDE_VC
#endif

#ifndef GROUP
  #define GROUP  0
#endif

#ifndef MEMBERID
  #define MEMBERID SC_P_CREATE_MEMID_AUTO
#endif
/*
#ifndef MAINGUN
  #ifdef VC
    #define MAINGUN 2
  #else
    #define MAINGUN 21
  #endif
#endif
*/

#ifndef GUN2
  #define GUN2 0
#endif

#ifndef PISTOL
  #define PISTOL 0
#endif

#define GetLevelPhase SC_ggi(SGI_LEVELPHASE)

#ifndef MAXOBJECTIVES
  #define MAXOBJECTIVES 15
#endif

#define MISSION_FAILED		  SC_MissionEnd(SC_MISSIONEND_TYPE_FAILED)
#define MISSION_FINISHED	  SC_MissionEnd(SC_MISSIONEND_TYPE_FINISHED)
#define MISSION_DONE		  	SC_MissionEnd(SC_MISSIONEND_TYPE_DONE_FADE)
#define MISSION_DONEFADE	  SC_MissionEnd(SC_MISSIONEND_TYPE_DONE_IMMEDIATELY)

typedef struct
{
  dword id[10];
}fd_id;


#ifndef	__PLAYER_H__
	int                    gPhase=0;
#endif

float                  time;
s_SC_P_Ai_MainTask     mt;

s_SC_SP_Objective		   gObjectives[MAXOBJECTIVES];			//objectives
int						         gObjcount=0;						          //objectives count



/*-----------------------------------abs--------------------------------------*/
#ifndef MAX_DEFS_H

float abs(float num)
{
	if (num > 0)
    return num;
  else
    return -num;
}

#endif
/*----------------------------------------------------------------------------*/

/*--------------------------------GetHO------------------------------------*/
dword GetHO(char *helper)            
{
  s_sphere        sphere;
  c_BoxOriented   box;
  c_Vector3       tar;
  s_SC_Area       ar;
  dword           type;
  dword           HO;

  CLEAR(sphere);
  CLEAR(box);
  CLEAR(ar);


  switch (SC_GetScriptHelper(helper, &sphere, &box))
  {
  	case SC_SCRIPTHELPER_TYPE_SPHERE:
  		ar.sphs = 1;
      ar.sph = &sphere;
  		break;
  	case SC_SCRIPTHELPER_TYPE_BOX:
  		ar.boxes = 1;
      ar.box = &box;
  		break;
  }

  
  HO = SC_GetRndHideout(&ar, SC_GETHIDEOUT_FL_EMPTYONLY, &tar);

  return HO;
}
/*----------------------------------------------------------------------------*/


/*--------------------------------GetHOPos------------------------------------*/
void GetHOPos(char *helper, s_SC_Area *area, c_Vector3 *tar)            //area can be NULL
{
  s_sphere        sphere;
  c_BoxOriented   box;
  s_SC_Area       ar;
  dword           type;
  dword           HO;

  CLEAR(sphere);
  CLEAR(box);
  CLEAR(ar);


  switch (SC_GetScriptHelper(helper, &sphere, &box))
  {
  	case SC_SCRIPTHELPER_TYPE_SPHERE:
  		ar.sphs = 1;
      ar.sph = &sphere;
      *tar = sphere.pos;
  		break;
  	case SC_SCRIPTHELPER_TYPE_BOX:
  		ar.boxes = 1;
      ar.box = &box;
      *tar = box.pos;
  		break;
  }

  /*if ((sphere.pos.x == 0) && (sphere.pos.y == 0) && (sphere.pos.z == 0))
  {
    ar.boxes = 1;
    ar.box = &box;
  }
  else
  {
    ar.sphs = 1;
    ar.sph = &sphere;
  } */


  if (!SC_GetRndHideout(&ar, SC_GETHIDEOUT_FL_EMPTYONLY, tar))
  {
    SC_Log(1,"Error, hideout not found, helpername %s",helper);
//    GetHOPos(helper, area);
  }

/*  if (HO == NULL)
    SC_message("Zadny rnd HO"); */

  if (area != NULL)
    *area = ar;

//  return tar;
}
/*----------------------------------------------------------------------------*/

//Get position of dummy
BOOL GetNODPos(char *name, c_Vector3 *vec)
{
	sc_nod	node;

	node = SC_NOD_GetNoMessage(NULL, name);
	if (!node)
		return FALSE;

	SC_NOD_GetWorldPos(node, vec);

	return TRUE;
}

/*--------------------------------GetNODPos-----------------------------------
c_Vector3 GetNODPos(char *helper)
{
  c_Vector3    pos;

  SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(helper), &pos);

  return pos;
}
/*----------------------------------------------------------------------------*/

/*--------------------------------InitSide------------------------------------*/
void InitSide(dword side, dword groups)
{
  s_SC_InitSide       inside;

  CLEAR(inside);

  inside.side_id = side;
  inside.max_groups = groups;

  SC_InitSide(&inside);
  SC_SetSideAlly(0, 1, TRUE);
}
/*----------------------------------------------------------------------------*/
void SetMedik(sc_player pl) 
{
	s_SC_P_Ai_Medik		medik_props;
	s_SC_P_AmmoRedefine	redefine;
	s_SC_PC_CmdMenu		menu;

	CLEAR(redefine);
	redefine.ammo_type = 22; //23 pro ing.
	redefine.max_ammo  = 1000;
	SC_P_AmmoRedefine_Add(pl, &redefine);

	SC_AMMO_Set(pl, 22, 1000);

	CLEAR(medik_props);
	SC_P_Ai_Medik_GetProps(pl, &medik_props);
	medik_props.battle.hp_percentage	= 0.2;
	medik_props.battle.range			= 100.0;
	medik_props.peace.hp_percentage		= 0.7;
	medik_props.peace.range				= 100.0;
	SC_P_Ai_Medik_SetProps(pl, &medik_props);

	CLEAR(menu);
	SC_PC_GetCommandMenu(&menu);
	menu.flags |= SC_PC_CMDMENU_FL_ENABLEMEDIC;
	menu.medik_max_call_distance = 60.0;
	SC_PC_SetCommandMenu(&menu);
}

void SetEng(sc_player pl) 
{
	s_SC_P_AmmoRedefine	redefine;
	s_SC_PC_CmdMenu		menu;

	CLEAR(redefine);
	redefine.ammo_type = 23; //22 pro medik
	redefine.max_ammo  = 1000;
	SC_P_AmmoRedefine_Add(pl, &redefine);

	SC_AMMO_Set(pl, 23, 1000);

	CLEAR(menu);
	SC_PC_GetCommandMenu(&menu);
	menu.flags |= SC_PC_CMDMENU_FL_ENABLEAMMO;
	menu.ammo_max_call_distance = 60.0;
	SC_PC_SetCommandMenu(&menu);
}

/*------------------------------CreatePlayer----------------------------------*/
void CreatePlayer(s_SC_Pscript_info *info)
{
  s_SC_P_Create        create_info;
  s_SC_P_RespawnPos    resp_pos;
  s_SC_Plscr_info      plscr_info;
  s_SC_P_CreateWeap    weap[6];
  int                  weap_count;
  s_SC_P_AmmoRedefine	 amred[1];
  s_PlayerIniEqp       iniEqp;


  CLEAR(plscr_info);
  CLEAR(iniEqp);

	SC_PlScr_GetInfo(info->script, &plscr_info);

  CLEAR(resp_pos);
	
  CLEAR(weap);

  #ifdef RESPNOD
    SC_NOD_FillRespawnPos(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(RESPOBJ), RESPNOD), &resp_pos);
  #else
    SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
  #endif

  CLEAR(create_info);
  create_info.script = info->script;

  #ifdef PC
    create_info.type = SC_P_CREATE_TYPE_PC;
  #else
    create_info.type = SC_P_CREATE_TYPE_AI;
  #endif

  create_info.flags = SC_P_CREATE_FL_GENERATE_AI_BLOCKER;
  
	#ifdef FLAGS
    create_info.flags |= FLAGS;
  #endif
    

  create_info.side = SIDE;
  create_info.group =  GROUP;
  create_info.member_id =  MEMBERID;
                                                                                                             
  #ifdef NAMENR
    create_info.name_nr = NAMENR;
    switch(NAMENR)
    {
			case 2701:
				create_info.genvoice_group = "Cobber";
				break;
			case 2702:
				create_info.genvoice_group = "Dutch";
				break;
			case 2703:
				create_info.genvoice_group = "Stone";
				break;
			case 2704:
				create_info.genvoice_group = "Tommyboy";
				break;
		}
  #else
    #ifdef ANSINAME
      create_info.name_ansi =  ANSINAME;
    #else
      #ifdef VC
        create_info.name_ansi =  "VC soldier";
      #else
        create_info.name_ansi =  "US soldier";
      #endif
    #endif
  #endif

  create_info.name_unicode = NULL;

  #ifdef CLASNAME
    create_info.class_name_id = CLASNAME;
  #endif

  #ifdef PC
    #ifdef VC
			#ifndef MAINGUN
				#define MAINGUN 2
			#endif
      create_info.inifile = "cvp_pvc03";
      create_info.head_name = "hvm_001";
      create_info.eqp_inifile = "g\\characters\\cvp_pvc03\\minh\\eqp.ini";
    	create_info.head_eqp_inifile = "g\\characters\\_heads\\_eqpini\\vhg002.ini";
    #else
      #ifndef MAINGUN
				#define MAINGUN 47
			#endif
      create_info.inifile = "cup_boone01";
      create_info.head_name = "hwm_012";
      create_info.eqp_inifile = "g\\characters\\cup_boone01\\basic\\eqp.ini";
      create_info.head_eqp_inifile = "g\\characters\\_heads\\_eqpini\\uhg001.ini";
    #endif
  #else
/*    	#ifndef MAINGUN
    		#define MAINGUN 60
    	#endif  */
    #ifdef VC
			vcGetPlayerIniEqp(RANK,CLS,SCLS,&iniEqp);
    #else
			usGetPlayerIniEqp(RANK,CLS,SCLS,&iniEqp);
    #endif

		create_info.inifile = iniEqp.bodyIni;
    create_info.head_name = iniEqp.headIni;
    create_info.eqp_inifile = iniEqp.bodyEqp;
    create_info.head_eqp_inifile = iniEqp.headEqp;

    #ifdef INIFILE
      create_info.inifile = INIFILE;
		#endif
  	#ifdef HEAD
			create_info.head_name = HEAD;
		#endif
    #ifdef EQP
			create_info.eqp_inifile = EQP;
		#endif
    #ifdef HEADEQP
			create_info.head_eqp_inifile = HEADEQP;
		#endif
  #endif

  #ifdef CROUCH
  	resp_pos.flags = SC_P_RESPPOS_FL_CROUCH;
	#endif
  
  
	#ifndef RESPAWNGPHASE
    create_info.respawn = &resp_pos;
  #endif



#ifdef MAINGUN
  if (MAINGUN != 0)
 	{
  	create_info.weapons = 1;
		weap[create_info.weapons-1].weap_id = MAINGUN;
	}
#else
  create_info.weapons = 1;
  weap[create_info.weapons-1].weap_id = iniEqp.weapon;
#endif

  if (PISTOL != 0)
  {
    create_info.weapons = create_info.weapons+1;
		weap[create_info.weapons-1].weap_id = PISTOL;
  }
  
  if (GUN2 != 0)
  {
    create_info.weapons = create_info.weapons+1;
		weap[create_info.weapons-1].weap_id = GUN2;
  }

#ifdef MEDIK
		create_info.weapons = create_info.weapons+1;
  	weap[create_info.weapons-1].weap_id=60;
  	
/*  	amred[0].ammo_type = 22;				//medkit 'ammo'
  	amred[0].max_ammo = 1000;				//ammo amount
  	create_info.ammo_redefines = 1;
  	create_info.ammo_redefine = amred;		*/
//  	SetMedik(info->player);
#endif

#ifdef ENGINEER
  	create_info.weapons = create_info.weapons+1;
  	weap[create_info.weapons-1].weap_id=61;

/*  	amred[0].ammo_type = 23;				//'ammo'
  	amred[0].max_ammo = 1000;				//ammo amount
  	create_info.ammo_redefines = 1;
  	create_info.ammo_redefine = amred;	*/
//  	SetEng(info->player);
#endif


#ifdef C4
    create_info.weapons = create_info.weapons+1;
    weap[create_info.weapons-1].weap_id = 67;
#endif  

#ifdef MEDKIT
    create_info.weapons = create_info.weapons+1;
    weap[create_info.weapons-1].weap_id = 60;
#endif

#ifdef KNIFE
    create_info.weapons = create_info.weapons+1;
    weap[create_info.weapons-1].weap_id = KNIFE;
#endif


  create_info.weap = weap;


  create_info.weap_select_tweap = weap[1].weap_id;

  SC_P_Create(&create_info);
}
/*----------------------------------------------------------------------------*/

/*-----------------------------ReleaseMainTask--------------------------------*/
void ReleaseMainTask(sc_player plid)
{
  s_SC_P_Ai_MainTask  task;
  CLEAR(task);

  SC_P_Ai_SetMainTask(plid, &task);
}
/*----------------------------------------------------------------------------*/

void PCGetPos(c_Vector3 *pos)
{
  s_SC_P_status    stat;
  c_Vector3				 vec;

  CLEAR(stat);

  SC_P_GetHeadPos(SC_PC_Get(), &vec);
  
  vec.z = vec.z - 1.2;
  vec.x = vec.x + frnd(2);
  vec.y = vec.y + frnd(2);
//	SC_P_GetStatus(SC_PC_Get(), &stat);

	*pos = vec;

//	return pos;
}

void MoveNearPC(sc_player pl, dword msg)
{
	c_Vector3      pos1, pos2;
	
	SC_P_GetHeadPos(SC_PC_Get(), &pos1);
	SC_P_GetHeadPos(pl, &pos2);
	
	
}

/*-----------------------------MainTaskFollow---------------------------------*/
void MainTaskFollow(sc_player pl, sc_player tpl, dword coopid, dword fl, float movestep, float searchdist, float searchzdist, float movedist, float pldist, float plzdist, float pcdist)
{
//  s_SC_P_Ai_MainTask  mt;

  CLEAR(mt);
  mt.cooperation_id = coopid;
  mt.flags = fl;

  mt.target_pl = tpl;

  if (movestep < 0)
    mt.move_step = 0;
  else
    mt.move_step = movestep;

  if (searchdist < 0)
    mt.HO_search_dist = 5;
  else
    mt.HO_search_dist = searchdist;

  if (searchzdist < 0)
    mt.HO_search_z_dist = 2;
  else
    mt.HO_search_z_dist = searchzdist;

  if (movedist < 0)
    mt.HO_movedist_max = 0.0f;
  else
    mt.HO_movedist_max = movedist;

  if (pldist < 0)
    mt.max_target_pl_dist = 5;
  else
    mt.max_target_pl_dist = pldist;

  if (plzdist < 0)
    mt.max_target_pl_z_dist = 4;
  else
    mt.max_target_pl_z_dist = plzdist;

  if (pcdist < 0)
    mt.max_pc_distance = 0;
  else
    mt.max_pc_distance = pcdist;

  mt.nextmove_interval		= 1.0;
	mt.nextmove_interval_rand = 1.0;

  SC_P_Ai_SetScriptMode(pl, FALSE);
  SC_P_Ai_SetMainTask(pl, &mt);
}
/*----------------------------------------------------------------------------*/

/*-------------------------------MainTaskGoTo---------------------------------*/
void MainTaskGoTo(sc_player pl, char *helper, dword coopid, dword fl, float movestep, float searchdist, float searchzdist, float movedist, float minenemy, float maxenemy, float mindanger, float maxdanger, float lastperc)
{
//  s_SC_P_Ai_MainTask    mt;
  s_SC_Area             area;
  c_Vector3             vec;
  s_SC_P_status         stat;
//  s_sphere              sp;

  CLEAR(area);
  CLEAR(mt);

  mt.cooperation_id = coopid;
  mt.flags = fl;

  if (strcmp(helper, "player") == 0)     //cilem neni misto, ale player
  {
    SC_P_GetStatus(SC_PC_Get(), &stat);
/*    area.sphs = 1;
    sp.pos = stat.pos;
    sp.rad = 5.0;     //v okruhu X m od playera se hleda HO
    area.sph = &sp;
    SC_GetRndHideout(&area, SC_GETHIDEOUT_FL_EMPTYONLY, &vec);
    mt.target = vec;
    mt.target_area = &area; */
    mt.target = stat.pos;
    mt.nextmove_interval		= 1.0;
	  mt.nextmove_interval_rand = 1.0;
  }
  else
  {
    GetHOPos(helper, &area, &vec);
		mt.target = vec;
    mt.target_area = &area;
  }

  if (movestep < 0.0)
    mt.move_step = 0.0;
  else
    mt.move_step = movestep;

  if (searchdist < 0.0)
    mt.HO_search_dist = 5.0;
  else
    mt.HO_search_dist = searchdist;

  if (searchzdist < 0.0)
    mt.HO_search_z_dist = 2.0;
  else
    mt.HO_search_z_dist = searchzdist;

  if (movedist < 0.0)
    mt.HO_movedist_max = 0.0;
  else
    mt.HO_movedist_max = movedist;

  if (minenemy < 0.0)
    mt.min_enemy_dist = 15.0;
  else
    mt.min_enemy_dist = minenemy;

  if (maxenemy < 0.0)
    mt.max_enemy_dist = 4.0;
  else
    mt.max_enemy_dist = maxenemy;

  if (mindanger < 0.0)
    mt.min_danger_dist = 15.0;
  else
    mt.min_danger_dist = mindanger;

  if (maxdanger < 0.0)
    mt.max_danger_dist = 4.0;
  else
    mt.max_danger_dist = maxdanger;

  if (lastperc < 0.0)
    mt.last_perc_in_group_moves = 0.0;
  else
    mt.last_perc_in_group_moves = lastperc;

  SC_P_Ai_SetScriptMode(pl, FALSE);
  SC_P_Ai_SetMainTask(pl, &mt);
}
/*----------------------------------------------------------------------------*/

/*-------------------------------SetMainTask----------------------------------*/
void SetMainTask(sc_player pl)
{
  s_SC_P_Ai_MainTask  maintask;

  CLEAR(maintask);

  maintask = mt;

  SC_P_Ai_SetMainTask(pl, &maintask);
}
/*----------------------------------------------------------------------------*/

/*--------------------------GroupReleaseMainTask------------------------------*/
void GroupReleaseMainTask(int side, int group)
{
  s_SC_P_Ai_MainTask  mt;
  sc_player           list[64];
  int                 num;
  int                 i;

  CLEAR(list);
  CLEAR(mt);

  num = SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_AI_ONLY);
  if (!num) return;

  for (i=0;i<num;i++)
  {
    SC_P_Ai_SetMainTask(list[i], &mt);
  }
}
/*----------------------------------------------------------------------------*/

/*--------------------------------IsTalking-----------------------------------*/
BOOL IsTalking(sc_player who)
{
	s_SC_Speech_Author	author;

	CLEAR(author);
	author.plid=who;
	return SC_Speech_IsTalking(&author);
}
/*----------------------------------------------------------------------------*/

/*-------------------------------GetTalkTime----------------------------------*/
float GetTalkTime(sc_player who)
{
	s_SC_Speech_Author	author;

	CLEAR(author);
	author.plid=who;
	return SC_Speech_GetTalkTime(&author);
}
/*----------------------------------------------------------------------------*/

/*---------------------------------SayText------------------------------------*/
void SayText(sc_player pl, char *what, dword id)
{
  ushort             buffer[512];
  s_SC_SpeechAdd     speech;

  SC_AnsiToUni(what, buffer);

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = 0;
  speech.force_authorname_text = 0;
  speech.speech_nr = 0;
  speech.speech_text = buffer;
  speech.timer_gap = 0.2f;
  SC_Speech_Add(&speech);
}
/*----------------------------------------------------------------------------*/

/*-----------------------------------Say--------------------------------------*/
float Say(sc_player pl, int what, float delay, int id)
{
  s_SC_SpeechAdd     speech;

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = 0;
  speech.force_authorname_text = 0;
  speech.speech_nr = what;
  speech.speech_text = 0;
  speech.timer = delay;
  speech.timer_gap = 0.2f;
  SC_Speech_Add(&speech);
  return speech.timer;
}
/*----------------------------------------------------------------------------*/

/*-----------------------------------Say--------------------------------------*/
float SayForce(sc_player pl, int force_id, int what, float delay, int id)
{
  s_SC_SpeechAdd     speech;

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = force_id;
  speech.force_authorname_text = 0;
  speech.speech_nr = what;
  speech.speech_text = 0;
  speech.timer = delay;
  speech.timer_gap = 0.2f;
  SC_Speech_Add(&speech);
  return speech.timer;
}
/*----------------------------------------------------------------------------*/

        
/*----------------------------------SayTo-------------------------------------*/
float SayTo(sc_player pl, sc_player to_pl, int what, float delay, int id)
{
  s_SC_SpeechAdd     speech;

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = 0;
  speech.force_authorname_text = 0;
  speech.speech_nr = what;
  speech.speech_text = 0;
  speech.timer = delay;
  speech.timer_gap = 0.2f;
  speech.sayto_pl = to_pl;
  SC_Speech_Add(&speech);
  return speech.timer;
}
/*----------------------------------------------------------------------------*/

float SayToAnim(sc_player pl, sc_player to_pl, int what, float delay, char *animfile, dword flags, int id)
{
  s_SC_SpeechAdd     speech;

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = 0;
  speech.force_authorname_text = 0;
  speech.speech_nr = what;
  speech.speech_text = 0;
  speech.timer = delay;
  speech.timer_gap = 0.2f;
  speech.sayto_pl = to_pl;

	speech.playanim_file = animfile;
	speech.playanim_flags = flags;  
	
	SC_Speech_Add(&speech);
  return speech.timer;
}


/*----------------------------------SayGen------------------------------------*/
float SayGen(sc_player pl, int what, float delay, int id)
{
  s_SC_SpeechAdd     speech;

  CLEAR(speech);
  speech.author.plid = pl;
  speech.callback_id = id;
  speech.force_authorname_id = 0;
  speech.force_authorname_text = 0;
  speech.speech_nr = what;
  speech.speech_text = 0;
  speech.timer = delay;
  speech.timer_gap = 0.2f;
  SC_Speech_Add(&speech);
  return speech.timer;
}
/*----------------------------------------------------------------------------*/

/*------------------------------SetLevelPhase---------------------------------*/
void SetLevelPhase(int tophase)
{
  int   phase;

  phase = GetLevelPhase;
  SC_Log(3,"Level gPhase changed from %d to %d", phase, tophase);
  SC_Osi("Level gPhase changed from %d to %d", phase, tophase);
  phase = tophase;
  SC_sgi(SGI_LEVELPHASE,phase);
}
/*----------------------------------------------------------------------------*/

/*----------------------------------Respawn-----------------------------------*/
void Respawn(sc_player pl, sc_plscript scr)
{
  s_SC_Plscr_info        plscr_info;
  s_SC_P_RespawnPos      resp_pos;

  CLEAR(plscr_info);
  SC_PlScr_GetInfo(scr, &plscr_info);
  CLEAR(resp_pos);
  SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
  SC_P_Respawn(pl, &resp_pos);
}
/*----------------------------------------------------------------------------*/

/*----------------------------GroupTargetRespawn------------------------------*/
void GroupTargetRespawn(int side, int group, dword flags, char *helper)
{
  s_sphere            sphere;
  s_SC_P_RespawnPos   target;
  s_SC_Area           area;
  sc_player           list[64];
  dword               num;
  c_Vector3           tar;
  int                 i;

  CLEAR(sphere);
  CLEAR(area);
  CLEAR(target);
  CLEAR(list);

  num = SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_DEADONLY | SC_ENUMPLS_FL_RESPAWNEDONLY);

  if (helper != NULL)
  {
    SC_GetScriptHelper(helper, &sphere, NULL);

    area.sphs = 1;
    area.sph = &sphere;

    SC_GetRndHideout(&area, SC_GETHIDEOUT_FL_EMPTYONLY, &tar);

    target.pos = tar;
    target.rz = 0;
  }
}
/*----------------------------------------------------------------------------*/

/*-------------------------------IsGroupDead----------------------------------*/
BOOL IsGroupDead(int side, int group)
{
  sc_player    list[64];

  CLEAR(list);

  if (SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_RESPAWNEDONLY) > 1)
    return FALSE;

  return TRUE;
}
/*----------------------------------------------------------------------------*/

BOOL GroupNearDeath(int side, int group, int pocet)
{
  sc_player    list[64];
  dword        num;

  CLEAR(list);

  num = SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_RESPAWNEDONLY);
  if ((num <= pocet) && (num > 0))
    return TRUE;

  return FALSE;
}
/*----------------------------------------------------------------------------*/


/*----------------------------------Pendl-------------------------------------*/
void Pendl(sc_player play, char *helper_base, int helper_count, BOOL back, dword msg)    //helpery musi byt pojmenovane helper_base#01, helper_base#02, atd...
{
  char        helper[64];
  c_Vector3   tar[32];
  int         i, j = 0, k;
  dword       side, group;

  CLEAR(tar);

  for(i=0;i<helper_count;i++)
  {
    CLEAR(helper);

    sprintf(helper, "%s#%02d", helper_base, i+1);

    GetHOPos(helper, NULL, &tar[i]);
    if (SC_P_GetDistancePos(play, &tar[i]) < 5.0f)
      j = i;
  }

  if (j == helper_count-1)
    back = TRUE;
  if (j == 0)
    back = FALSE;
  if (!back)
    SC_P_Ai_MoveAt(play, &tar[j+1], 0, msg);
  else
    SC_P_Ai_MoveAt(play, &tar[j-1], 0, msg+1);
}
/*----------------------------------------------------------------------------*/

BOOL AreaClear(char *helper, float radius, dword side, dword group)
{
  dword                   num;
  sc_player               pl_list[32];
  c_Vector3               posi;
  s_sphere                sphere;
  s_SC_Area               area;

  CLEAR(area);
  CLEAR(pl_list);

  SC_NOD_GetWorldPos(SC_NOD_GetNoMessage_Entity(helper), &sphere.pos);

	sphere.rad = radius;

	area.sphs = 1;
	area.sph = &sphere;

/*	area.sph.pos.x = posi.x;
	area.sph.pos.y = posi.y;
	area.sph.pos.z = posi.z;
	
	area.sph.rad = radius;  */

	num = SC_EnumPlayersArea(side, group, pl_list, 32, SC_ENUMPLS_FL_ALIVEONLY, &area);
	
	if (num)
		return FALSE;
	else
		return TRUE;
}

BOOL IsInArea(char *helper, sc_player pl)      
{
  dword                   num;
  int											x;
  sc_player               pl_list[32];
  s_sphere                sphere;
  c_BoxOriented   				box;
  s_SC_Area               ar;

  CLEAR(ar);
  CLEAR(pl_list);

  switch (SC_GetScriptHelper(helper, &sphere, &box))
  {
  	case SC_SCRIPTHELPER_TYPE_SPHERE:
  		ar.sphs = 1;
      ar.sph = &sphere;
  		break;
	 	case SC_SCRIPTHELPER_TYPE_BOX:
  		ar.boxes = 1;
      ar.box = &box;
			break;
  }

	num = SC_EnumPlayersArea(SC_P_SIDE_ALL, SC_P_GROUP_ALL, pl_list, 32, SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_PC_ONLY, &ar);
	
	for(x=0;x<num;x++)
	{
		if (pl_list[x] == pl)
			return TRUE;
	}
	
	return FALSE;
}


/*---------------------------------ShootAt------------------------------------*/
void ShootAt(sc_player pl, char *helper, float time)
{
  s_SC_P_AI_WatchShoot    shoot;
  dword                   side;
  dword                   num;
  sc_player               pl_list[32];
  s_SC_Area               area;
  c_Vector3								vec;

  CLEAR(shoot);
  CLEAR(area);
  CLEAR(pl_list);

  SC_P_GetSideGroupMemberId(pl, &side, NULL, NULL);
  switch (side)
  {
  case SC_P_SIDE_US:
    side = SC_P_SIDE_VC;
    break;
  case SC_P_SIDE_VC:
    side = SC_P_SIDE_US;
    break;
  }

  GetHOPos(helper, &area, &vec);
  num = SC_EnumPlayersArea(side, SC_P_GROUP_ALL, pl_list, 32, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY, &area);

  if (num != 0)
  {
    shoot.flags = SC_P_AI_WATCHSHOOT_FL_SHOOT | SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_WATCH | SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_SHOOT;
    shoot.player = pl_list[rand()%num];
    shoot.time = time;
    shoot.phase = SC_P_PHASE_STAND;
    shoot.aim = TRUE;
    shoot.lean = SC_P_LEAN_NONE;

    SC_P_Ai_SetWatchShoot(pl, &shoot);
  }
}
/*----------------------------------------------------------------------------*/

/*--------------------------------ShootAtPl-----------------------------------*/
void ShootAtPl(sc_player pl, sc_player tpl, float time)
{
  s_SC_P_AI_WatchShoot    shoot;

  CLEAR(shoot);

    shoot.flags = SC_P_AI_WATCHSHOOT_FL_SHOOT | SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_WATCH | SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_SHOOT;
    shoot.player = tpl;
    shoot.time = time;
    shoot.phase = SC_P_PHASE_STAND;
    shoot.aim = TRUE;
    shoot.lean = SC_P_LEAN_NONE;

    SC_P_Ai_SetWatchShoot(pl, &shoot);
}
/*----------------------------------------------------------------------------*/

/*---------------------------------ShootTo------------------------------------*/
void ShootTo(sc_player pl, char *helper, float time)
{
  s_SC_P_AI_WatchShoot    shoot;
  c_Vector3								vec;

  CLEAR(shoot);

  shoot.flags = SC_P_AI_WATCHSHOOT_FL_SHOOT;
  shoot.player = 0;
  GetHOPos(helper, NULL, &vec);
	shoot.pos = vec;
  shoot.time = time;
  shoot.phase = SC_P_PHASE_STAND;
  shoot.aim = TRUE;
  shoot.lean = SC_P_LEAN_NONE;

  SC_P_Ai_SetWatchShoot(pl, &shoot);

}
/*----------------------------------------------------------------------------*/

void ShootToRndDummy(sc_player pl, char *name_base, int count, float time)         //dummy musi byt pojmenovane name_base#0, name_base#1, atd...
{
  char        						name[64];
  s_SC_P_AI_WatchShoot    shoot;
  c_Vector3								vec;

  sprintf(name,"%s#%d", name_base, rand()%count);

  CLEAR(shoot);

  shoot.flags = SC_P_AI_WATCHSHOOT_FL_SHOOT;
  shoot.player = 0;
  GetNODPos(name, &vec);
	shoot.pos = vec;
  shoot.time = time;
  shoot.phase = SC_P_PHASE_STAND;
  shoot.aim = TRUE;
  shoot.lean = SC_P_LEAN_NONE;

  SC_P_Ai_SetWatchShoot(pl, &shoot);
}


/*---------------------------------WatchTo------------------------------------*/
void WatchTo(sc_player pl, char *helper, float time)
{
  s_SC_P_AI_WatchShoot    shoot;
  c_Vector3								vec;

  CLEAR(shoot);

  shoot.player = 0;
  GetHOPos(helper, NULL, &vec);
	shoot.pos = vec;
  shoot.phase = SC_P_PHASE_CROUCH;
  shoot.time = time;

  SC_P_Ai_SetWatchShoot(pl, &shoot);
}
/*----------------------------------------------------------------------------*/

/*---------------------------------WatchTo------------------------------------*/
void WatchVec(sc_player pl, c_Vector3 *vec, float time)
{
  s_SC_P_AI_WatchShoot    shoot;

  CLEAR(shoot);

//  shoot.player = 0;
	shoot.pos = *vec;
//  shoot.phase = SC_P_PHASE_CROUCH;
  shoot.time = time;
  shoot.flags = SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT | SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT;

  SC_P_Ai_SetWatchShoot(pl, &shoot);
}
/*----------------------------------------------------------------------------*/

/*--------------------------------ShootNOD------------------------------------*/
void ShootNOD(sc_player pl, char *helper, char *nod, float time)
{
  s_SC_P_AI_WatchShoot    shoot;
  c_Vector3               pos;

  SC_NOD_GetWorldPos(SC_NOD_Get(SC_NOD_GetNoMessage_Entity(helper), nod), &pos);

  shoot.flags = SC_P_AI_WATCHSHOOT_FL_SHOOT;
  shoot.player = 0;
  shoot.pos = pos;
  shoot.time = time;
  shoot.phase = SC_P_PHASE_STAND;
  shoot.aim = TRUE;
  shoot.lean = SC_P_LEAN_NONE;

  SC_P_Ai_SetWatchShoot(pl, &shoot);

}
/*----------------------------------------------------------------------------*/

/*----------------------------------WatchAt-----------------------------------*/
void WatchAt(sc_player pl, sc_player tpl, float time)
{
  s_SC_P_AI_WatchShoot    watch;

  CLEAR(watch);

  watch.player = tpl;
  watch.time   = time;

  SC_P_Ai_SetWatchShoot(pl, &watch);
}
/*----------------------------------------------------------------------------*/

/*---------------------------------AddPeril-----------------------------------*/
dword AddPeril(int side, int group, char *helper)
{
  s_SC_AI_Peril   peril;
  s_SC_Area       area;
  dword           peril_id;
  c_Vector3				vec;

  GetHOPos(helper, &area, &vec);
	peril.coverfrom_pos = &vec;
  peril.coverfrom_distance = 10.0f;
  peril.forbidden_area = &area;
  peril.time = 0.0f;

  peril_id = SC_AI_Peril_Add(side, group, &peril);
  return peril_id;
}
/*----------------------------------------------------------------------------*/

/*---------------------------------AddDanger----------------------------------*/
dword AddDanger(int side, int group, char *name)
{
	s_SC_AI_FakeDanger danger;

	CLEAR(danger);
	danger.name = name;
	danger.verify_time = 1.0f;

	return SC_AI_FakeDanger_Add(side, group, &danger);
}
/*----------------------------------------------------------------------------*/

/*--------------------------------AddDangers----------------------------------*/
fd_id AddDangers(int side, int group, char *name_base, int count)    //dangery musi byt pojmenovane name_base#1, name_base#2, atd...
{
  char  name[64];
  int   i;
  fd_id id;

  for (i=0; i<count; i++)
  {
    sprintf(name,"%s#%d", name_base, i+1);
    id.id[i] = AddDanger(side, group, name);
  }
  return id;
}
/*----------------------------------------------------------------------------*/

/*-----------------------------GroupUpdateEnemy-------------------------------*/
void GroupUpdateEnemy(int side, int group, sc_player plid)
{
  sc_player   list[64];
  int         num;
  int         i;

  CLEAR(list);

  num=SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_AI_ONLY);
  if (!num) return;

  for (i=0;i<num;i++)
  {
    SC_P_Ai_Situation_UpdateEnemy(list[i],plid);
  }
}
/*----------------------------------------------------------------------------*/

/*---------------------------------Explode------------------------------------*/
void Explode(char *helper, float dmg, float impuls)
{
  s_SC_Expl_CreateInfo  expl;
  s_sphere              sphere;

  CLEAR(expl);

  SC_GetScriptHelper(helper, &sphere, NULL);

  expl.sph = sphere;
  expl.damage = dmg;
  expl.marok_impuls = impuls;
  expl.piercing = 10;
	expl.ptc_id = 29;

  SC_Explosion_Make(&expl);
}
/*----------------------------------------------------------------------------*/

/*-------------------------------IsFromGroup----------------------------------*/
BOOL IsFromGroup(sc_player pl, int side, int group)
{
  sc_player   list[64];
  int         num;
  int         i;

  num=SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY);
  for (i=0; i<num; i++)
    if (pl == list[i])
      return TRUE;
  return FALSE;
}
/*----------------------------------------------------------------------------*/

/*--------------------------------KillGroup-----------------------------------*/
void KillGroup(int side, int group)
{
  sc_player   list[64];
  int         num;
  int         i;

  num=SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY);
  for (i=0; i<num; i++)
    SC_P_MakeDamage(list[i], 1000);
}
/*----------------------------------------------------------------------------*/

/*----------------------------GroupSetScriptMode------------------------------*/
void GroupSetScriptMode(int side, int group, BOOL mode)
{
  sc_player   list[64];
  int         i, num;

  num=SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY);
  for (i=0; i<num; i++)
    SC_P_Ai_SetScriptMode(list[i], mode);
}
/*----------------------------------------------------------------------------*/

/*---------------------------------HoldPos------------------------------------*/
void HoldPos(sc_player pl, dword phase, float rot)
{
  s_SC_P_status                 stat;
  s_SC_P_AI_ScriptModeProps     prop;

  SC_P_Ai_SetScriptMode(pl, TRUE);

  SC_P_Ai_GetScriptModeProps(pl, &prop);

  prop.static_phase = phase;
  prop.static_aim = TRUE;

  SC_P_Ai_SetScriptModeProps(pl, &prop);

  if (rot != 0)
		SC_P_SetPos(pl, NULL, NULL, &rot);

//  SC_P_Ai_SetScriptMode(pl, FALSE);
}
/*----------------------------------------------------------------------------*/

void NotAim(sc_player pl)
{
  s_SC_P_AI_ScriptModeProps     prop;

  SC_P_Ai_SetScriptMode(pl, TRUE);

  SC_P_Ai_GetScriptModeProps(pl, &prop);

  prop.static_aim = FALSE;

  SC_P_Ai_SetScriptModeProps(pl, &prop);

}

void ResetScriptMode(sc_player pl)
{
  s_SC_P_AI_ScriptModeProps     prop;
  
  CLEAR(prop);
  SC_P_Ai_SetScriptModeProps(pl, &prop);
  
  SC_P_Ai_SetScriptMode(pl, FALSE);
}

/*--------------------------------PlDetector----------------------------------*/
dword PlDetector(sc_player pl, char *helper, dword id)
{
  dword       pldet;
  s_SC_Area   ar;
  c_Vector3		vec;

  GetHOPos(helper, &ar, &vec);

  pldet = SC_PlDet_Create(pl, &ar, id);
  return pldet;
}
/*----------------------------------------------------------------------------*/

/*---------------------------------GetRndPl-----------------------------------*/
sc_player GetRndPl(int side, int group, dword fl)
{
  sc_player   list[64];
  int         num;

  num = SC_EnumPlayers(side, group, list, 64, fl);

  if (num)
    return list[rand()%num];
  else
    return FALSE;
}
/*----------------------------------------------------------------------------*/

/*---------------------------------GetGroup-----------------------------------*/
int GetGroup(sc_player pl)
{
  int gr;

  SC_P_GetSideGroupMemberId(pl, NULL, &gr, NULL);

  return gr;
}
/*----------------------------------------------------------------------------*/

/*--------------------------------PlayerBack----------------------------------*/
BOOL PlayerBack(sc_player pl, char *helper, float dist)
{
  c_Vector3   vec;
  float       dist1, dist2;

  GetNODPos(helper, &vec);
  dist1 = SC_P_GetDistancePos(SC_PC_Get(), &vec);
  dist2 = SC_P_GetDistancePos(pl, &vec);
//  dist2 = SC_P_GetDistancePl(SC_PC_Get(), pl);

  if ((dist1-dist2) > dist)
    return TRUE;
  else
    return FALSE;
}
/*----------------------------------------------------------------------------*/

/*--------------------------------PlayerNear----------------------------------*/
BOOL PlayerNear(sc_player pl, char *helper, float dist)
{
  c_Vector3   vec;
  float       distanc;

  GetNODPos(helper, &vec);
  distanc = SC_P_GetDistancePos(pl, &vec);

  if (distanc < dist)
    return TRUE;
  else
    return FALSE;
}
/*----------------------------------------------------------------------------*/

sc_player NearestPlayer(dword side, dword group)
{
  sc_player   pl, list[64];
  int         num, i;
  float 			dist, dist0;

  num = SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_AI_ONLY);
  
  if (!num) return FALSE;
  
  dist0 = 1000;
  
  for (i=0; i<num; i++)
  {
		dist = SC_P_GetDistancePl(list[i], SC_PC_Get());
		if (dist < dist0)
		{
			dist0 = dist;
			pl = list[i];
		}
	}
	
	return pl;
}

#ifndef __COMMON_CXX__
BOOL GetPlayerPos(sc_player pl_id, c_Vector3 *pos)
{
	s_SC_P_status	status;

	if ( !SC_P_GetStatus(pl_id, &status) )
		return FALSE;

	*pos = status.pos;

	return TRUE;
}
#endif

BOOL AreaClearFromPlayer(sc_player pl_id, float radius, dword side, dword group)
{
  dword                   num;
  sc_player               pl_list[32];
  c_Vector3               posi;
  s_sphere                sphere;
  s_SC_Area               area;

  CLEAR(area);
  CLEAR(pl_list);

  GetPlayerPos(pl_id, &sphere.pos);
	sphere.rad = radius;

	area.sphs = 1;
	area.sph = &sphere;

/*	area.sph.pos.x = posi.x;
	area.sph.pos.y = posi.y;
	area.sph.pos.z = posi.z;
	
	area.sph.rad = radius;  */

	num = SC_EnumPlayersArea(side, group, pl_list, 32, SC_ENUMPLS_FL_ALIVEONLY | SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_AI_ONLY, &area);
	
	if (num)
		return FALSE;
	else
		return TRUE;
}


/*--------------------------------ObjectNear----------------------------------*/
BOOL ObjectNear(sc_nod obj, char *helper, float dist)
{
  c_Vector3   vec1, vec2;
  float       distanc;

  GetNODPos(helper, &vec1);
  SC_NOD_GetWorldPos(obj, &vec2);
  
  if (SC_IsNear3D(&vec1, &vec2, dist))
    return TRUE;
  else
    return FALSE;
}
/*----------------------------------------------------------------------------*/

/*---------------------------------ClearOBJ-----------------------------------*/
void ClearOBJ()
{
	CLEAR(gObjectives);
	SC_SP_SetObjectives(0, gObjectives);
}
/*----------------------------------------------------------------------------*/

/*----------------------------------AddOBJ------------------------------------*/
void AddOBJ(dword textid, char *target)
{
	int i;
	c_Vector3	vec;
	
	for (i=0;i<gObjcount;i++) if (gObjectives[i].text_id==textid)
  {
		SC_Log(1,"Duplicite objective added - %d",textid);
		return;
	}
	gObjectives[gObjcount].text_id=textid;
	gObjectives[gObjcount].state=SC_SP_OBJECTIVE_STATE_ACTIVE;
	gObjcount++;
	SC_SP_SetObjectives(gObjcount,gObjectives);
  if (target != NULL)
  {
    GetNODPos(target, &vec);
		SC_Radar_SetTarget(&vec);
  }
}
/*----------------------------------------------------------------------------*/

/*-------------------------------CompleteOBJ----------------------------------*/
void CompleteOBJ(dword textid)
{
	int i;
	for (i=0;i<gObjcount;i++)
  {
		if ((gObjectives[i].text_id==textid)&&(gObjectives[i].state==SC_SP_OBJECTIVE_STATE_ACTIVE))
    {
			gObjectives[i].state=SC_SP_OBJECTIVE_STATE_FINISHED;
			SC_SP_SetObjectives(gObjcount,gObjectives);
//			SC_Radar_SetTarget(NULL);
			return;
		}
	}
}
/*----------------------------------------------------------------------------*/

/*---------------------------------FailOBJ------------------------------------*/
void FailOBJ(dword textid)
{
	int i;
	for (i=0;i<gObjcount;i++) if (gObjectives[i].text_id==textid)
		gObjectives[i].state=SC_SP_OBJECTIVE_STATE_FAILED;
	SC_SP_SetObjectives(gObjcount,gObjectives);
	SC_Radar_SetTarget(NULL);
}
/*----------------------------------------------------------------------------*/

/*-------------------------------Get_OBJ_Stat---------------------------------*/
int GetOBJStat(dword textid)
{
	int i;
	for (i=0;i<gObjcount;i++)
		if (gObjectives[i].text_id==textid)
			return gObjectives[i].state;
	return SC_SP_OBJECTIVE_STATE_NONE;
}
/*----------------------------------------------------------------------------*/

/*---------------------------------AutoSave-----------------------------------*/
void AutoSave(dword name, dword desc, BOOL disable)
{
	s_SC_MissionSave savedata;

  CLEAR(savedata);
	savedata.savename_id=name;
	savedata.description_id=desc;
	savedata.disable_info=disable;
	SC_MissionSave(&savedata);
}
/*----------------------------------------------------------------------------*/

#ifndef __COMMON_CXX__
/*-----------------------------SetPlayerDamage--------------------------------*/
void SetPlayerDamage(sc_player pl_id, float multCaused, float multReceived)
{
	s_SC_P_ScriptProps	sp;


	CLEAR(sp);
	sp.caused_damage_mult = multCaused;
	sp.received_damage_mult = multReceived;

	SC_P_SetScriptProps(pl_id, &sp);
}
/*----------------------------------------------------------------------------*/

/*------------------------------SetGroupDamage--------------------------------*/
void SetGroupDamage(dword sideId, dword groupId, float multCaused, float multReceived)
{
	sc_player	plList[256];
	dword		i, num = 256;


	num = SC_EnumPlayers(sideId, groupId, plList, num, SC_ENUMPLS_FL_AI_ONLY);
	for (i = 0; i < num; i++)
	{
		SetPlayerDamage(plList[i], multCaused, multReceived);
	}
}
/*----------------------------------------------------------------------------*/
#endif

/*---------------------------Menu_EnableMedicEng------------------------------*/
void Menu_EnableMedicEng()
{
	s_SC_PC_CmdMenu menu;

	SC_PC_GetCommandMenu(&menu);
	menu.flags = SC_PC_CMDMENU_FL_ENABLEMEDIC | SC_PC_CMDMENU_FL_ENABLEAMMO;
	menu.medik_max_call_distance=100;
	menu.ammo_max_call_distance=100;
	SC_PC_SetCommandMenu(&menu);
}
/*----------------------------------------------------------------------------*/

/*---------------------------Menu_DisableMedicEng-----------------------------*/
void Menu_DisableMedicEng()
{
	s_SC_PC_CmdMenu menu;

	SC_PC_GetCommandMenu(&menu);
	menu.flags = 0;
	SC_PC_SetCommandMenu(&menu);
}
/*----------------------------------------------------------------------------*/

/*------------------------------MoveToRndDummy--------------------------------*/
void MoveToRndDummy(sc_player pl, char *name_base, int count, dword msg)         //dummy musi byt pojmenovane name_base#0, name_base#1, atd...
{
  c_Vector3   target;
  char        name[64];

  sprintf(name,"%s#%d", name_base, rand()%count);
  GetNODPos(name, &target);

  SC_P_Ai_MoveAt(pl, &target, NULL, msg);
}
/*----------------------------------------------------------------------------*/

/*--------------------------------MoveToDummy---------------------------------*/
void MoveToDummy(sc_player pl, char *name, dword msg)
{
  c_Vector3   target;

  GetNODPos(name, &target);

  SC_P_Ai_MoveAt(pl, &target, NULL, msg);
}
/*----------------------------------------------------------------------------*/
           
void GroupMessage(int side, int group, dword msg)
{
  sc_player   list[64];
  int         num;
  int         i;

  num = SC_EnumPlayers(side, group, list, 64, NULL);
  for (i=0; i<num; i++)
    SC_P_ScriptMessage(list[i], msg, msg);
}

/*------------------------------DerespawnGroup---------------------------------*/
void DerespawnGroup(int side, int group)
{
  sc_player   list[64];
  int         num;
  int         i;

  num = SC_EnumPlayers(side, group, list, 64, SC_ENUMPLS_FL_RESPAWNEDONLY | SC_ENUMPLS_FL_ALIVEONLY);
  for (i=0; i<num; i++)
    SC_P_Derespawn(list[i]);
}
/*----------------------------------------------------------------------------*/

void DisableMoving()
{
	s_SC_PC_Control			pccontrol;

  SC_PC_GetControl(&pccontrol);
  pccontrol.movement = FALSE;
  pccontrol.phasechange = FALSE;
	pccontrol.weapons = FALSE;
  SC_PC_SetControl(&pccontrol);
}

void EnableMoving()
{
	s_SC_PC_Control			pccontrol;

  SC_PC_GetControl(&pccontrol);                                                                       
  pccontrol.movement = TRUE;                                                                         
  pccontrol.phasechange = TRUE;
  pccontrol.weapons = TRUE;
  SC_PC_SetControl(&pccontrol);    
}

void Borders()
{
	DisableMoving();
	SC_SetMovieBorders(TRUE, FALSE);
}

void NoBorders()
{
	EnableMoving();
	SC_SetMovieBorders(FALSE, FALSE);
}

void MovieTitle(dword id1, dword id2)
{
	ushort						*movTxt[2];
	s_SC_ScreenInfo 	si;
	
	movTxt[0] = SC_Wtxt(id1);
	movTxt[1] = SC_Wtxt(id2);
	CLEAR(si);
	si.txts = 2;
	si.txt = movTxt;
	si.chars_per_sec = 0;	//default
	si.show_time = 5.0f;
	SC_ScreenInfo_Set(&si);
}

void EndBink(char *binkname)
{
	s_SC_MissionEnd	end;
	
	CLEAR(end);
	
	end.type = SC_MISSIONEND_TYPE_FINISHED;
//	sprintf(end.success_bink, "Fmv\\%s.bik", binkname);
	sprintf(end.success_bink, "%s", binkname);
	
	SC_MissionEndEx(&end);
}
