/*
*	sc_global.h
*
*	Ptero-Engine-II : Main script include file, defines extern engine functions 
*	
*	M.Janacek 18.7.2001
*/



// DO NOT CHANGE THIS FILE AS IT IS ALREADY COMPILED WITH THE GAME ENGINE 
// and changing of defines, structures and functions would cause problems



#ifndef SC_GLOBAL_H
#define SC_GLOBAL_H 



// number of global variables accesed by SC_sgi, SC_ggi, SC_sgf ,SC_ggf and SC_MP_Gvar_SetSynchro functions
#define SC_GLOBAL_VARIABLE_MAX			4096
	

// values for s_SC_P_Create::side
#define SC_P_SIDE_US					0
#define SC_P_SIDE_VC					1
#define SC_P_SIDE_NEUTRAL				2
#define SC_P_SIDE_MP_SPECTATOR			0x0f			// not to be used by script, for internal MP game engine use


#define SC_P_SIDE_ALL					0xffffffff		// used for players enumaration SC_EnumPlayers
#define SC_P_GROUP_ALL					0xffffffff		// used for players enumaration SC_EnumPlayers


// values for s_SC_OBJ_info::event_type
#define SC_OBJ_MSG_INIT					1
#define SC_OBJ_MSG_RELEASE				2
#define SC_OBJ_MSG_JUSTLOADED			3
#define SC_OBJ_MSG_DOTICK				4
#define SC_OBJ_MSG_HIT					5		// is called depending on SC_OBJSCRIPT_FL_
#define SC_OBJ_MSG_MESSAGE				6		// message send using SC_ObjectScriptMessage
#define SC_OBJ_MSG_MOUNTEDSHOT			7
#define SC_OBJ_MSG_MAROKSIMULATION		8		// param1:	0 means object (sc_nod nod) just frozen
												//			1 means object (sc_nod nod) just started to move

#define SC_OBJ_MSG_DSTR_NETCLIENTBEFORE 9		// DSTR of some nod has changed on the game server, client receives this info
												// is called before DSTR change is done
												// nod - original nod
												// param1 - sc_nod new dstr, can be NULL
												// param2 - 0 means client is joining the server and this is the join info so it happend time ago ( no good to make particles )
												//			1 means client is in the game and this change happens just now
												// param3 - sc_nod cur_dstr - previously ( currently ) selected DSTR

#define SC_OBJ_MSG_DSTR_NETCLIENT		10		// DSTR of some nod has changed on the game server, client receives this info
												// is called after DSTR change is done
												// nod - original nod
												// param1 - sc_nod new dstr, can be NULL
												// param2 - 0 means client is joining the server and this is the join info so it happend time ago ( no good to make particles )
												//			1 means client is in the game and this change happens just now

#define SC_OBJ_MSG_USED					11		// param1 is sc_player which used it
#define SC_OBJ_MSG_VALIDATE_USE			12		// param1 is sc_player which wants to use it
												// param2 - return value, TRUE means enable, FALSE means disable, default is TRUE ( is set when this msg is called )
												// param3 - cursor type, default is SC_USECURSOR_HAND, cursors are placed on g\hud\hud_01.tga texture
												// param5 - can be filled by the text, default is NULL and means use text defined in SC_ActiveObj_Create
#define SC_OBJ_MSG_FROMCLNMESSAGE		13		// message send using SC_ObjectScriptMessage_toSRV
												// param1 is (void*)data
												// param2 is datasize
#define SC_OBJ_MSG_ITEMDATACHANGED		14		// param1 is index_from
												// param2 is data length
#define SC_OBJ_MSG_FROMCLNNOD			15		// message send using SC_ObjectScriptMessage_NodToSRV
												// param1 is (void*)data
												// param2 is datasize
#define SC_OBJ_MSG_FROMSRVNOD			16		// message send using SC_ObjectScriptMessage_NodToCLNs
												// param1 is (void*)data
												// param2 is datasize
#define SC_OBJ_MSG_VEHICLEGETWHEELPOWER	17		// 
#define SC_OBJ_MSG_VEHICLE_DOTICK		18		// 
#define SC_OBJ_MSG_VEHICLE_REPAIR		19		// param6 includes percentage (0.0f - 1.0f ) which should be repaired ( so 1.0f means will be fully repaired everytime, 0.5f means health is going to increase by 50% of max )

												
												
#define SC_USECURSOR_COMMAND			0		// not probably for "use" use
#define SC_USECURSOR_HAND				1
#define SC_USECURSOR_RADIO				2
#define SC_USECURSOR_MEDIK				3
#define SC_USECURSOR_TALK				4
#define SC_USECURSOR_ENGINEER			5
#define SC_USECURSOR_USSOLDIER			6		// not probably for "use" use
#define SC_USECURSOR_VCSOLDIER			7		// not probably for "use" use
#define SC_USECURSOR_LEVELUP			8		// not probably for "use" use
#define SC_USECURSOR_HANDDISABLED		9
#define SC_USECURSOR_LOCKED				10
#define SC_USECURSOR_C4					28

#define SC_USECURSOR_NONE				0xff	// no cursor will appear


#define SC_OBJSCRIPT_FL_HITMISSILE				0x01
#define SC_OBJSCRIPT_FL_HITEXPLOSION			0x02
#define SC_OBJSCRIPT_FL_HITMAROK				0x04
#define SC_OBJSCRIPT_FL_HITPLAYER				0x08
#define SC_OBJSCRIPT_FL_MAROKSIMULATION			0x10			// enables SC_OBJ_MSG_MAROKSIMULATION


// values for s_SC_OBJ_info::hit_by

#define SC_OBJ_HIT_BY_MISSILE					1
#define SC_OBJ_HIT_BY_MAROK						2
#define SC_OBJ_HIT_BY_EXPLOSION					3


#define SC_PRELOAD_BES_MAXID					64


// do not change these values! 
#define SC_SNDPLAYER_GAME			0
#define SC_SNDPLAYER_SPEECH			1
#define SC_SNDPLAYER_HELI			2
#define SC_SNDPLAYER_BEEP			3
#define SC_SNDPLAYER_NATURE			5
#define SC_SNDPLAYER_SCRIPT0		6
#define SC_SNDPLAYER_SCRIPT1		7

// do not change these values! 


// values for s_SC_ScriptHelper_info::event_type
#define SC_SCRHELPER_EVENTTYPE_INIT			1
#define SC_SCRHELPER_EVENTTYPE_RELEASE		2
#define SC_SCRHELPER_EVENTTYPE_TIMETICK		3
#define SC_SCRHELPER_EVENTTYPE_JUSTLOADED	4
#define SC_SCRHELPER_EVENTTYPE_MSG			5


// values for s_SC_SOUND_info::message
#define SC_SOUND_MESSAGE_INIT				1



// values fpr s_SC_L_info::message
#define SC_LEV_MSG_TIME						1
#define SC_LEV_MSG_SPEECHCALLBACK			2			// param1 - callback_id	, param2 - 0/1 - released/normal_end
#define SC_LEV_MSG_VIEWANIMCALLBACK			3			// param1 - callback_id , NOT IMPLEMENTED YET
#define SC_LEV_MSG_LOUDSHOTCALLBACK			4			// param1 - callback_id, param2 - sc_player
														// param3 - 0 means shot, 1 means explosion
														// param4 is shot/explosion position
#define SC_LEV_MSG_INITSCENE				5			// is called when the scene is initializing for the first time and when scene is initialising during loading of the gamesave too
#define SC_LEV_MSG_RELEASESCENE				6
#define SC_LEV_MSG_JUSTLOADED				7			// is called when savegame is loaded
#define SC_LEV_MSG_MUSICDONE				8			// param1 - music_id, NOT IMPLEMENTED YET
#define SC_LEV_MSG_LOADINGDONE				9			// is called when loading of the game ( start new map, loading p3g or F8 switching to the game ) is finished
														// good place to play bink movies for example
#define SC_LEV_MSG_MESSAGE					10			// param1 - msg_param1, param2 - msg_param2
#define SC_LEV_MSG_DBG_HUD_RENDER			11			// allows write any debug info on the screen using SC_Fnt_Write/SC_Fnt_WWrite functions
#define SC_LEV_MSG_PLDETECTOR				12			// param1 - callback_id, param2 - player, param3 - pldet_id  ( callback caused by Player detector created by SC_PlDet_Create() )
#define SC_LEV_MSG_GROUPMAINTASK_FINISHED	13			// all members of side-param1, group-param2 finisned maintask cooperation_id-param3
#define SC_LEV_MSG_CMDMENU					14			// when user chooses item from command menu
														// param1 is s_SC_PC_CmdMenuItem::cmd_id
#define SC_LEV_MSG_CEDEVENT					15			// is called from CutEditor, see additional sub-messages SC_CED_MSG_*
#define SC_LEV_MSG_VEHANIM_END				16			// param1 is main sc_nod of vehicle, animation is started by SC_VEH_StartAnim()
														// callback is not called when using SC_VEH_StopAnim()
#define SC_LEV_MSG_MOVIESKIP				17			// user pressed key for skip movie - must be enabled by SC_MovieSkipEnable
														// when key is pressed SC_MovieSkipEnable(FALSE) is called automaticly to disable it
#define SC_LEV_MSG_TEAMCMD					18			// user used some team command
														// param1 is the type SC_LEV_MSG_TEAMCMD_TYPE_???			
														// param4 is the command position
														// param2 is return value
														//			default is 1
														//			0 means stop the command ( PC will not say it, make fpv anim and AI will not receive it)

	#define SC_LEV_MSG_TEAMCMD_TYPE_FOLLOWME			1
	#define SC_LEV_MSG_TEAMCMD_TYPE_MOVE				2
	#define SC_LEV_MSG_TEAMCMD_TYPE_MOVEFAST			3
	#define SC_LEV_MSG_TEAMCMD_TYPE_COVERFIRE			4
	#define SC_LEV_MSG_TEAMCMD_TYPE_ATTACK				5

														
//script sub-messages (these messages are sent to a level script via SC_LEV_MSG_MESSAGE)
#define	SC_CED_MSG_CAM_START	1	//param2 is set to an index, param3 is time tick within the whole movie scope
#define	SC_CED_MSG_CAM_END		2	//param2 is set to an index, param3 is time tick within the whole movie scope
#define	SC_CED_MSG_PL_SETANIM	3	//param2 is set to an index, param3 is time tick within the whole movie scope
#define SC_CED_MSG_STOP			4	//param2 is zero, param3 is time tick within the whole movie scope


														


// values for s_SC_WeapFpv_info::event
#define SC_WEAPFPV_EVENT_DOTICK						1
#define SC_WEAPFPV_EVENT_INIT						2
#define SC_WEAPFPV_EVENT_RELEASE					3
#define SC_WEAPFPV_EVENT_VALIDATEANIM				4
#define SC_WEAPFPV_EVENT_GETANIMTIME				5
#define SC_WEAPFPV_EVENT_SHOT						6


#define SC_WEAPFPV_ANIM_ST					0
#define SC_WEAPFPV_ANIM_STMOVE				1
#define SC_WEAPFPV_ANIM_STSPRINT			2
#define SC_WEAPFPV_ANIM_STAIM				3
#define SC_WEAPFPV_ANIM_AIMMOVE				4
#define SC_WEAPFPV_ANIM_STPRONE				5
#define SC_WEAPFPV_ANIM_PRONEMOVE			6
#define SC_WEAPFPV_ANIM_PRONEBACK			7
#define SC_WEAPFPV_ANIM_PRONELEFT			8
#define SC_WEAPFPV_ANIM_PRONERIGHT			9
#define SC_WEAPFPV_ANIM_PRONESPRINT			10
#define SC_WEAPFPV_ANIM_STWALL				11

#define SC_WEAPFPV_ANIM_SHOOT				12
#define SC_WEAPFPV_ANIM_SHOOTAIM			13
#define SC_WEAPFPV_ANIM_SHOOTMOVE			14
#define SC_WEAPFPV_ANIM_SHOOTSPRINT			15

#define SC_WEAPFPV_ANIM_TAKE				16
#define SC_WEAPFPV_ANIM_TAKEPRONE			17
#define SC_WEAPFPV_ANIM_TAKEWALL			18

#define SC_WEAPFPV_ANIM_HIDE				19
#define SC_WEAPFPV_ANIM_HIDEPRONE			20
#define SC_WEAPFPV_ANIM_HIDEWALL			21

#define SC_WEAPFPV_ANIM_RELOAD				22
#define SC_WEAPFPV_ANIM_RELOADPRONE			23
#define SC_WEAPFPV_ANIM_RELOADWALL			24

#define SC_WEAPFPV_ANIM_BAYTAKE				25
#define SC_WEAPFPV_ANIM_BAYTAKEPRONE		26
#define SC_WEAPFPV_ANIM_BAYTAKEWALL			27

#define SC_WEAPFPV_ANIM_BAYHIDE				28
#define SC_WEAPFPV_ANIM_BAYHIDEPRONE		29
#define SC_WEAPFPV_ANIM_BAYHIDEWALL			30

#define SC_WEAPFPV_ANIM_BAYSTAB				31

#define SC_WEAPFPV_ANIM_GRENADE				32
#define SC_WEAPFPV_ANIM_HIT					33

#define SC_WEAPFPV_ANIM_MODE1				34
#define SC_WEAPFPV_ANIM_MODE1PRONE			35
#define SC_WEAPFPV_ANIM_MODE1WALL			36

#define SC_WEAPFPV_ANIM_MODE2				37
#define SC_WEAPFPV_ANIM_MODE2PRONE			38
#define SC_WEAPFPV_ANIM_MODE2WALL			39

#define SC_WEAPFPV_ANIM_DROP				40
#define SC_WEAPFPV_ANIM_DROPPRONE			41
#define SC_WEAPFPV_ANIM_DROPWALL			42


#define SC_WEAPFPV_ANIM_USERDEF1			60
#define SC_WEAPFPV_ANIM_USERDEF1PRONE		61
#define SC_WEAPFPV_ANIM_USERDEF1WALL		62

#define SC_WEAPFPV_ANIM_USERDEF2			63
#define SC_WEAPFPV_ANIM_USERDEF2PRONE		64
#define SC_WEAPFPV_ANIM_USERDEF2WALL		65

#define SC_WEAPFPV_ANIM_USERDEF3			66
#define SC_WEAPFPV_ANIM_USERDEF3PRONE		67
#define SC_WEAPFPV_ANIM_USERDEF3WALL		68

#define SC_WEAPFPV_ANIM_USERDEF4			69
#define SC_WEAPFPV_ANIM_USERDEF4PRONE		70
#define SC_WEAPFPV_ANIM_USERDEF4WALL		71

#define SC_WEAPFPV_ANIM_USERDEF5			72
#define SC_WEAPFPV_ANIM_USERDEF5PRONE		73
#define SC_WEAPFPV_ANIM_USERDEF5WALL		74

#define SC_WEAPFPV_ANIM_USERDEF6			75
#define SC_WEAPFPV_ANIM_USERDEF6PRONE		76
#define SC_WEAPFPV_ANIM_USERDEF6WALL		77


// values for s_SC_Weap3pv_info::event_type
#define SC_WEAP3PV_EVENT_INIT				0
#define SC_WEAP3PV_EVENT_SHOT				1
#define SC_WEAP3PV_EVENT_RELOAD				2
#define SC_WEAP3PV_EVENT_SETBAYONET			3
#define SC_WEAP3PV_EVENT_TICK				4


// values for s_SC_Weap_info::event

#define SC_WEAP_EVENT_INITWEAPTYPE			1			// is called once when script is loading to weapon type
#define SC_WEAP_EVENT_RELEASEWEAPTYPE		2			// is called once when script is releasing from weapon type
#define SC_WEAP_EVENT_INIT					3			// is called for every script instance ( every weapon created in the game )
														// param1 - 0 means weapon is created on player respawn
														//			1 means weapon created on pickup
#define SC_WEAP_EVENT_RELEASE				4			// is called for every script instance release
#define SC_WEAP_EVENT_DOTICK				5			// is called for every weapon every frame
#define SC_WEAP_EVENT_CANSELECT				6			// is called to validate weapons selection ( for example, for grenade it checks if any "ammo" is available )
#define SC_WEAP_EVENT_CANUNSELECT			7			// is called to validate weapons unselection ( for example, for grenade it checks if there is not throwing right now)
#define SC_WEAP_EVENT_MPCHANGE				8			// comes on clients, caused by SC_WEAP_SendMpChange
#define SC_WEAP_EVENT_GETINFO_USEMENU		9			// weapon script can define menu to display when holding use, fills s_SC_hud_menu_init *menu;
#define SC_WEAP_EVENT_GETINFO_SHOOT			10			// weapon script can define text display on the screen, return in s_SC_Weap_info::text
#define SC_WEAP_EVENT_USE_PRESSED			11			// is called when player presses USE key,
														// set s_SC_Weap_info::param1 to 1 when script operated USE and the game should continue ( pickups, and other uses )
														// param2 is menu_item_id defined by SC_WEAP_EVENT_GETINFO_USEMENU
#define SC_WEAP_EVENT_DEFAULTSHOOT			13			// default shoot happend
#define SC_WEAP_EVENT_GETDROPITEM			14			// param1 should be filled with item_id to be dropped as a weapon
#define SC_WEAP_EVENT_AMMOPICKCALLBACK		15			// called when picking up ammo with "weapcallback" settings
														// param1 is void *data
														// param2 is datasize
#define SC_WEAP_EVENT_MSG					16			// message caused by SC_P_SendWeapScriptMsg
														// param1 is void *data
														// param2 is datasize


#define SC_WEAP_FL_DISABLE_SYS_SHOOT					0x0001
#define SC_WEAP_FL_DISABLE_SYS_CHANGEBATCH				0x0002
#define SC_WEAP_FL_DISABLE_SYS_CHANGEBAYONET			0x0004
#define SC_WEAP_FL_DISABLE_SYS_AIM						0x0008
#define SC_WEAP_FL_DISABLE_SYS_RELOAD					0x0010
#define SC_WEAP_FL_DISABLE_SYS_DROP						0x0020
#define SC_WEAP_FL_DISABLE_NOAIM_SHOOT					0x0040


#define SC_FPV_ACTION_NONE					0
#define SC_FPV_ACTION_RELOAD				1
#define SC_FPV_ACTION_HIDE					2
#define SC_FPV_ACTION_SHOW					3
#define SC_FPV_ACTION_SHOOT					4
#define SC_FPV_ACTION_MODE1					5
#define SC_FPV_ACTION_MODE2					6
#define SC_FPV_ACTION_BAYTAKE				7
#define SC_FPV_ACTION_BAYHIDE				8
#define SC_FPV_ACTION_BAYHIT				9
#define SC_FPV_ACTION_BUTT_HIT				10
#define SC_FPV_ACTION_DROP					11
#define SC_FPV_ACTION_USERDEF1				20
#define SC_FPV_ACTION_USERDEF2				21
#define SC_FPV_ACTION_USERDEF3				22
#define SC_FPV_ACTION_USERDEF4				23
#define SC_FPV_ACTION_USERDEF5				24
#define SC_FPV_ACTION_USERDEF6				25



#define SC_FPV_FL_PAUSE_AT_END				0x01
#define SC_FPV_FL_FORCE_TIME_RETURN			0x02


#define SC_P_RESPPOS_FL_CROUCH				0x01


// s_SC_Pscript_info::message
#define SC_PLSCR_MSG_SCRIPT_INIT					1
#define SC_PLSCR_MSG_SCRIPT_RELEASE					2
#define SC_PLSCR_MSG_PL_CREATED						3
#define SC_PLSCR_MSG_PL_RELEASED					4
#define SC_PLSCR_MSG_PL_RESPAWNED					5
#define SC_PLSCR_MSG_PL_DERESPAWNED					6
#define SC_PLSCR_MSG_PL_HIT							7		// param1 is sc_player who did this hit
#define SC_PLSCR_MSG_PL_KILLED						8		// param1 is sc_player who killed him
#define SC_PLSCR_MSG_PL_HEALEDFROMCOMA				9

#define SC_PLSCR_MSG_SCRIPT_TIMETICK				10
#define SC_PLSCR_MSG_SCRIPT_MESSAGE					11
#define SC_PLSCR_MSG_JUSTLOADED						12
#define SC_PLSCR_MSG_INTERACTION					13		// caused by interacting, menu is set by SC_P_SetInteraction
															// param1 is sc_player who interacts ( PC player )
															// param2 is item index
#define SC_PLSCR_MSG_PC_WEAPSDISABLED_TRYSHOOT		14		// pc player has disabled using of weapons ( by SC_PC_SetControl )
															// and pressed shoot
#define SC_PLSCR_MSG_ANIM_CALLBACK					15		// param1 is callback_id from 

#define SC_PLSCR_MSG_AI_MAINTASK_FINISHED			20		// param1 is cooperation_id of the finished main task
#define SC_PLSCR_MSG_AI_MOVEAT_CALLBACK				21		// param1 is callback_id, param2 is SC_PL_AI_MOVEAT_CALLBACK_xxx
#define SC_PLSCR_MSG_AI_SCRIPTMODE_EVENT			22		// param1 is event_type - SC_PL_AI_SCRIPTMODE_EVENT_
#define SC_PLSCR_MSG_AI_TEAMCMD_VALIDATE			23		// is called when AI is in SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM and user gives the task
															// return value is in param1
															//		0 means disable task
															//		1 means do the task ( game engine will change status to SC_P_AI_TEAMCMD_STATE_ENABLED and will give the command )
															//			- script has to make sure all 'nonstandart' setting is removed ( special animations,... )



#define SC_PL_AI_MOVEAT_CALLBACK_FINISHED			1		// player reached the position
#define SC_PL_AI_MOVEAT_CALLBACK_FAILED				2		// player failed to reach the position and moving is stopped
#define SC_PL_AI_MOVEAT_CALLBACK_STOPPED			3		// some other task stopped moving

#define SC_PL_AI_SCRIPTMODE_EVENT_MOVINGPERIL		1		// s_SC_Pscript_info::param2: 0 - sees it, 1 - just hears it


// values used in s_SC_P_Create
#define SC_P_CREATE_TYPE_PC					1
#define SC_P_CREATE_TYPE_AI					2
#define SC_P_CREATE_TYPE_EXTERN_PC			3		// not for use by script, used by MP engine only
#define SC_P_CREATE_TYPE_EXTERN_AI			4		// not for use by script, used by MP engine only

#define SC_P_CREATE_FL_unused						0x01
#define SC_P_CREATE_FL_GENERATE_AI_BLOCKER			0x02
#define SC_P_CREATE_FL_ALLOW_COMA					0x04		// allow player be in come ( heavily wounded )
#define SC_P_CREATE_FL_USE_WEAPONS_STAMINA			0x08		// use stamina of big weapons to decrease players stamina and to decide possibility to pick it up
#define SC_P_CREATE_FL_TARGET_FOR_AIFIRSTWEEKSHOT	0x10		// AI will use "the first weak shooting batch when shooting at this newly detected enemy
																// AI has to have s_SC_P_AI_props::firstweakshoot_time set
																// this flags is now everytime set for PC player
#define SC_P_CREATE_FL_NODEADJUSTCOMA				0x20		// player cannot die, he will stay in coma - useful for PC's group
																// automaticly sets SC_P_CREATE_FL_ALLOW_COMA flag too
#define SC_P_CREATE_FL_FORCE_USE_IK_DEATH			0x40		// forces the player to die using IK ( otherwise players can die in animation too, depends on settings 
#define SC_P_CREATE_FL_DROP_NOTHING_FROM_DEAD		0x80		// there will be nothing droped out from the player when killed


#define SC_P_CREATE_MEMID_AUTO				0x0100
#define SC_P_CREATE_MEMID_AUTOSTART			0x0100


#define SC_P_AI_MAINTASK_FL_ALLOW_MOVE_TO_NOCOVER				0x01		// allow moving to nocovered positions
#define SC_P_AI_MAINTASK_FL_PERMANENT							0x02		// task is permanent, otherwise the task is closed ( with a callback SC_PLSCR_MSG_AI_MAINTASK_FINISHED to the script) when the player reaches the target
#define SC_P_AI_MAINTASK_FL_USE_DANGERLIMITS_IN_BATTLE			0x04		// use min_danger_dist and max_danger_dist in battle mode too ( otherwise these tests are done in danger mode only )
#define SC_P_AI_MAINTASK_FL_DO_VALID_MOVEDIRECTION_TEST			0x08		// test if the new position is nearer to the move_target then the current position ( is done by full searchway algo ), works in fakedanger, danger and battle modes ( doesn't in peace mode )
#define SC_P_AI_MAINTASK_FL_NOMOVE_WHEN_CHECKING_FAKEDANGER		0x10		// when someone is checking FakeDanger, all others have moving disabled
#define SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE_AWAY_FROM_ENEMIES	0x20		// do not move in battle away from enemies
#define SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE_AWAY_FROM_DANGERS	0x40		// do not move in battle mode ( when SC_P_AI_MAINTASK_FL_USE_DANGERLIMITS_IN_BATTLE is iset ) and in danger mode away from dangers
#define SC_P_AI_MAINTASK_FL_NOMOVE_INBATTLE						0x80		// do not move by maintask in battle and danger modes
#define SC_P_AI_MAINTASK_FL_PCDIST_ALLOWAHEAD					0x0100		// PC doesn't have to be in distance from target point only, it will allow also ahead of player but in max distance from the way
#define SC_P_AI_MAINTASK_FL_DISABLE_BATTLEMOVES					0x0200		// disable battle-moving

#define SC_P_AI_MAINTASK_FL_DISABLE_GENSPEECH_MOVINGONPOSITION	0x0400		// disables generic speech when player reaches target position
#define SC_P_AI_MAINTASK_FL_DISABLE_GENSPEECH_TELLINGTOMOVE		0x0800		// disables generic speech "gogogo" when players stops at 'step' position



#define SC_P_AI_MAINTASK_FL_FORGAMEENGINE						0x00010000	// flags used by the game start from here


// s_SC_AI_GroupProps::flags
#define SC_AI_GROUP_FL_DISABLE_ENEMYSHARING						0x0001
#define SC_AI_GROUP_FL_SHOW_ON_RADAR							0x0002


// s_SC_P_AI_props::flags
#define SC_PLAI_PROPS_FL_SITUPDATE_VISUAL_DISABLED		0x0001		// player will not visually update situation
#define SC_PLAI_PROPS_FL_SITUPDATE_HEAR_DISABLED		0x0002		// player will not react on sound impulses
#define SC_PLAI_PROPS_FL_SITSHARE_SEND_DISABLED			0x0004		// player will not inform other group members about his known enemies
#define SC_PLAI_PROPS_FL_SITSHARE_RECEIVE_DISABLED		0x0008		// player will not received info about enemies from  other group members

#define SC_PLAI_PROPS_FL_SHOOTING_DISABLED				0x0010		// player will act as usual ( poke from hideouts,...) but will not shoot
#define SC_PLAI_PROPS_FL_SHOOTING_HIT_ALLIES			0x0020		// when set, AI will hit allies ( default is OFF )
#define SC_PLAI_PROPS_FL_ISINVISIBLE_FOR_ENEMY_AI		0x0040		// player is invisible for enemy AI ( all impulses are ignored - visual, sound,...)


#define SC_P_PHASE_STAND				0
#define SC_P_PHASE_CROUCH				1
#define SC_P_PHASE_PRONE				2


#define SC_P_HEALTHSTATUS_OK			0
#define SC_P_HEALTHSTATUS_COMA			1
#define SC_P_HEALTHSTATUS_DEAD			2


#define SC_P_LEAN_NONE					0
#define SC_P_LEAN_LEFT					-1
#define SC_P_LEAN_RIGHT					1


#define SC_P_AI_MOVESTYLE_RUN			0
#define SC_P_AI_MOVESTYLE_SPRINT		1
#define SC_P_AI_MOVESTYLE_AIM			2



// s_SC_P_AI_WatchShoot::flags
#define SC_P_AI_WATCHSHOOT_FL_SHOOT						0x0001			// when not set, player will just watch

#define SC_P_AI_WATCHSHOOT_FL_PHASE_CURRENT				0x0002			// phase se pouzije podle aktualniho nastaveni v okamziku zadani
#define SC_P_AI_WATCHSHOOT_FL_AIM_CURRENT				0x0004			// aim se pouzije podle aktualniho nastaveni v okamziku zadani

#define SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_WATCH		0x0008			// aby se hrac otocil smerem k cili, musi byt prima viditelnost
#define SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_SHOOT		0x0010			// aby hrac zacal strilet na cil, musi byt prima viditelnost
#define SC_P_AI_WATCHSHOOT_FL_TESTVISIBILITY_SHOOTRPG	0x0020			// aby hrac zacal strilet na cil, musi byt prima viditelnost + misto 20cm okolo ( aby RPG v pohode proletela )
																		// this flag also forces for collision test in every frame ( normally it's tested 3x per second only )



#define SC_ENUMPLS_FL_RESPAWNEDONLY			0x01
#define SC_ENUMPLS_FL_NORESPAWNEDONLY		0x02
#define SC_ENUMPLS_FL_DEADONLY				0x04			// has sence with SC_ENUMPLS_FL_RESPAWNED only
#define SC_ENUMPLS_FL_ALIVEONLY				0x08			// has sence with SC_ENUMPLS_FL_RESPAWNED only
#define SC_ENUMPLS_FL_AI_ONLY				0x10
#define SC_ENUMPLS_FL_PC_ONLY				0x20


#define SC_P_AI_MODE_PEACE				0
#define SC_P_AI_MODE_FAKEDANGER			1
#define SC_P_AI_MODE_DANGER				2
#define SC_P_AI_MODE_BATTLE				3
#define SC_P_AI_MODE_SCRIPT				10


#define SC_SCRIPTHELPER_TYPE_ERROR					0
#define SC_SCRIPTHELPER_TYPE_SPHERE					1
#define SC_SCRIPTHELPER_TYPE_BOX					2


#define SC_P_AI_MOVESTYLE_FL_PHASE				0x01		// use defined phase value
#define SC_P_AI_MOVESTYLE_FL_AIM				0x02		// use defined aim value
#define SC_P_AI_MOVESTYLE_FL_SPRINT				0x04		// use defined sprint value

#define SC_P_AI_MOVESTYLE_FL_ALL			( SC_P_AI_MOVESTYLE_FL_PHASE | SC_P_AI_MOVESTYLE_FL_AIM | SC_P_AI_MOVESTYLE_FL_SPRINT)

#define SC_P_AI_STANDSTYLE_FL_PHASE				0x01
#define SC_P_AI_STANDSTYLE_FL_AIM				0x02
#define SC_P_AI_STANDSTYLE_FL_LEAN				0x04

#define SC_P_AI_STANDSTYLE_FL_ALL				(SC_P_AI_STANDSTYLE_FL_PHASE | SC_P_AI_STANDSTYLE_FL_AIM | SC_P_AI_STANDSTYLE_FL_LEAN)


#define SC_SPEECHPROPS_FL_ALLOWFORDEADPLS		0x01	// speech will be played by dead players too
#define SC_SPEECHPROPS_FL_FOR_ENGINE_USE		0x10000	// from this value it's reserver for engine internal use

#define SC_SPEECHPROPS_TYPE_NORMAL				0		// type of speech is selected in dependence on type
#define SC_SPEECHPROPS_TYPE_FORCE_2D			1		// speech will be played in 2D ( player's mind )
#define SC_SPEECHPROPS_TYPE_FORCE_3DINCAMERA	2		// speech will be player in 3D, but in camera

#define SC_SPEECH_BATCH_FL_DONOTSTOP_OTHERACTIVE			0x01				// when some speech from the batch is stopped ( player is dead ), do not stop alread active speeches ( used for radio for example )

#define SC_GETHIDEOUT_FL_EMPTYONLY							0x01





#define SC_P_AI_SIT_FORGET_ENEMIES					0x01
#define SC_P_AI_SIT_FORGET_DANGERS					0x02
#define SC_P_AI_SIT_FORGET_VISUALS					0x04
#define SC_P_AI_SIT_FORGET_GROUPSHARE				0x08

#define SC_P_AI_SIT_FORGET_ALL		(SC_P_AI_SIT_FORGET_ENEMIES | SC_P_AI_SIT_FORGET_DANGERS | SC_P_AI_SIT_FORGET_VISUALS | SC_P_AI_SIT_FORGET_GROUPSHARE)


#define SC_P_AI_SIT_TYPE_NONE				0
#define SC_P_AI_SIT_TYPE_ENEMY				1
#define SC_P_AI_SIT_TYPE_DANGER				2
#define SC_P_AI_SIT_TYPE_VISUAL				3
#define SC_P_AI_SIT_TYPE_SHAREDENEMY		4



#define SC_P_CANSEEPOS_FL_DISABLE_VIEWANGLE				0x01
#define SC_P_CANSEEPOS_FL_DISABLE_COLLISION				0x02




#define SC_VEHICLESEATTYPE_WATCH			0
#define SC_VEHICLESEATTYPE_SHOOT			1
#define SC_VEHICLESEATTYPE_DRIVER			2
#define SC_VEHICLESEATTYPE_MWP				3

#define SC_VEHICLESEAT_FL_HIDEWEAPON_3PV		0x01
#define SC_VEHICLESEAT_FL_HIDEWEAPON_FPV		0x02
#define SC_VEHICLESEAT_FL_RENDER3PV_INFPV		0x04
#define SC_VEHICLESEAT_FL_DISABLED_FOR_PC		0x08		// can be set when creating seat or runtime by SC_VEH_EnableSeatForPC
#define SC_VEHICLESEAT_FL_RENDER3PV_DISABLE		0x10
#define SC_VEHICLESEAT_FL_ROTATEAROUND			0x20
#define SC_VEHICLESEAT_FL_DISABLE_FPVVIEW		0x40


#define SC_VEHICLESEATDSTRDEAD_IK				0
#define SC_VEHICLESEATDSTRDEAD_DEADANIM			1
#define SC_VEHICLESEATDSTRDEAD_DISAPPEAR		2


#define SC_SPEECHAUTHOR_GENERAL				0xffffffff






#define SC_CREATEITEM_FL_LOCALNOSYNCH			0x01
#define SC_CREATEITEM_FL_MAKESLEEP				0x02
#define SC_CREATEITEM_FL_PLACEONGROUND			0X08			// create object on the ground, rotate it to get best position
#define SC_CREATEITEM_FL_PLACEONGROUNDNOROT		0x10			// create object on the ground, no rotation to place it

#define SC_CREATEITEM_USEMASK_FLAGS				0x01
#define SC_CREATEITEM_USEMASK_M					0x02
#define SC_CREATEITEM_USEMASK_GRAVITY			0x04



#define SC_CREATEITEM_PHSINIT_FL_ISTRASH			0x01
#define SC_CREATEITEM_PHSINIT_FL_COLLIDEPLS			0x02
#define SC_CREATEITEM_PHSINIT_FL_FORCECOLMOVDOOR	0x04		// force the object to collide with even moving door ( moving door doesn't collide with any object otherwise) - for grenades, rpg, ....
#define SC_CREATEITEM_PHSINIT_FL_MPSYNCH			0x0100





// s_SC_ModeScript_info::event
#define SC_MODESCRIPT_EVENT_INIT				1		// param1 - is server
#define SC_MODESCRIPT_EVENT_RELEASE				2		// param1 - is server
#define SC_MODESCRIPT_EVENT_DOTICK_SRV			3		// elapsed_time is valid
#define SC_MODESCRIPT_EVENT_DOTICK_CLN			4		// elapsed_time is valid

#define SC_MODESCRIPT_EVENT_MSG_TO_SRV			5		// param1 - dword from_pl_handle
														// param2 - datasize
														// param3 - void* data
														// caused by SC_MP_MsgToSrv
#define SC_MODESCRIPT_EVENT_MSG_TO_CLN			6		// param1 - dword to_pl_handle
														// param2 - datasize
														// param3 - void* data
														// caused by SC_MP_MsgToCln
#define SC_MODESCRIPT_EVENT_SYNCHCHANGE			7		// synchro object changed, is called on clients only, reaction at SC_MP_Synch_SendChanges
														// param1 - synchro mp_id

#define SC_MODESCRIPT_EVENT_PLREADYTORESPAWN	8		// param1 - player handle ( not sc_player !)
														// param2 - 0 - side change or just joined the server 														
														//			1 - after map restart
#define SC_MODESCRIPT_EVENT_PLKILLED			9		// param1 - player handle
														// param2 - killed by player handle
														// param3 - killed by weapon type
														// param4 - 0-"full_death", 1 - "coma"
														// param5 - 0-can be teamkill, 1 - teamkill disabled ( when someone from the team enters b-trap for example )														
															// return values
															// param10 - exp to be added to killed player
															// param11 - exp to be added to killer															

#define SC_MODESCRIPT_EVENT_PLKILLEDFROMCOMA	10		// param1 - player handle
														// player was in coma and is dead now
#define SC_MODESCRIPT_EVENT_PLRELEASED			11		// param1 - player handle
#define SC_MODESCRIPT_EVENT_RENDER				12		// there can be some info written on the screen using SC_Fnt_Write functins
#define SC_MODESCRIPT_EVENT_FILLMODESETTINGS	13		// script should initialize script settings on this call using SC_MP_ModeSettings_Add(info->param1,...)
														// is called when map is loaded, and also in menus to display correct settings
														// param1 is identificator of settings, must be used when calling SC_MP_ModeSettings_Add
#define SC_MODESCRIPT_EVENT_GETMAP_SHORTINFO	14		// param1 is index <0,2>
														// param2 is (ushort*) left_align text to be filled
														// param3 is (ushort*) right_align text to be filled
														// those texts are used in Limbo menu right top corner
#define SC_MODESCRIPT_EVENT_GET_PRESSFIRE_TEXT	15		// param1 is BOOL already pressed
														// param2 is (ushort*) text to be filled
														// param3 is color to be filled ( default is white, no need to be changed )
#define SC_MODESCRIPT_EVENT_PRESSFIRE_PRESSED	16		// param1 is mp_id of player that pressed fire														
#define SC_MODESCRIPT_EVENT_RESTARTMAP			17		// is called by game when the map is restarting - script should clear score, end rules and all game progress
														// is called on both server and clients
#define SC_MODESCRIPT_EVENT_RESTARTROUND		18		// is called by game or script when the round should be restarted
														// script can enable or disable it by changing param1 - 0 disable, 1 enable, default is 0														
														// is called on both server and clients, return value is checked on the server only
#define SC_MODESCRIPT_EVENT_LOCALMSG			19		// message from some local script

#define SC_MODESCRIPT_EVENT_PLAYERCREATED		20		// param1 is pl_handle of just created player, called on MP server only
#define SC_MODESCRIPT_EVENT_PLAYERRELEASED		21		// param1 is pl_handle of just released player, called on MP server only

#define SC_MODESCRIPT_EVENT_GETSIDESTATS		22		// param1 is side id ( 0,1 )
														// param2 is (ushort*)
														// this text is used in Limbo menu-players list at the bottom of the screen
#define SC_MODESCRIPT_EVENT_PLRESPAWNED			23		// param1 - player handle ( not sc_player !)
														// is called on both server and clients
#define SC_MODESCRIPT_EVENT_PLSSTATSCHANGED		24		// some player has changed score, kills or deaths
#define SC_MODESCRIPT_EVENT_HEAL				30		// param1 - medic handle
														// param2 - wounded handle
														// param3 - percent being heal ( 0 - 100)
														// event is not called when medik heals himself
#define SC_MODESCRIPT_EVENT_COMAHEAL			31		// param1 - medic handle
														// param2 - wounded handle
#define SC_MODESCRIPT_EVENT_ADDAMMO				32		// param1 - engineer handle
														// param2 - receiver handle
														// param3 - how many was added, it's a magic value: if player has 2 fully empty weapons, the value is 200, if has one full and one 1/4 empty, the value is 25
														// event is not called when engineer adds ammo to himself
#define SC_MODESCRIPT_EVENT_PLACED_AMMOSTORAGE	33		// param1 - engineer handle
														// param9 - position of ammo storage
#define SC_MODESCRIPT_EVENT_PLACED_FAS			34		// param1 - medic handle
														// param9 - position of First Aid Station




#define SC_MP_SIDE_FL_SHOWPOINTS		0x01

#define SC_P_EQP3PV_ID_MAX				8


#define SC_MP_MSG_TOALL					0xffff



#define SC_DOOR_STATE_NORMAL			0			// door is not locked and supports "hard closed" ( can be open by use only when fully closed )
#define SC_DOOR_STATE_LOCKED			1			// door is locked, cannot be opened
#define SC_DOOR_STATE_NODEADBOLT		2			// door is not locked and "hard closed" is disabled ( can be open by shooting or any other impuls even when fully closed )
#define SC_DOOR_STATE_DISABLED			3			// door is disabled ( is not active for USE, no lock is applied )



#define SC_P_MOVESPEED_STYLE_SPRINT			0
#define SC_P_MOVESPEED_STYLE_RUN			1
#define SC_P_MOVESPEED_STYLE_BACKRUN		2
#define SC_P_MOVESPEED_STYLE_SIDERUN		3
#define SC_P_MOVESPEED_STYLE_AIMFORW		4
#define SC_P_MOVESPEED_STYLE_AIMBACK		5
#define SC_P_MOVESPEED_STYLE_AIMSIDE		6




#define SC_AI_MOVINGPERIL_FL_VISIBILITY_ROTATION			0x01			// checks if AI can see it ( if is faced forward to the peril )
#define SC_AI_MOVINGPERIL_FL_VISIBILITY_DIRECT				0x02			// checks for direct visibility ( collision to the scene )


#define SC_VEH_WHEELCTRL_SNDS_MAX			3



#define SC_MP_MAP_GROUP_ID_UNIVERSAL			0			// universal group, items are visible all the time
#define SC_MP_MAP_GROUP_ID_STORAGES				3
#define SC_MP_MAP_GROUP_ID_FIRSTUSER			256

#define SC_MP_MAP_SIDEMASK_SIDE1				0x01
#define SC_MP_MAP_SIDEMASK_SIDE2				0x02
#define SC_MP_MAP_SIDEMASK_SPECTATOR			0x04


#define SC_MP_RESPGROUP_UNDEF				0
#define SC_MP_RESPGROUP_MAXID				255




#define SC_SP_OBJECTIVE_STATE_ACTIVE			0
#define SC_SP_OBJECTIVE_STATE_FINISHED			1
#define SC_SP_OBJECTIVE_STATE_FAILED			2
#define SC_SP_OBJECTIVE_STATE_NONE				3		// no icon is displayed


#define	SC_SIK_HEAD				0
#define	SC_SIK_CHEST		    1
#define	SC_SIK_HIPS				2
#define	SC_SIK_RARM				3
#define	SC_SIK_RFOREARM			4
#define	SC_SIK_LARM				5
#define	SC_SIK_LFOREARM			6
#define	SC_SIK_RTHIGH		    7
#define	SC_SIK_RCALF		    8
#define	SC_SIK_LTHIGH		    9
#define	SC_SIK_LCALF		    10




// return values for SC_P_CanPickupWeapon
#define SC_P_CANPICKUPWEAP_NO					0
#define SC_P_CANPICKUPWEAP_YES					1
#define SC_P_CANPICKUPWEAP_SWAP					2


// values for SC_MissionEnd
#define SC_MISSIONEND_TYPE_RUNS					0		// not to be set by script
#define SC_MISSIONEND_TYPE_FAILED				1
#define SC_MISSIONEND_TYPE_FINISHED				2
#define SC_MISSIONEND_TYPE_DONE_FADE			3
#define SC_MISSIONEND_TYPE_DONE_IMMEDIATELY		4


// values for SC_GetUserKeyName
#define SC_USERKEY_USE					1
#define SC_USERKEY_SHOOT				2
#define SC_USERKEY_AIM					3
#define SC_USERKEY_CHANGEFIREMODE		4
#define SC_USERKEY_MISSIONOBJECTIVES	5
#define SC_USERKEY_RELOAD				6
#define SC_USERKEY_TEAMCOMMAND			7



#define SC_MWP_FL_ROTATEAROUND			0x01


// for SC_Radar_ItemAdd
#define SC_RADARITEM_FL_CIRCLEHIGHLIGHT			0x01		// item is highlighted by pulsing circle
#define SC_RADARITEM_FL_NEARLIMIT				0x02		// item is rendered just when near to player
#define SC_RADARITEM_FL_FORVIETNAMMODETOO		0x04		// item is rendered in MP vietnam mode



// s_SC_Expl_CreateInfo::flags
#define SC_EXPLCREATE_FL_DISABLETEAMKILL			0x01
#define SC_EXPLCREATE_FL_DISABLEMAROKS				0x02		// explosion will not damage and move Marok objects
#define SC_EXPLCREATE_FL_DISABLESCENECOL_MAROK		0x04		// all Maroks in radius will get damage and impules ( has no sence when SC_EXPLCREATE_FL_DISABLEMAROKS is used )
#define SC_EXPLCREATE_FL_DISABLESCENECOL_PLAYERS	0x08		// all Playersin radius will get damage
#define SC_EXPLCREATE_FL_NOBLACKSPOT				0x10		// disables rendering of black spot

#define SC_EXPLCREATE_FL_VALIDBITS				5			// used for MP data send optimalization


// s_SC_Emitor_Create::flags
#define SC_EMITOR_FL_USEDOPPLER					0x01



#define SC_P_GENSPCH_GROUP_HIT					0x01
#define SC_P_GENSPCH_GROUP_SCRIPT				0x02
#define SC_P_GENSPCH_GROUP_SYSTEM				0x04
#define SC_P_GENSPCH_GROUP_RESPONSE				0x08



#define SC_P_AI_TEAMCMD_STATE_DISABLED			0
#define SC_P_AI_TEAMCMD_STATE_SCRIPTCONFIRM		1
#define SC_P_AI_TEAMCMD_STATE_ENABLED			2



// flags for SC_P_SetAnimsVariations and SC_P_GetAnimsVariations
#define SC_P_ANIMVARIATION_DISABLE_STATIV				0x01
#define SC_P_ANIMVARIATION_DISABLE_MOVEMENT				0x02
#define SC_P_ANIMVARIATION_DISABLE_STOPINGANIM			0x04				// dobehy...

#define SC_P_ANIMVARIATION_DISABLE_ALL					0xff


#define SC_HUD_LEFTTOP_DISABLED					0xffffffff

#define SC_LOUDSHOT_FL_PCONLY					0x01
#define SC_LOUDSHOT_FL_PERMANENT				0x02



#define SC_SPEECHADD_FL_ENDBY_ANIMEND			0x00		// is default, as it is zero, is valid when no other SC_SPEECHADD_FL_ENDBY_ is defined
#define SC_SPEECHADD_FL_ENDBY_SPEECHEND			0x01
#define SC_SPEECHADD_FL_ENDBY_LASTSPEECHEND		0x02		// animation is stopped when last speech of the player is finished
#define SC_SPEECHADD_FL_LOOPED					0x04
#define SC_SPEECHADD_FL_SETANIMFROMSTATIV		0x08		// sets stg depending on current player stativ
#define SC_SPEECHADD_FL_USEAUTOMATICANIM		0x10		// use automatic animation ( cannot be used with SC_SPEECHADD_FL_SETANIMFROMSTATIV )




#define SC_P_AI_SPECTASK_NONE					0
#define SC_P_AI_SPECTASK_GOTOHEAL				1
#define SC_P_AI_SPECTASK_GIVEAMMO				2
#define SC_P_AI_SPECTASK_OTHER					0xff



// variable types definition and some general defines


#ifndef _PTEN_


	#define FALSE		0
	#define TRUE		1

	#define NULL		0


	#define FLT_MAX         3.402823466e+38F

	#define PI			3.141592654f

	#define CLEAR(a) SC_ZeroMem(&a,sizeof(a))

	#define RAD_TO_DEG(a)				(a*57.2957795131f)
	#define DEG_TO_RAD(a)				(a*0.0174532925199f)

	typedef unsigned int dword;	

	typedef unsigned short ushort;		

	typedef unsigned char BYTE;		

	typedef int BOOL;
	
	typedef struct {
		float x,y,z;
	}c_Vector3;// struct c_Vector3
	
	typedef struct{
		c_Vector3 pos;
		float rad;
	}s_sphere;

	typedef struct{
		c_Vector3 pos;
		c_Vector3 right,front,up;	// orthonormal vectors
		float dx,dy,dz;				// lenghts of box edges
	}c_BoxOriented;


	extern int sprintf(char *, const char *, ...);
	extern int swprintf(ushort *, ushort*, ...);
	extern int rand(void);
	extern int strcmp(char *txt1, char *txt2);

	extern float frnd(float max);
	extern float sqrt(float val);
	extern float fmod(float a, float b);
	extern float absr(float val);

	extern float sin(float a);
	extern float cos(float a);
	extern float atan2(float y, float x);

#else
	class c_BoxOriented;
	#include "pte_global.h"
#endif  // #ifndef _PTEN_
	


typedef unsigned int sc_player;	
typedef unsigned int sc_plscript;	
typedef unsigned int sc_nod;	
typedef unsigned int sc_item;
typedef unsigned int sc_weapon;
typedef unsigned int sc_colmat;


typedef struct{
	dword message,param1,param2,param3;
	c_Vector3 param4;
	sc_player player;
	sc_plscript script;
	float elapsed_time;
	float next_exe_time;
}s_SC_Pscript_info;


typedef struct{

	dword message;			// SC_OBJ_MSG_
	sc_nod master_nod;
	sc_nod nod;	
	sc_item item;			// is !=0 for items

	float elapsed_time;
	float next_exe_time;

	dword param1,param2,param3;
	c_Vector3 param4;
	ushort *param5;
	float param6;

	dword hit_by;			// value is SC_OBJ_HIT_BY_xxxx
	dword hit_by_weap_type;	// correct value for missiles and explosions, 0 for marok
	// for SC_OBJ_HIT_BY_MISSILE
	c_Vector3 world_pos;
	c_Vector3 world_dir;
	dword tmissile;
	dword tmissile_id;
	float tmissile_damage;		// is filled by m_momentum first parameter from weap.txt
	sc_player hit_by_player;	

	/// for SC_OBJ_HIT_BY_MAROK
	c_Vector3 hitmarok_dL;
	c_Vector3 hitmarok_dP;
	float hit_energy;

	/// for SC_OBJ_HIT_BY_EXPLOSION
	sc_player hitexpl_by_player;
	dword hitexpl_script_type;	
	float hitexpl_damage;			// damage v zavislosti na damage_expl a vzdalenosti objektu	
	float hitexpl_whole_area;		// cela plocha objektu privracena k explozi
	float hitexpl_damaged_area;		// plocha objektu ktera obdrzela damage	
	

	// for SC_OBJ_MSG_VEHICLEGETWHEELPOWER and SC_OBJ_MSG_VEHICLE_DOTICK ( some of them )
	dword wh_index;
	BOOL wh_key_forw;
	BOOL wh_key_back;
	BOOL wh_key_left;
	BOOL wh_key_rght;
	BOOL wh_key_hbrk;
	float wh_veh_speed;
	float wh_veh_ang_speed;
	dword vh_veh_onground_mask;	// bit mask for max 32 wheels

	float wh_ret_power;
	float wh_ret_brake;
	float wh_ret_maxangelspeed;

	dword veh_ret_impulses;
	c_Vector3 *veh_ret_imp_size;
	c_Vector3 *veh_ret_imp_point;
	float wh_ret_soundrevs;	// from 0 to 1 ( to min&max is converted using vehicle definition )
	BOOL wh_ret_enginepowered;

}s_SC_OBJ_info;


typedef struct{
	dword event_type;		// SC_SCRHELPER_EVENTTYPE_xxxx
	s_sphere sph;
	sc_nod nod;
	char *nod_name;
	float elapsed_time;
	float next_exe_time;	

	dword param1;
	dword param2;
	dword param3;
	c_Vector3 param4;
}s_SC_ScriptHelper_info;



typedef struct{
	c_Vector3 loc;
	c_Vector3 rot;
	c_Vector3 scale;
}s_SC_NOD_transform;



typedef struct{	
	dword event;					// SC_MODESCRIPT_EVENT_
	dword param1,param2,param3,param4,param5;
	c_Vector3 param9;
	int param10,param11;
	float elapsed_time;				// valid in SC_MODESCRIPT_EVENT_DOTICK_SRV and SC_MODESCRIPT_EVENT_DOTICK_CLN
}s_SC_ModeScript_info;


typedef struct{
	dword savename_id;
	dword description_id;
	BOOL disable_info;		// TRUE - do not write info about game save on the screen
}s_SC_MissionSave;


typedef struct{
	dword type;			// type is SC_MISSIONEND_TYPE_
	
	sc_player failed_watch_pl;						// when type is failed, watch this player
	c_Vector3 failed_watch_from,failed_watch_dir;	// when type is failed and failed_watch_pl==NULL, watch this position

	char success_bink[256];							// when success_bink[0]!=0 play bink instead of fading out the screen

	ushort *failed_reason;

}s_SC_MissionEnd;


typedef struct{
	dword weap_type;			// weapon ID
	sc_nod from;					// start nod
	c_Vector3 dir;				// untransformed direction to fly off	
	c_Vector3 add_rot;			// change in rotation per second
}s_SC_FlyOffCartridge;


typedef struct{
	float r,g,b;
	float rad;	
	c_Vector3 pos;

	float time;
	BOOL decrease_radius;
}s_SC_light;



typedef struct{
	int hours;
	int minutes;
	int seconds;
	int msec;	
}s_SC_systime;



typedef struct{
	dword id;	
	dword color;
	float scale;
	c_Vector3 pos;
}s_SC_FpvMapSign;


typedef struct{
	dword message;		// SC_SOUND_MESSAGE_
}s_SC_SOUND_info;

typedef struct{	
	dword message,param1,param2,param3;
	float elapsed_time;						// elapsed time from the last SC_LEV_MSG_TIME
	float next_exe_time;					// time between 2 calls of SC_LEV_MSG_TIME
	c_Vector3 param4;
}s_SC_L_info;



typedef struct{

	dword event;
	sc_nod obj;
	dword weap_type;
	sc_weapon weapon;
	sc_player pl_id;			// pl_id - player

	dword weap_selbatch;	// selected batch
	dword weap_selbatch_magazine_id;	// which magazine ( 0/1 ) is used by currect batch
	dword weap_ammo[2];		// ammo in both possible magazines
	BOOL weap_bayonet_set;	// TRUE - bayonet is set, FALSE - is not
	dword pl_total_ammo;	// ammo player have in total for that selected batch is using

	
	// valid for SC_WEAPFPV_EVENT_DOTICK, SC_WEAPFPV_EVENT_VALIDATEANIM and SC_WEAPFPV_EVENT_GETANIMTIME only
	float elapsed_time;
	dword anim_id;	
	float cur_anim_time;
	float anim_fps;			// frames per second in current animation ( for various timing )
	dword eqp_index;		// set valid eqp index in every frame ( if weapon doesn't change it, you don't have to...)
	dword anmsys_index;		// set valid AnimSystem index, 0 is default 1 and 2 are user defined ( by SC_FPV_InitExtAnimSystem )

	
	BOOL valid_fpv_camera;	// false when watching pl from 3pv
							// valid for SC_WEAPFPV_EVENT_DOTICK only

}s_SC_WeapFpv_info;


typedef struct{

	dword event_type;		// SC_WEAP3PV_EVENT_
	sc_nod obj;				// 3pv weapons root
	dword weap_type;		// weapons type		
	sc_weapon weapon;
	sc_player pl_id;			// pl_id - player

	dword weap_selbatch;	// selected batch
	dword weap_selbatch_magazine_id;	// which magazine ( 0/1 ) is used by currect batch
	dword weap_ammo[2];		// ammo in both possible magazines
	BOOL weap_bayonet_set;	// TRUE - bayonet is set, FALSE - is not


	float elapsed_time;		// valid for SC_WEAP3PV_EVENTTYPE_TICK only

}s_SC_Weap3pv_info;




typedef struct{
	dword id;
	BOOL disabled;
	dword key_dinput;
	ushort *txt;
}s_SC_hud_menu_item;

typedef struct{

	dword recog_ptr;			// for menus identification
	
	ushort *title;

	dword items,default_item;
	s_SC_hud_menu_item *item;

	ushort *force_use_text;

}s_SC_hud_menu_init;


typedef struct{

	dword event;
	sc_weapon weapon;			// pointer at weapon
	dword weap_type;
	sc_player pl_id;
	BOOL pl_is_local;
	dword weap_flags;		// SC_WEAP_FL_		can be change in any call to script

	dword param1;
	dword param2;

	// valid for SC_WEAP_EVENT_DOTICK
	float elapsed_time;
	BOOL is_selected;		// TRUE when player has it in his hands

	
	BOOL inp_shoot;
	BOOL inp_shoot_just;
	BOOL inp_changebatch;
	BOOL inp_changebatch_just;
	BOOL inp_reload_just;
	BOOL inp_aim;
	BOOL inp_aim_switch;
	BOOL inp_changebayonet_just;
	BOOL inp_drop;
	dword inp_ai_use_param;
	BOOL inp_inobstacle;
		
	BOOL can_be_selected;		// output value from SC_WEAP_EVENT_CANSELECT

	dword change_val;			// for SC_WEAP_EVENT_MPCHANGE
	ushort *text;				// for SC_WEAP_EVENT_GETINFO_SHOOT
	s_SC_hud_menu_init *menu;

}s_SC_Weap_info;


typedef struct{
	char *filename;
	sc_nod nod;			// is NULL for scripts added by SC_PlScr_Add(char *filename);	
}s_SC_Plscr_info;



typedef struct{
	c_Vector3 pos;
	float rz;
	dword flags;		// SC_P_RESPPOS_FL_xxxxx
}s_SC_P_RespawnPos;

typedef struct{	
	dword weap_id;	
}s_SC_P_CreateWeap;

typedef struct{	
	ushort ammo_type;
	ushort max_ammo;
}s_SC_P_AmmoRedefine;


typedef struct{
	dword head_index;
	dword hat_index;
	dword eqp_index;
	dword voice_index;
}s_SC_P_Create_MpProps;

typedef struct{	
	sc_plscript script;		// author pl script

	dword mp_class;			// for use by MP game engine only
	dword type;				// SC_P_CREATE_TYPE_xxxx
	dword flags;			// SC_P_CREATE_FL_

	dword side;				// SC_P_SIDE_
	dword group;
	dword member_id;		// use SC_P_CREATE_MEMID_AUTO to auto assign member id ( values are from SC_P_CREATE_MEMID_AUTOSTART )

	dword name_nr;			// when 0, name_ansi and name_unicode is used
	char *name_ansi;
	ushort *name_unicode;

	dword class_name_id;	// medic, ing, ... just for writing on HUD when watching player, used in SP only
			
	char *inifile;
	char *eqp_inifile;
	char *head_name;		// name of the head to be used, NULL means random head from body definition
	char *head_eqp_inifile;

	char *genvoice_group;	// when NULL, definition from inifile is used
	
	s_SC_P_RespawnPos *respawn;	// when !=NULL, player is respawned on defined position immediatelly after is created

	dword weapons;
	s_SC_P_CreateWeap *weap;

	dword weap_select_tweap;	// valid when !=0

	dword ammo_redefines;					// nr of ammo to redefine
	s_SC_P_AmmoRedefine *ammo_redefine;		// list of ammo redefines

	float stamina_max;						// stamina ammount, 0.0f means default ( 100.0f )
	float stamina_sprintdec_mult;			// multiplicator of stamina decreasing when sprinting
	float movespeed_mult;					// movement speed multiplicator, 0.0f means default ( 1.0f )
	float health;							// 0 means ini file default

	s_SC_P_Create_MpProps mpprops[2];		// just for engine use in MP, not meant to be filled by the script

}s_SC_P_Create;


typedef struct{
	float caused_damage_mult;
	float received_damage_mult;
}s_SC_P_ScriptProps;

typedef struct{

	dword side_id;				// use SC_SIDE_xxxx for default sides ( US,VC,NEUTRAL)
	dword max_groups;

}s_SC_InitSide;


typedef struct{
	dword sphs;
	s_sphere *sph;

	dword boxes;
	c_BoxOriented *box;
}s_SC_Area;



typedef struct{

	dword cooperation_id;			// all players in the group with the same cooperation_id cooperate
	dword flags;					// SC_P_AI_MAINTASK_FL_xxx
	sc_player target_pl;			// player to follow	
	c_Vector3 target;				// point to search a way, valid when target_pl==NULL, 
									// MUST be placed exactly on the ground to allow searcway algo to find correctly the way
									//       and to avoid problems with HO_search_z_dist  ( there can be problem with finding a hideout around target when HO_search_z_dist is set too strictly and target is not placed on the ground)
	s_SC_Area *target_area;			// target area definition, on HO inside the area are used
									// can be NULL - no area limitations

	float move_step;				// 0 means go directly to target, otherwise searching step
	float HO_search_dist;			// distance to search for HO around target ( and by steps ) points
	float HO_search_z_dist;			// max distance to search for HO around target ( and by steps ) points in Z-axe, 0 means no limit

	float HO_movedist_max;			// max distance to move at the new HO from the center of searching ( when it's 0.0f this test is disabled )

	float max_target_pl_dist;		// used when target_pl!=NULL
									// AI will move when it's distance from target_pl is bigger than this value									
	float max_target_pl_z_dist;		// used when target_pl!=NULL
									// AI will move when it's distance from target_pl in Z axe is bigger than this value									
									// condition for move is (dist>max_target_pl_dist)||(z_dist>max_target_pl_z_dist)

	float min_enemy_dist;			// AI will not move closed than this distance ( from the nearest enemy )
									// 0 means move skip this test
	float max_enemy_dist;			// not used when target_pl!=NULL
									// AI will move if it's distance ( from the nearest enemy )is higher than this value
									// 0 means move skip this test

	float min_danger_dist;			// AI will not move closed than this distance ( from the nearest danger )
									// 0 means move skip this test
	float max_danger_dist;			// not used when target_pl!=NULL
									// AI will move if it's distance ( from the nearest danger ) is higher than this value
									// 0 means move skip this test

	float last_perc_in_group_moves;	// not used when target_pl!=NULL
									// 100.0f means all, 0 only the last one

	float max_pc_distance;			// max distance from PC, usage is specified by SC_P_AI_MAINTASK_FL_PCDIST_xxx flags
									// 0 means no tests

	float nextmove_interval,nextmove_interval_rand;
									// nextmove_interval - 0 means engine default, nextmove_interval + frnd01()* nextmove_interval_rand									

	float start_delay;				// 0 means use default, otherwise use this value

}s_SC_P_Ai_MainTask;


typedef struct{	

	float FDverify_time_mult;	// kolikrat rychleji PC zverifikuje FakeDanger oproti AI ( 0.0f znamena ze neverifikuje )
	float FDverify_maxdist_to_nearest_groupAI;
									// maximalni povolena vzdalenost k nejblizsimu AI z groupy aby se verifikovalo, 0.0f znamena no limit	
	float FDverify_viewangle;	// max odchylka smeru pohledu PC od smeru k FD, aby dochazelo k verifikovani

}s_SC_P_PC_MainTask;




// used by SC_AI_FakeDanger_Add

typedef struct{	
	dword flags;				// not used yet
	char *name;					// scene entity name
	float verify_time;			// if 0, no verifying of this FakeDanger is done	
}s_SC_AI_FakeDanger;



typedef struct{	
	// is saved as a block to p2g, doesn't change order or use pointers
	dword flags;							// SC_AI_GROUP_FL_
	float enemy_info_max_distance;			// maximum distance between players in group to share info about enemies	
}s_SC_AI_GroupProps;




typedef struct{
	float distance;						// distance of this point
	float angle;						// visible angle 
	float angle_perception_lost;		// ztrata vnimavosti v neprimem smeru
										// vliv ztraty vnimavosti:  sila_vjemu = pow(abs(uhel_k_podnetu - uhel_pohledu) / max_uhel, perception_lost );
										// coz je hodnota od 0 ( primy smer) do 1 ( na hranici max uhlu) umocnena na perception_lost 
										// perception_lost = 1 znamena linearne
										// perception_lost = 3 napriklad znamena pomaly ubytek vnimavosti ( v polovine uhlu ma jeste 87.5% )
										// perception_lost = 0.3 je velmi rychly ubytek vnimavosti ( v polovine uhlu je to uz jenom 18.8% )
	float distance_perception_lost;
										// hodnota 1 znamena zadna zmena se vzdalenosti
										// hodnota mensi nez 1 je ubytek vnimavost, hodnota vetsi nez 1 je blbost...
}s_SC_P_AI_props_vis;


typedef struct{	// must be the same as engine s_GM_pl_ai_props structure

	dword flags;							// SC_PLAI_PROPS_FL_
	float max_visibility;

	s_SC_P_AI_props_vis vis[3];
	float vis_perception_mult;				// global multiplicator for all modes

	float vis_perception_mult_script;		// global multiplicator for script mode
	float vis_perception_mult_peace;		// global multiplicator for peace mode
	float vis_perception_mult_peace_fakedanger;// global multiplicator for peace fake danger mode
	float vis_perception_mult_danger;		// global multiplicator for danger mode
	float vis_perception_mult_battle;		// global multiplicator for battle mode

	float vis_perception_mult_danger_item;	// pouzite kdyz je visual zaroven take danger ( nepritel vystrelil -> danger_item, hrac se podiva tim smerem a uvidi ho, ma na nej tento bonus )

	float vis_perception_phase[3];			// when target stands, crouch and lie
	float vis_perception_move[3];			// kvadraticka rovnice s rychlosti v m/s: mult = (move[0] * speed * speed) + (move[1] * speed ) + move[2]
	float vis_perception_phase_change;		// multiplicator kdyz postava si kleka/leha atd...
	float vis_perception_aim_change[3];		// multiplicator kdyz postava zamiruje nebo odmiruje v stoji/kleku/lehu
	float vis_ammount_decrease_persec;		// when not see some visual, decrease his ammount by this value per second

	float forget_time_enemy;				// time from the last enemy spotting to forgotting him

	float forget_time_danger_shooting;		// time from the last danger update to forgotting it

	float danger_around_stop_shooting;		// pri jake hodnote danger around postava prerusi strelbu z ukrytu
	float danger_around_no_peepout;			// pri jake hodnote uz postava nevystrci hlavu z ukrytu

	float danger_visual_to_enemy_value;		// visual.amount 0-1 pri ktere se visual zmeni na enemy kdyz je na dane pozici zaroven danger

	float hear_enemy_detection;				// jak rychle zdetekuje nepritele na zaklade jeho strelby ( kazdy vystrel po vetsim case /1sec/ ) "upresnuje"
	float hear_enemy_detection_max_distance;// na jakou max vzdalenost je AI schopno zdetekovat nepritele pouze podle strelby
	float hear_enemy_detection_max_distance_z;// na jakou max vzdalenost v ose Z je AI schopno zdetekovat nepritele pouze podle strelby
												// 0 znamena no limit

	float hear_max_distance;				// natvrdo orezava vzdalenost na jakou AI slysi ( treba pro pouziti v budovach ), pokud je nastaveno na 0, neni zadny limit ( pouze ten dany zvukem - pro vystrel to je z definice ve weapu ), default 0.0f
	float hear_max_distance_z;				// default 0.0f

	float danger_reaction_time_min,danger_reaction_time_max;	// cas po jakym se podiva na novy danger
	float danger_lookat_time_mult;			// nasobitel casu po ktery se diva na novy danger ( cas se zavisli na herni situaci )
	float danger_lookat_sure_time_min,danger_lookat_sure_time_max;		// cas ktery ceka po poslednim updatu shoot_danger nez vykoukne z krytu
	
	float peace_lookat_visuals_min_ammount;	// ammount hodnota visualu pri ktere se na nej zacne AI divat ( jak brzo se otoci na vizualni podnet, ktery jeste neni identifikovan jako nepritel ), 0 je okamzite, 1 je nikdy ( pri ammount 1 uz je to nepritel )

	float battlemode_tohideout_dist_max;			// maximalni vzdalenost na jakou hleda HO
	float battlemode_tohideout_z_dist_max;			// maximalni vzdalenost v Z ose na jakou hleda HO
	float battlemode_tohideout_nearestenemy_mult;	// bude hledat HO na X nasobek vzdalenosti nejblizsiho enemy 
	float battlemode_tohideout_fix_dist;			// hledaci vzdalenost je: min(dist_max,fix_dist + nearest_dist() * nearestenemy_mult)
	float battlemode_tohideout_movedist_mult_max;	// nasobek "hledaci vzdalenosti", ktery se pouzije jako maximum pro test skutecne vzdalenosti presunu ( pomoci search way), 0.0f znamena ze se to netestuje, values >1.0f have sence only

	float fakedangermode_tohideout_dist_max;		// maximalni vzdalenost na jakou hleda lepsi HO, default 4.0f
	float fakedangermode_tohideout_z_dist_max;		// maximalni vzdalenost v Z ose na jakou hleda HO
	float fakedangermode_tohideout_fix_dist;
	float fakedangermode_tohideout_time_mult;		// maximalni vzdalenost je
													// min(fix_dist + time_mult * time_po_ktery_tam_chce_jit, dist_max);
	float fakedangermode_tohideout_movedist_max;	// maximalni skutecna vzdalenost ( pomoci searchway) na jakou se presouva, 0.0f znamena ze se to netestuje, melo by byt napr 1.4 * fakedangermode_tohideout_dist_max
	

	float enemydead_recognize_immediatelly_dist;	// do jake vzdalenosti rozpozna mrtveho nepritele bez nutnosti ho visualne overit, default is 10m
	float enemydead_recognize_speed;				// jak rychle vizualne overi mrtveho nepritele, default is 3.0 ( v porovnani s vsimnutim si ziveho nepritele )
	float enemydead_forget_speed_mult;				// kolikrat rychleji "zapomina" na nepritele kdyz je mrtvy ( fake na osetreni situaci kdy mrtveho nevidi ), default is 2.0


	float shoot_imprecision_xy;						// default 0.3f
	float shoot_imprecision_z;						// default 0.1f
													// nepresnost strelby,	0.0f znamena 100% presnost
													//						1.0 znamena 10% odchylka v presnosti ( na 20m strili s nahodnym rozptylem 0 az 2m)
	float shoot_imprecision_correction_time_min;	// 0.0f znamena zadne "korekce" behem strelby
	float shoot_imprecision_correction_time_max;	// casovy interval po kterem se snazi lepe zamirit ( najde si novou nahodnou ochylku dle shoot_imprecision a za zvoleny cas tam premiri)
													// vysledkem je kyvani zbrani kolem cile

	float allydeath_reaction_hear_dist;				// vzdalenost na jakou slysi umirajiciho spojence, default 4.0f, max is 15.0f
	float allydeath_reaction_vis_dist;				// vzdalenost na jakou vidi umirajiciho spojence, default 10.0f, max is 15.0f
	BOOL allydeath_reaction_do_collision_test;		// vypina/zapina provedeni testu viditelnosti na umirajiciho spojence, default FALSE

	float aimtime_max;					// maximalni cas pro zamireni, default 0.7f
	float aimtime_canshoot;				// hodnota 'casu', pod kterou jiz muze strilet, default 0.1f, nikdy nenastavovat na nulu nebo nebude skoro nikdy strilet ( i male domireni mu zpusobi ze zase musi cekat )
	float aimtime_rotmult;				// nasobitel otoceni, default 0.5f
	float aimtime_enemy_min_dist;		// pokud je cil blize jak tato hodnota, tak se aimtime nebere v uvahu, default 8.0f
	

	float firstweakshoot_time;			// when >0, the first weak shooting batch when shooting at new deteceted anemy is enabled
										//				shooting will be weaker for selected time
										// when 0, this AI feature is disabled
										// target has to have SC_P_CREATE_FL_TARGET_FOR_AIFIRSTWEEKSHOT to enable this feature
										// default values is 1.5f	
	float firstweakshoot_damagemult;	// used when damaging target during "first weak shooting batch when shooting at new deteceted anemy"
										// default is 0.25f
	float firstweakshoot_imprec_mult;	// both shoot_imprecision_xy and shoot_imprecision_z are multiplicated during "first weak shooting batch when shooting at new deteceted anemy"
										// default is 2.0f, 

	float mwp_search_dist;				// max distance to search mounted weapons for automatic use
										// 0 means do not search
										// when mwp_search_dist>0 and AI is using some, it can leave it when the situation is not suitable
										// default is 0

	float deadbodycheck_searchdistance;			// how far will AI check for dead enemies
												// default value is 15.0f
												// 0.0f means no checking
	float deadbodycheck_maxmovedistance;		// how far AI will move to check dead enemy
												// default value is 22.0f		


	float fakedanger_movewatch;					// default is 1.0f and means watch fake dangers during all moving
												// 0.0f means never watch, values between are probability...

	// hodnoty battlemoves_timelimit_* nastavuji limit, po jaky musi AI zustat na hideoutu nez se muze znovu presunout ( aby zmatene nebehali )
	// cas je nulovan, pokud je postava zasazena = kdyz ji nekdo zasahuje tak se samozrejme muze hybat okamzite
	float battlemoves_timelimit_zerotimedist;	// do jake vzdalenosti od nejblizsiho nepritele je ten limitni cas 0
												// default is 5.0f												
	float battlemoves_timelimit_1sec_distance;	// o kolik metru musi byt nepritel dal aby se limitni cas zvysil o jednu vterinu
												// default is 2.0f
	float battlemoves_timelimit_maxval;			// maximalni hodnota limitu vzdalenosti ( aby hodne vzdaleni nepratele nezpusobovali prilis dlouhe casy )
												// default is 14.0f



// values not set, but calculated by Recalculate() in the game engine
	
	float _vis_angle_one_near_inv_distance;	// = 1.0f/ (vis_angle_near_distance - 1.0f)
	float _vis_angle_near_far_inv_distance;	// = 1.0f/ (vis_angle_far_distance-vis_angle_near_distance)

	float _hear_max_distance2;
	float _aimtime_enemy_min_dist2;

}s_SC_P_AI_props;

typedef struct{
	dword static_phase;		// SC_P_PHASE_
	BOOL static_aim;		
	int static_lean;		// SC_P_LEAN_
	dword move_phase;		// SC_P_PHASE_
	dword move_style;		// SC_P_AI_MOVESTYLE_
}s_SC_P_AI_ScriptModeProps;



typedef struct{
	// do not forget to add to the save every new member
	dword flags;		// SC_P_AI_WATCHSHOOT_FL_
	sc_player player;
	c_Vector3 pos;		// valid when player==0
	float time;			// cas po ktery se bude divat/strilet na cil
	
	dword phase;		// SC_P_PHASE_xxx
	BOOL aim;			// FALSE/TRUE
	int lean;			// SC_P_LEAN_
}s_SC_P_AI_WatchShoot;


typedef struct{	
	c_Vector3 pos;
	dword phase;		// SC_P_PHASE_
	float lean;			// from -1.0f to 1.0f, no lean is 0.0f
	float aim;			// phase of aiming ( 0.0f is no aim, 1.0f is full aim )
	float rz;
	float rx;
	c_Vector3 movdir;
	float hp,max_hp;
	BOOL is_local;
	float control_disabled;
	BOOL pc_view_underwater;
	dword health_status;	// SC_P_HEALTHSTATUS_
}s_SC_P_status;


typedef struct{	
	dword ai_mode;		// SC_P_AI_MODE_
	dword enemies;
	dword dangers_all;			// all dangers ( activated and new too )
	dword dangers_activated;	// only activated dangers ( when a new danger is added, it takes some time to activate it - about 1 sec )
	dword visuals;
	dword impulses;
	float danger_around;
}s_SC_P_AI_status;



typedef struct{
	c_Vector3 *coverfrom_pos;				// can be NULL, point to cover from
	float coverfrom_distance;				// range of covering from coverfrom_pos
	s_SC_Area *forbidden_area;				// NULL means no test, area player cannot be
			// at least one of pos or area must be filled and both can be filled too
	float time;			// 0 means for ever
}s_SC_AI_Peril;





typedef struct{	
	dword flags;					// SC_AI_MOVINGPERIL_FL_
	dword author_side;
	BOOL author_is_PC;

	sc_nod marok_nod;				// can be 0, but be carefull with "pos" visibility detection ( grenades for example )
									// zadava se objekt, ktery se pri detekci kolize nema brat v uvahu ( granat, auto,... )
	c_Vector3 pos;					// current position of peril
	c_Vector3 move_dir;				// move_dir of peril
	float danger_radius;			// explosion radius for example
	float item_start_danger_time;	// 0 means is dangerous from now, 1 means will be dangerous after 1 second		
	float item_live_time;			// how long will be object causing peril active yet
	float gravity;					// object gravity	
	float ai_min_detection_distance;// at which distance from AI can be detected
	float ai_hear_distance;			// at which distance AI is able to "hear" moving item

	float peril_live_time;			// live time of peril

	dword genspch_aisee_reaction;			// ID of generic speech used when AI see this moving peril
	dword genspch_aisee_reaction_isfromPC;	// ID of generic speech used when AI see this moving peril from ally PC
}s_SC_AI_MovingPeril;



typedef struct{
	dword flags;		// SC_P_AI_MOVESTYLE_FL_xxxx
	float phase;		// 0 - stand, 1 - crouch, 0.3 means 70% probability of stand
	float aim;			// 0 - no aim, 1 - aim, 0.8 means 80% probability of aim
	float sprint;		// 0 - no sprint, 1 - sprint, 0.4 means 40% of sprint
}s_SC_P_AI_MoveStyle_Mode;


typedef struct{
	s_SC_P_AI_MoveStyle_Mode peace;
	s_SC_P_AI_MoveStyle_Mode fakedanger;
	s_SC_P_AI_MoveStyle_Mode danger;
	s_SC_P_AI_MoveStyle_Mode battle;
}s_SC_P_AI_MoveStyle;

typedef struct{
	dword flags;		// SC_P_AI_STANDSTYLE_FL_
	dword phase;		// 0 - stand, 1 - crouch
	BOOL aim;			// FALSE - no aim, TRUE - aim
	int lean;			// SC_P_LEAN_
}s_SC_P_AI_StandStyle_Mode;


typedef struct{
	s_SC_P_AI_StandStyle_Mode peace;
}s_SC_P_AI_StandStyle;

typedef struct{
	sc_player plid;			// valid sc_player or SC_SPEECHAUTHOR_GENERAL
	c_Vector3 pos;			// valid when plid==NULL	
}s_SC_Speech_Author;


typedef struct{
	s_SC_Speech_Author author;
	dword speech_nr;					// id of speech ( both text and sample )
	ushort *speech_text;				// when !=NULL, text is used from here
	dword force_authorname_id;
	ushort *force_authorname_text;		// those 2 can be used to overwrite default ( players ) name
										// it should be filled for nopl ( just position speech ) otherwise 'no author' of speech is written on the screen
	float timer;						// IN: includes activation time
										// OUT: is increased by lenght of speech and selected gap
	float timer_gap;					// gap that is added to timer ( to postpone next speech , is done automaticly, script doesn't have to care for it )
	dword callback_id;					// when !=0, callback is called into level.c with selected id ( SC_LEV_MSG_SPEECHCALLBACK )

	float force_stay_time;				// when 0, the time is taken from sample length or text lenght
										// when >0, message will stay for this time	

	sc_player sayto_pl;					// when 0, not used
	c_Vector3 *sayto_place;				// when NULL, not used


	char *playanim_file;
	dword playanim_flags;				// SC_SPEECHADD_FL_
	
}s_SC_SpeechAdd;




typedef struct{
	dword flags;		// SC_SPEECHPROPS_FL_
	float max_subtitle_dist;
	dword type;			// SC_SPEECHPROPS_TYPE_
}s_SC_SpeechProps;

typedef struct{
	BOOL movement;
	BOOL phasechange;
	BOOL looking;
	BOOL weapons;
	BOOL interaction;
	BOOL enter_vehicle;
	BOOL leave_swap_vehicle;			// will be removed soon !

	BOOL leave_vehicle;
	BOOL swap_vehicle;

	BOOL use_mwp;
	BOOL leave_mwp;
	BOOL use_binocular;
	BOOL weapons_except_aim;
}s_SC_PC_Control;




typedef struct{
	dword weap_type;			// id of weapon type from weap.txt
	dword flags;				// SC_MWP_FL_
	dword multi;				// number of 'multi weapons'
								// 0 means don't use  ( = use nod_muzzle )
								// 1 has no sence, is invalid
								// 2 and more means mwp has more weapons ( nod_muzzle_multi is the list of muzzle nodes )

	dword use_info_txt_id;		// text to be displayed when looking at
	dword exit_info_txt_id;		// text to be displayed when using it	

	sc_nod master_nod;			// it's name is used for scene mwp identification, it's also nod with the script	
	sc_nod nod_base;				// base of weapon ( AI uses for recognizing position in scene)
	sc_nod nod_rotate_x;			// dummy to rotate up/down
	sc_nod nod_rotate_z;			// dummy to rotate left/right
	sc_nod nod_rotate_last;		// nod_rotate_x of nod_rotate_y (the one, which is 'lower' in hiearchy) (for camera movement)
	sc_nod nod_fpv_camera;		// place, where camera is places
	sc_nod nod_active_pos;		// center of detection sphere ( used for interaction)
	sc_nod nod_muzzle;
	sc_nod *nod_muzzle_multi;
	sc_nod nod_entry;			// centre of 3pv animation
	
	

	float active_rad;			// radius of detection sphere
	float active_dist;			// max distance of detection sphere from camera when
	float active_cos_min;		// 0 means default ( 0.2f), 1 - just from behind exactly ( not be used ), -1 means from everywhere

	float rotate_zmin,rotate_zmax;		// limit angles
	float rotate_xmin,rotate_xmax;		// limit angles
	float rotate_speed;					// 1.0f - the same as player rotation speed

	float player_anim_begin;	// default is 0.0f
	float player_anim_end;	// default is 1.0f

	float flash_rot_step;		// 0 means all rotations possible, value bigger then PI means no rotation possible

	float speed_limit_x;		// in radians per second, 0 means no limit
	float speed_limit_z;		// in radians per second, 0 means no limit

	char *anim_dir;

	BOOL is_on_vehicle;			// TRUE when mpw is used for vehicle link

	dword rotate_snd_id;

	float overheat_per_shot;	// o kolik se zvysi prehrivani zbrane za jeden vystrel
	float overheat_per_second;	// o kolik se snizi prehrivani za sekundu

	float shot_start_move;		// posun zacatku letu strely ve smeru strely ( rozumne hodnoty jsou <0, pouziti aby strela vyletela ne z konce hlavne ale treba z prostredku, abysme vyresili prolitavani skrz zdi pri 'zabodnuti hlavne'

}s_SC_MWP_Create;


typedef struct{

	c_Vector3 shoot_pos,shoot_dir;

	sc_nod muzzle_nod;
	sc_nod vehicle_marok_nod;		// filled when mwp is on the vehicle

}s_SC_MwpInfo;


typedef struct{

	dword enter_text;			
	ushort *enter_text_ushort;

	sc_nod nod;							// main nod of vehicle
	sc_nod nod_activate;				// must be a Marok object - slouzi na nastoupeni - detekuje se hracuv pohled

	sc_nod nod_mp_sideflag;				// nod used to place Side Flag in MP

	char *anims_root_folder;	// root folder for animations

	char *mp_map_icon;

	dword horn_sound_id;		// id of sound played when using the horn
	float shadow_z_move;		// 0.0f means shadow alpha is calculated from center of nod_activate
								// values bigger then 0 means higher alpha values..
								// values bigger then 1000.0f means no shadow ( fake... )
}s_SC_VehicleInit;


typedef struct{

	dword type;					// SC_VEHICLESEATTYPE_
	dword flags;				// SC_VEHICLESEAT_FL_
	dword dstr_dead;			// SC_VEHICLESEATDSTRDEAD_

	dword name_nr;

	sc_nod mwp_nod;				// valid when type==SC_VEHICLESEATTYPE_MWP

	char *pos_nod;	
	char *entry_nod;			// for AI to fit enter animation
	char *viewpos;

	float rx_min,rx_max;
	float rz_min,rz_max;

	char *anim_enter;			// can be NULL - player enters vehicle immediatelly then
	char *anim_leave;			// can be NULL - player leaves vehicle immediatelly then

	char *anim_stativ;			// watch around, driver, can be NULL -> player is not rendered, valid for SC_VEHICLESEATTYPE_SHOOT too - used when player is not shooting ( just watching around )
	char *anim_shoot_up;
	char *anim_shoot_middle;
	char *anim_shoot_down;
	char *anim_dead;

	char *watch3pv_nod;			// NULL means 3pv is disabled
	c_Vector3 watch3pv_vec;		// distance from which the nod is watched

	float overturn_kill_z_limit;	// 0 means 90degrees limit	
									// when Z of transform up vector of the vehicles is smaller then overturn_kill_z_limit, the player is killed (IK is used )
									// use value <-1.0f for disabling

}s_SC_VehicleSeatInit;


typedef struct{
    c_Vector3 pos;
    float rot_quaternion[4];
}s_SC_Marok_Placement;

typedef struct{
	s_SC_Marok_Placement placement;
    c_Vector3 linear_velocity;		// not valid for SC_Marok_SetState, use SC_Marok_Impuls
    c_Vector3 angular_velocity;     // not valid for SC_Marok_SetState, use SC_Marok_Impuls
}s_SC_MarokObjState;



typedef struct{
	float situpd_per_sec_max;
	float battlemove_per_sec_max;	
}s_SC_AI_props;



typedef struct{
	dword flags;			// SC_EXPLCREATE_FL_xxxx
	dword author_handle;	// use 0 for unknown player author
	s_sphere sph;
	float damage;			// hand grenade has aprox 100.0f
	float marok_impuls;		// hand grenade has aprox 300.0f
	float piercing;			// hand grenade has aprox 10.0f, 0.0f means 10.0f ( for easier editing )
	dword tweap_id;
	dword ptc_id;	
	dword script_type;		// for use by scripts to identify various explosion types, only 6-lower bits can be used ( network optimalization )

	float valid_x_center,valid_x_size;		// possibility do define the angle, valid_x_size==0 means no limit
	float valid_z_center,valid_z_size;		// possibility do define the angle, valid_z_size==0 means no limit
}s_SC_Expl_CreateInfo;


typedef struct{

	dword flags;			// SC_CREATEITEM_FL_

	dword item_type;		// item is created from item_type
	char *bes_name;			// item is created just from BES

	c_Vector3 pos,rot;
    c_Vector3 linear_velocity,angular_velocity;

	BYTE *data;		// NULL means no data
	dword data_size;

	dword redefine_props_use_mask;			// SC_CREATEITEM_USEMASK_
	dword redefine_props_flags;				// SC_CREATEITEM_PHSINIT_FL_
	float redefine_props_m;
	float redefine_props_gravity;
	
}s_SC_ItemCreate;



typedef struct{

	dword script_id;			// for internal script use - to identify group later, DO NOT USE id SC_MP_RESPGROUP_UNDEF value
								// max value is SC_MP_RESPGROUP_MAXID
	char *respawn_name;			// for automatic respawn_points fill ( searches for those respawns in scene )

	float resp_min_distance;	// minimal distance some player can stand from respawn position to allow respawn there

// for showing on the map
	BOOL map_position_enable;
	c_Vector3 *map_position;	// if NULL, average of respawns is taken	

}s_SC_MP_RespawnGroupCreate;


typedef struct{
	dword side_id;			// side id to - recognize respawn groups, use to create players
	dword name_id;			// id into text DB
	char *name_ansi;		// used when name_id is 0

	dword info_id;

	char *logo_filename;
	char *menu_profile;

	dword flags;			// SC_MP_SIDE_FL_
	dword color;			// side color for MP texts
							// 0 means use default for used side id
	char *vehicle_flag_bes;

}s_SC_MP_SideInfo;



typedef struct{
	BYTE data[12];
}s_SC_NodHandle;



typedef struct{
	
	sc_nod wheel_nod;

	c_Vector3 body_point;
	c_Vector3 body_vector;	// normalized

	float damper_min_size;
	float damper_max_size;

	float wheel_rad;         // radius of wheel
      
    float spring_rate;		// tuhost pruziny
	
						
    float spring_squeeze;   // dispalcement of the spring when whell is in downer position
							// o kolik se pruzina prodlouzi po vyndani z auta 
							//	= o kolik metru je v aute ( v maximalnim zdvihu tlumicu ) stlacena oproti nestlacenemu stavu

    float damper_damping;   // magnitude of friction force of spring
							// odpor tlumice ( sila )
    
	char *phs_material_name;    
       
    float friction_looser;	// koeficient in range <0,1> which modifies friction koeficient between whell and road when whell is 'smykuje'
							// koeficinet treni kola kdyz se utrhne ( 0 znamena ze netre vubec, 1 znamena ze neni zmena )

    float wheel_weight;      // weight of wheel in kg

	float material_friction_mult;
							// multiplicator of selected material friction ( must be >= 0 )
	

	float engine_fwrd;		// power of engine when engine should move car forward
	float engine_bkrd;		// power of engine when engine should move car backward
	float engine_left;		// power of engine when vehicles is steering left
	float engine_right;		// power of engine when vehicles is steering right
							// all these 4 values are added to the total wheel_engine_value
							//		and total engine power is divided to all wheels in corresponding ratio
							// negative values mean power in oposite direction
	
	float brake_power;		// brake power in Nm
	float handbrake_power;	// handbrake power in Nm
	float nodriver_brake_power;// brake power in Nm applied when there is no driver in the vehicle
	float engine_nothrotle_brake_power;	// braking power of the engine when no throttle is pressed

	float steering_mult;	// 0 means no steering
							// 1 means steering in normal direction
							// -1 means steering in opposite direction

}s_SC_Vehicle_Wheel;

typedef struct{

	dword snd_id;
	c_Vector3 pos;	
	float freqmult_1,freqmult_revs1;
	float freqmult_2,freqmult_revs2;
	
	float volume_throtle[20];
	float volume_nothrotle[20];

}s_SC_Vehicle_WheelControl_Snd;


typedef struct{

	sc_nod vehicle_nod;

	BOOL use_wheelpower_callback;
	BOOL use_script_tick;			// enables calls of SC_OBJ_MSG_VEHICLE_DOTICK	
	dword wheels;
	s_SC_Vehicle_Wheel *wheel;

	sc_nod steeringwheel_nod;
	float steeringwheel_max_rot;	// max rotation, must be adjucted according to driver animation


	float steer_max;
	float steer_speed;
	float steer_backspeed;
	float steer_curse[11];	// index 'x' - real steer angle when steer is (x * 0.1)

	//float steer_max_mult_at10mpersec;
	//float steer_speed_mult_at10mpersec;
	//float steer_backspeed_mult_at10mpersec;
							
	float eng_max_revs;			// max otacky za minutu
	float eng_freewheel_revs;	// otacky motoru pri volnobehu
	float eng_revs_slowdown;
	float eng_min_revs;			// minimalni pouzitelne otacky motoru (pouziva automaticka spojka)
	float eng_max_power_revs;	// do jakych otacek dava motor vykon
	float eng_braking_revs;			// od jakych otacek uz engine nedava silu ale bzdi ( pretoceni )
	float eng_braking_revs_power;	// pri pretoceni je to sila brzdy na kazdych 1000 otacek nad to


	s_SC_Vehicle_WheelControl_Snd snd[SC_VEH_WHEELCTRL_SNDS_MAX];

	dword eng_start_sound;				//  sound played when engine starts
	dword eng_stop_sound;				//  sound played when engine stops
	float eng_sound_volumeup_speed;		// how fast will standart sounds ( snd[] ) became full volume after engine starts
	float eng_sound_volumedown_speed;	// how fast will standart sounds ( snd[] ) became min volume after engine stops

	
	float eng_Nm[20];		// Nm at 0rpm [0], 1000rpm [1], 2000rpm [2] .....	
	

	float trns_force_delay;
	dword trns_gears;		
	float trns_fixed_ratio;

	float trns_gear[10];			// 0 is reverse, 1 is 1, 2 is 2,....
	float trns_gear_up[10];			// pri jakych otackach motoru se radi vys ( trns_gear_up[cur_gear] )
	float trns_gear_down[10];		// pri jakych maximalnich otackach nizsiho stupne se podrazuje ( trns_gear_down[cur_gear-X] )

	

	// odpor ( vzduchu, nahodnu, ... )
	float move_resistance_const;	// konstnantni	
	float move_resistance_lin;		// linearni
	float move_resistance_quad;		// kvadraticky

}s_SC_Vehicle_WheelControl;

typedef struct{
	sc_nod nod;					// active wheel is recognized automaticly ( from the vehicle wheels list )									

	float radius;				// muliply of rotation speed for passive wheeels

}s_SC_Vehicle_TrackDefinition_Wheel;


typedef struct{
	sc_nod nod;

	sc_nod wheel_start;		// MUST be NULL for static wheels
	sc_nod wheel_end;		// MUST be NULL for static wheels

}s_SC_Vehicle_TrackDefinition_Segment;

typedef struct{

	sc_nod vehicle_nod;

	dword passive_wheels;
	s_SC_Vehicle_TrackDefinition_Wheel *passive_wheel;

	dword segments;
	s_SC_Vehicle_TrackDefinition_Segment *segment;

	float tex_move_speed;				// speed of the texture moving on the track segment

}s_SC_Vehicle_TrackDefinition;





typedef struct{
	dword id;				// from SC_MP_MAP_GROUP_ID_FIRSTUSER up
	dword side_mask;		// SC_MP_MAP_SIDEMASK_
	dword text_nr;
	char *text_ansi;
	ushort *text_uni;
}s_SC_MP_Map_Group;

typedef struct{
	char *bitmap_file;
	char *tranform_file;

	dword user_groups;
	s_SC_MP_Map_Group *user_group;

}s_SC_MP_Map_Init;

typedef struct{	
	dword side_mask;		// SC_MP_MAP_SIDEMASK_
	dword group_id;
	c_Vector3 world_pos;
	char *icon;
	char *icon2;			// used for selected or completed - depends on the type	
	dword objective_id;		// 0 means no objective	

	dword internal_id;		// for engine internal, do not fill
}s_SC_MP_Map_Item;


typedef struct{	
	dword side_mask;		// SC_MP_MAP_SIDEMASK_
	dword objective_id;
	BOOL finished;
	char *picture;
	char *picture_finished;	// when objective is finished, the picture_finighed is drawn over picture or movie	
	dword text_nr;
	char *text_ansi;
	ushort *text_uni;
}s_SC_MP_Map_Objective;


typedef struct{
	BOOL enable_pcpl_coma;	// PC players can fall to coma, has sence for modes with medics
							// default is FALSE
	BOOL teamgame;			// used for displaying allied soldiers on radar, map,....
							// default is TRUE
}s_SC_MP_Props;




typedef struct{
	float reload_time[2];
	ushort *user_name;
	dword slot;
	dword item_type;
	dword ammo_itemtype[2];
}s_SC_TweapInfo;


typedef struct{
	dword flags;		// SC_EMITOR_FL_
	BOOL store_in_save;
	c_Vector3 pos;	
}s_SC_Emitor_Create;


typedef struct{
	dword state;		// SC_SP_OBJECTIVE_STATE_
	dword text_id;
	ushort *text_uni;
}s_SC_SP_Objective;


typedef struct{
	float range;
}s_SC_RadarProp;



typedef struct{

	float range;
	float movedist_limit;			// distance limit for move to wounded ( calculates real moving distance )
									// 0.0f means no limit
									// default is 0.0f
	float hp_percentage;

}s_SC_P_Ai_MedikState;


typedef struct{
	s_SC_P_Ai_MedikState peace;
	s_SC_P_Ai_MedikState battle;
}s_SC_P_Ai_Medik;


typedef struct{
	dword not_used_value;
}s_SC_MP_ResultsMode;



#define SC_TESTCOLS_FL_NOTESTSTATIC			0x01
#define SC_TESTCOLS_FL_NOTESTWATER			0x02
#define SC_TESTCOLS_FL_NOTESTMAROK			0x04


#define SC_TESTCOLS_TYPE_NONE				0
#define SC_TESTCOLS_TYPE_STATIC				1
#define SC_TESTCOLS_TYPE_WATER				2
#define SC_TESTCOLS_TYPE_MAROK				3


typedef struct{
	dword flags;					// SC_TESTCOLS_FL_
	c_Vector3 from,dir;				// line to test
	
	dword result_type;				// SC_TESTCOLS_TYPE_
	float result_u;					// result
	float result_marok_m;
	sc_nod result_marok_nod;

	sc_colmat result_colmat;
}s_SC_TestCollisions;


typedef struct{
	dword slot3_by_stamina;
						// TRUE - weapons pickup is limited by stamina
						// FALSE - weapons pickup is limited by weapons number
	dword slot3_limit;	// limit used when slot3_by_stamina==FALSE

}s_SC_WeapPickupLimits;


typedef struct{

	dword kills;
	dword deaths;
	
	int exp;
	dword level;

}s_SC_MP_P_PlayStats;





#define SC_PC_CMDMENU_FL_ENABLEMEDIC		0x01
#define SC_PC_CMDMENU_FL_ENABLEAMMO			0x02

#define SC_PC_CMDMENU_FIRST_USER_ID			0x0100

#define SC_PC_CMDMENU_MAXITEMS				8

#define SC_P_INTERACTION_MAXITEMS			8

typedef struct{
	dword txt_nr;			// text to be displayed
	dword cmd_id;			// command id for SC_LEV_MSG_CMDMENU message
							// must be equal or bigger than SC_PC_CMDMENU_FIRST_USER_ID
}s_SC_PC_CmdMenuItem;

typedef struct{
	
	dword flags;		// SC_PC_CMDMENU_FL_

	float medik_max_call_distance;
	float ammo_max_call_distance;

	dword items;
	s_SC_PC_CmdMenuItem item[SC_PC_CMDMENU_MAXITEMS];	
	
}s_SC_PC_CmdMenu;



typedef struct{
	dword txt_nr;			// text to be displayed	
}s_SC_P_InteractionItem;

typedef struct{
	float active_distance;	// 0 means default ( default is set to 4.0f now )

	dword items;
	s_SC_P_InteractionItem item[SC_P_INTERACTION_MAXITEMS];
}s_SC_P_Interaction;




typedef struct{	
	char *stg_filename;
	float start_anim_time;			// cas v animaci od ktereho se zacne prehravat
	float end_anim_time;			// cas v animaci do ktereho se prehrava, 0 znamena defaulni cely cas animace
	float begin_interpolate_time;	// jaky cas na zacatku pusteni se animace "nainterpolovava"
	float end_interpolate_time;		// jaky cas pred koncem pusteni se animace "odinterpolovava"
	float weight;					// vaha animace, 1.0f je naplno
	BOOL disable_hit_anim;

	dword callback_id;				// 0 znamena nevolat, vola SC_PLSCR_MSG_ANIM_CALLBACK
	float callback_timetoend;		// jak dlouho pred koncem animace se ma callback zavolat
	
}s_SC_P_Play3pvAnim;



typedef struct{
	dword flare_type;			// types are defined at ini\flares.txt
	sc_nod nod;					// flare is linked on the nod
	c_Vector3 pos;				// is used when nod==0

	float live_time;
	

	float light_radius;				// 0 means no light
	float light_r,light_g,light_b;
	float light_ConstF,light_LinearF;

}s_SC_FlareInfo;



typedef struct{

	dword txts;
	ushort **txt;

	float chars_per_sec;	// 0 means default
	float show_time;		// how long the text will be displayed after the last character is written

}s_SC_ScreenInfo;



// global integer variables
extern void SC_sgi(dword id, int a);
extern int SC_ggi(dword id);

// global float variables
extern void SC_sgf(dword id, float a);
extern float SC_ggf(dword id);

extern void SC_MP_Gvar_SetSynchro(dword id);

extern void SC_ScriptEnableEngineCalls(dword script_handle);

extern void SC_ZeroMem(void *ptr, dword size);
extern float SC_GetLineDist(c_Vector3 *pos, c_Vector3 *line_a, c_Vector3 *line_b);
extern float SC_GetLineDistXY(c_Vector3 *pos, c_Vector3 *line_a, c_Vector3 *line_b);

extern BOOL SC_IsNear2D(c_Vector3 *a, c_Vector3 *b, float dist);
extern BOOL SC_IsNear3D(c_Vector3 *a, c_Vector3 *b, float dist);

extern float SC_2VectorsDist(c_Vector3 *a, c_Vector3 *b);

extern float SC_VectorLen(c_Vector3 *vec);
extern float SC_VectorLen2(c_Vector3 *vec);

extern void SC_VectorNormalize(c_Vector3 *vec);

extern float SC_GetLineSegLineSegDist2(c_Vector3 *line1_a, c_Vector3 *line1_b, c_Vector3 *line2_a, c_Vector3 *line2_b);

extern dword SC_GetDifficulty(void);	// return {0,1,2,3} {easy,normal,hard,vietnam}
extern void SC_SetDifficulty(dword val);	// return {0,1,2,3} {easy,normal,hard,vietnam}
											// valid for MP only ! should be used from mode script, value based on mode user settings

extern void SC_message(char *txt,...);				// displays message box
extern void SC_Log(dword level, char *txt, ...);	// write to the log file, level 0 - fatal error, 1 - error, 2 - warning, 3 - info
extern void SC_Osi(char *txt,...);					// write text on the screen (left bottom corner)

extern BOOL SC_StringSame(char *a, char *b);

extern BOOL SC_KeyJustPressed(dword id);			// uses DirectInput codes
extern BOOL SC_KeyPressed(dword id);				// uses DirectInput codes

extern void SC_EventImpuls(char *ev_name);
extern void SC_EventEnable(char *ev_name, BOOL enable);	// enable/disable the event



extern void SC_CreatePtc(dword id, c_Vector3 *vec);
extern void SC_CreatePtc_Ext(dword id, sc_nod nod, float time, float interval, float scale, float time_mult);
					// creates particle in nod, but subeffects are in world space
extern void SC_CreatePtcVec_Ext(dword id, c_Vector3 *vec, float time, float interval, float scale, float time_mult);
extern void SC_CreatePtcInNodSpace_Ext(dword id, sc_nod nod, float time, float interval, float scale, float time_mult);
extern void SC_CreateFpvPtcInNodSpace_Ext(dword id, sc_nod nod, float time, float interval, float scale, float time_mult);
					// all particle is in nod space ( better for flames f.e.)
						// id - id of particle
						// nod - position
						// time - time to play this particle (0 only once)
						// interval - interval between 2 particles (0 means interval defined in particle)
						// scale - scale of particle

extern ushort *SC_AnsiToUni(char *src, ushort *dest);

extern void SC_Fnt_Write(float x, float y, char *txt, float scale, dword color);
extern float SC_Fnt_GetWidth(char *txt, float scale);

extern void SC_Fnt_WriteW(float x, float y, ushort *txt, float scale, dword color);
extern float SC_Fnt_GetWidthW(ushort *txt, float scale);


extern void SC_GetScreenRes(float *width, float *height);


extern void SC_MissionSave(s_SC_MissionSave *info);	// is ignored in single mission ( works in campaign only )

extern void SC_MissionEnd(dword type);					// type is SC_MISSIONEND_TYPE_
extern void SC_MissionEndEx(s_SC_MissionEnd *info);		

extern void SC_QuickSaveEnable(BOOL enable);		// default is TRUE

extern void SC_SetSceneVisibilityMult(float vis_mult, float scene_fog_mult, float bckg_fog_mult);
				// 1.0f - default visibility, 2.0f - twotimes bigger visibility


extern void SC_SetObjectScript(sc_nod nod, char *script_name);		
			// script_name==NULL znamena zruseni stavajiciho scriptu pokud tam nejaky je
			// pokud objekt uz script mel, prijde do neho release a potom init uz do noveho

extern dword SC_ObjScript_GetFlags(sc_nod nod);					// SC_OBJSCRIPT_FL_
extern void SC_ObjScript_SetFlags(sc_nod nod, dword flags);		// SC_OBJSCRIPT_FL_

extern BOOL SC_SphereIsVisible(s_sphere *sph);


extern void SC_PreloadBES(dword id, char *bes_name);	// preload, max id is from interval [1,SC_PRELOAD_BES_MAXID]
												// !=0 - this text is written
extern float SC_GetVisibility(void);
extern float SC_GetPCZoom(void);

extern void SC_FadeTo(BOOL black, float speed);	// speed==0.0f - immediatelly, otherwise means change = time * speed
					
extern void SC_PreloadSound(dword snd_id, BOOL is3D);	// preloads sound
extern void SC_FadeSoundPlayer(dword snd_player_id, float final_volume, float fade_time);// final_volume 0 - off, 1 - full volume

extern ushort* SC_Wtxt(dword val);				// get texts from texts database


extern void SC_SwitchSceneSCS(char *fname, float time);			// switch scene settings

extern void SC_SetMovieBorders(BOOL set_on, BOOL immediatelly);

extern dword SC_CreateLight(s_SC_light *info);				// returns light_id that can be used in SC_UpdateLight
extern void SC_UpdateLight(dword id, s_SC_light *info);
extern void SC_GetCameraPos(c_Vector3 *vec);

extern void SC_GetSystemTime(s_SC_systime *info);

extern BOOL SC_IsMpClient(void); 
extern BOOL SC_IsMpGame(void); 

extern BOOL SC_BoxOriented_ColPoint(c_BoxOriented *box, c_Vector3 *point);
extern BOOL SC_BoxOriented_ColLine(c_BoxOriented *box, c_Vector3 *start, c_Vector3 *end);
extern BOOL SC_BoxOriented_ColSphere(c_BoxOriented *box, s_sphere *sph);

extern void SC_Explosion_Make(s_SC_Expl_CreateInfo *info);			// valid in all SP, MP_server and MP_client

extern void SC_PlayBinkMovie(char *filename);

extern void SC_HUD_InfoIcon_Add(dword id, dword color, float time);	
								// time==0.0f means for ever, must be removed by SC_HUD_InfoIcon_Remove
								// id is index into g\\hud\\hud_01.tga texture
extern void SC_HUD_InfoIcon_Remove(dword id);

extern void SC_HUD_AddStateText(ushort *txt, float min_time, float max_time, dword color, dword snd_id);
								// min_time - minimalni cas po ktery bude text zobrazen ( po teto dobe bude nahrazen novym pokud je nejaky ve fronte )
								// max_time - cas po kterem zmizi ( pokud neni 'nahrazen')								

extern void SC_HUD_SetLeftTopIcon(dword icon_index, dword icon_type, ushort *txt);
								// icon_index ( 0 is top most ), max index is 7	
								// force icon to blink by using icon_index+100  ( so indexes 100-107 are valid too )
								// icon_type - icon index from hud_mp_ico.tga/dds texture
								//			set to SC_HUD_LEFTTOP_DISABLED to disable it
								// txt - text displayed next to icon, can be NULL


extern void SC_ScreenInfo_Set(s_SC_ScreenInfo *info);		// NULL means disabled

extern void SC_Geff_Make(dword id, c_Vector3 *pos, c_Vector3 *rot, c_Vector3 *scale);
						// creates GEFF effect on selected pos
						// rot and scale can be NULL

extern void SC_MovieSkipEnable(BOOL enable); // state is saved into p3g

extern void SC_HintSet(ushort *hint);		// NULL means switch it off
											// hint is copyied into aplication memory, so no need to keep it


extern BOOL SC_Area_IsPointInside(s_SC_Area *area, c_Vector3 *point);
								  

// level stuff

extern void SC_LevelScriptMsg(dword msg_param1, dword msg_param2);
extern void SC_LevelScriptMsg(dword msg_param1, dword msg_param2, dword msg_param3, c_Vector3 *msg_param4);



extern dword SC_GetScriptHelper(char *name, s_sphere *sph, c_BoxOriented *box);
				// return values is SC_SCRIPTHELPER_TYPE_
				// when retval !=SC_SCRIPTHELPER_TYPE_ERROR, proper object (sph or box) is filled
				// you can set sph to NULL when you're sure script helper is the box ( and vice versa)

extern void SC_ScriptHelperMsg(char *name, dword msg_param1, dword msg_param2);
extern void SC_ScriptHelperMsg(char *name, dword msg_param1, dword msg_param2, dword msg_param3, c_Vector3 *msg_param4);

extern void SC_Get_NodHandle(sc_nod nod, s_SC_NodHandle *handle);
extern sc_nod SC_Get_NodByHandle(s_SC_NodHandle *handle);



extern dword SC_Emitor_Create(s_SC_Emitor_Create *info);				// returns emitor_id 
													//				is used to update and remove emitor
													//				is save compatible value
extern void SC_Emitor_Update(dword emitor_id, c_Vector3 *pos);
extern void SC_Emitor_Remove(dword emitor_id);

extern BOOL SC_TestCollisions(s_SC_TestCollisions *info);	// returns TRUE when there was a collision

extern BOOL SC_GetUserKeyName(dword key, ushort *buf, dword buf_size_in_ushorts);
															// key is SC_USERKEY_
															// for user outputs
															// returns FALSE when no key is assigned


extern dword SC_Flare_Create(s_SC_FlareInfo *info);			// returns flare_id that can be used in SC_Flare_Remove, 
															// id is NOT save compatible
															// flares are NOT stored in p3g ( so they must be recreated after iload )
extern void SC_Flare_Remove(dword flare_id);			


// sound
extern BOOL SC_SND_SetEnvironment(dword env1_id, dword env2_id, float env_ratio);

extern void SC_SND_Ambient_Play(dword snd_id);
extern void SC_SND_Ambient_Stop(void);

extern void SC_SND_PlaySound3D(dword snd_id, c_Vector3 *pos);							// pos==NULL means in the camera
extern void SC_SND_PlaySound3DVolume(dword snd_id, c_Vector3 *pos, float volume_mult);	// pos must be filled

extern void SC_SND_PlaySound2D(dword snd_id);

extern void SC_SND_PlaySound3Dlink(dword snd_id, sc_nod nod);
extern void SC_SND_PlaySound3Demitor(dword snd_id, dword emitor_id);	// timeout can be NULL, 

extern void SC_SND_PlaySound3Dpl(dword snd_id, dword pl_id, dword flags);// flags SND_PLAY_PL_FL_xxxx
			// play sound linked to player


extern void SC_SND_PlaySound3DSpec(dword snd_id, c_Vector3 *pos, dword spec_id);
extern void SC_SND_PlaySound2DSpec(dword snd_id, dword spec_id);

extern void SC_SND_SetHearableRatio(float Ratio);

extern float SC_SND_GetSoundLen(dword snd_id);

extern dword SC_SND_GetMissileDropSound(dword drop_type, sc_colmat colmat);	
									// drop_type is used if ini\materials\*.ini, 5 is knife for example

extern dword SC_AGS_Set(dword val);



// Music
extern dword SC_Music_Play(char *ini_filename, sc_nod nod);		// returns music_id used by other functions
extern void SC_Music_Stop(dword music_id, float fadeout_time);
extern void SC_Music_ChangeVolume(dword music_id, float new_volume, float fade_time);	// new_volume is 0-100
extern float SC_Music_GetUserParam(dword music_id, dword param_index);



// MAROK


extern void SC_Marok_Impuls(sc_nod nod, c_Vector3 *impulse_vector, c_Vector3 *world_point_of_application);
extern void SC_Marok_FallAsleep(sc_nod nod);
extern void SC_Marok_WakeUp(sc_nod nod);
extern void SC_Marok_GetState(sc_nod nod, s_SC_MarokObjState *state);
extern void SC_Marok_SetState(sc_nod nod, s_SC_MarokObjState *state);
extern BOOL SC_Marok_IsValid(sc_nod nod);	// return FALSE when nod is not in physics

extern void SC_Math_RotateVector(c_Vector3 *in_vector, float quaternion[4], c_Vector3 *out_vector);// in_vector and out_vector can point the same memory
extern void SC_Math_EulerToQuaternion(c_Vector3 *euler, float quaternion[4]);						// builds the quaternion from euler angles

extern void SC_Marok_GetRelativePlacement(s_SC_Marok_Placement *plc1, s_SC_Marok_Placement *plc2, s_SC_Marok_Placement *rel_plc);
extern void SC_Marok_SetRelativePlacement(s_SC_Marok_Placement *plc1, s_SC_Marok_Placement *plc2, s_SC_Marok_Placement *rel_plc);
extern void SC_Marok_GetRelativePlacement2(sc_nod nod1, sc_nod nod2, s_SC_Marok_Placement *rel_plc);
extern void SC_Marok_SetRelativePlacement2(sc_nod nod1, sc_nod nod2, s_SC_Marok_Placement *rel_plc);
extern void SC_Marok_InterpolatePlacements(s_SC_Marok_Placement *plc1, s_SC_Marok_Placement *plc2, float param, s_SC_Marok_Placement *result);

extern BOOL SC_Marok_IsMpSynchro(sc_nod nod);

extern void SC_Marok_MakeStatic(sc_nod nod);		// set object weigth to zero
extern void SC_Marok_MakeDynamic(sc_nod nod);	// set object weight to it's default value ( so has no sence at zero weight objects by default )

extern void SC_Marok_IkJoint_Add(sc_nod nod);			// adds IK Joint
extern BOOL SC_Marok_IkJoint_Remove(sc_nod nod);		// removes IK Joint
extern BOOL SC_Marok_IkJoint_IsInserted(sc_nod nod);

extern void SC_Marok_Delete(sc_nod nod);

extern BOOL SC_Marok_CanBeRestored(sc_nod master_nod, sc_nod nod);
													// tests if restored object 'nod' wouldn't collide
													// all Marok objects under master_nod are ignored for this test
													// returns TRUE when no collision is found


extern void SC_Marok_GlassBreaker_Add(sc_nod nod);	// for small objects, glassbreaker 'shoots' as it moves to windows
													//	windows have 'faked' collisions, so small objects ( grenades ) nearly doesn't colide
													// list is not save-compatible, need to be filled again after load
extern void SC_Marok_GlassBreaker_Remove(sc_nod nod);
													// object have to be removed from the list when releasing



// death character IK
extern void SC_P_IK_Impulse(sc_player pl_id, dword sik_part, c_Vector3 *impulse);// sik_part is SC_SIK_xxx

// DSTRs
extern void SC_NOD_SetDSTR(sc_nod nod, char *obj_name, char *dstr_name);
extern void SC_NOD_SetDSTR2(sc_nod nod, char *obj_name, char *dstr_name, dword dstr_by_pl_handle, dword dstr_by_weaptype);
extern void SC_NOD_Restore(sc_nod nod);		// restores DSTR and position to the state from the mission start
											// works for nod and all subentities hiearchy
extern sc_nod SC_NOD_GetDSTR(sc_nod nod);	// returns actual set DSTR nod for specified nod
											// nod can be basic nod or any dstr
											// returns value can be also NULL
// Items


extern void SC_ItemType_Preload(dword itemtype);

extern sc_item SC_Item_Create(s_SC_ItemCreate *info);	
			// valid on both server and clients
			// returned sc_item is 0 everytime on MP client
			// sc_item is not save-compatible value

extern void SC_Item_Release(sc_item item);

extern BOOL SC_Item_IsValid(sc_item item);
			// on MP Client,	item's position and state is not valid some time after creating
			//					need to be tested before creating a particle from item's position for example


extern void SC_Item_GetData(sc_item item, BYTE *data, dword *data_size);
								// data_size -	IN-size of data buffer
								//				OUT - size of item's data copied
extern void SC_Item_SetData(sc_item item, BYTE *data);	
								// size is taken from item
extern void SC_Item_InitData(sc_item item, BYTE *data, dword data_size);
								// initialize item datasize and data
								// invalid on MP client

extern void SC_Item_SynchroData(sc_item item, dword start_index, dword lenght);
								// not valid on MpClient, is used on server to resend changed data to clients
								// cases SC_OBJ_MSG_ITEMDATACHANGED msg on all clients

extern sc_nod SC_Item_GetMarokNod(sc_item item);
extern sc_nod SC_Item_GetScriptNod(sc_item item);


extern void SC_Item_PickupEnable(sc_item item, BOOL enable);
extern BOOL SC_Item_PickupIsEnabled(sc_item item);

extern sc_item SC_Item_Find(dword item_type, void *data, dword datasize);
								// searches for item, all items has to be filled								
								// returns 0 when not found
		
extern BOOL SC_Item_IsAlreadyInitialized(sc_item item);
								// returns FALSE on Mp Client when item is created, but the position is not set yet 
extern void SC_Item_EnableRendering(sc_item item, BOOL enable);	// used for disapearing of local RPG for example ( needed when bad connection to server )

extern void SC_Items_RemoveAll(dword type, s_SC_Area *area);
								// type is ID from items.txt
								// type 0 means all items
								// for use in SP only !


// objects
extern char *SC_NOD_GetName(sc_nod nod);
extern void SC_NOD_GetPivotWorld(sc_nod nod,c_Vector3 *vec);

extern void SC_NOD_TransformToWorldSpace(sc_nod nod, c_Vector3 *source, c_Vector3 *result);
extern void SC_NOD_TransformToObjectSpace(sc_nod nod, c_Vector3 *source, c_Vector3 *result);

extern void SC_NOD_GetWorldPos(sc_nod nod, c_Vector3 *pos);
extern float SC_NOD_GetWorldRotZ(sc_nod nod);

extern void SC_NOD_GetDummySph(sc_nod master_nod, char *dummy_name, s_sphere *sph);

extern sc_nod SC_NOD_Get(sc_nod master_obj, char *obj_name);
extern sc_nod SC_NOD_GetNoMessage(sc_nod master_obj, char *obj_name);
extern sc_nod SC_NOD_GetNoMessage_Entity(char *obj_name);

extern void SC_NOD_GetTransform(sc_nod obj,s_SC_NOD_transform *trans);			
extern void SC_NOD_SetTransform(sc_nod obj,s_SC_NOD_transform *trans);
extern void SC_NOD_Hide(sc_nod obj, BOOL hide);

extern void SC_NOD_GetPosInOtherSpace(sc_nod other_nod, sc_nod nod, c_Vector3 *vec);

extern void SC_FPV_FlyOffCartridge(s_SC_FlyOffCartridge *info);

extern void SC_FPV_SetUserDefAnim(dword weap_type, dword user_id, char *normal, char *prone, char *wall);
			// is global for weapon type
			// id is USERDEF_ID value (1-4)
			// normal - normal animation, has to be filled
			// prone variation, can be NULL, normal is used then
			// wall variation, can be NULL, normal is used then

extern float SC_FPV_SetAction(sc_player player, dword action, dword flags);		
								// returns animation lenght in sec
								// action is SC_FPV_ACTION_
								// flags are SC_FPV_FL_

extern dword SC_FPV_GetAction(sc_player player);
								// returns current fpv action of active player
								// when player is not the active one it returns SC_FPV_ACTION_NONE

extern void SC_FPV_InitExtAnimSystem(dword weap_type, dword system_id, char *extend);	// system_id can be from 1 or 2

extern void SC_FPV_DoPreload(dword weap_type);
				// preloads the weapons as if it is used by PC 
				//	 for weapons scripts that need to get timing from fpv animations for example


extern BOOL SC_WEAP_GetExtData(sc_weapon weapon, BYTE *data, dword *data_size);
extern void SC_WEAP_SetExtData(sc_weapon weapon, BYTE *data, dword data_size);

extern void SC_WEAP_GetAmmo(sc_weapon weapon, dword *ammo);
extern void SC_WEAP_SetAmmo(sc_weapon weapon, dword *ammo);

extern void SC_WEAP_SendMpChange(sc_weapon weapon, dword change_val);

extern void SC_WEAP_SetSelectedBatch(sc_weapon weapon, dword batch_id);	// pouziva napr. m16grnt

extern void SC_WEAP_SetNextShotValForHud(sc_weapon weapon, float val);	// for m48 cannon for example

extern void SC_WEAP_MpStats_AddShot(sc_weapon weapon);					// nasimuluje vystrel z dane zbrane ( aby i scriptovane zbrane byly ve statistice )

extern void SC_WEAP_MWP_GetInfo(sc_weapon weapon, s_SC_MwpInfo *info);
extern void SC_WEAP_MWP_JustShot(sc_weapon weapon);						// tell mwp it just shot - for swaping of barrels on multi weapons

extern void SC_TWEAP_GetInfo(dword weap_type, s_SC_TweapInfo *info);

extern dword SC_AMMO_Get(sc_player pl_id, dword ammo_type);
extern void SC_AMMO_Set(sc_player pl_id, dword ammo_type, dword ammount);

extern dword SC_AMMO_GetMax(sc_player pl_id, dword ammo_type);

extern ushort *SC_AMMO_GetUserName(dword ammo_type);



extern void SC_3PV_SetUserDefAnim(dword weap_type, dword user_id, char *stgname);	
						// for use by weapon script only !
						// loads user defined animation for selected weapon type
extern float SC_3PV_PlayUserDefAnim(sc_player player, dword weap_type, dword user_id, float pause_maxtime_at_end, float begin_interpolate_time);
						// for use by weapon script only !
extern void SC_3PV_StopUserDefAnim(sc_player player, dword weap_type, dword user_id);
						// for use by weapon script only !
						// stops animation created with pause_at_end==TRUE


// other objects functions


extern dword SC_MANM_Create(char *filename);
extern void SC_MANM_Release(dword manm_id);
extern dword SC_MANM_GetIndex(dword manm_id, char *objname);
extern void SC_MANM_Set(dword manm_id, dword manm_index, sc_nod nod, float time);
extern void SC_MANM_SetRelative(dword manm_id, dword manm_index, sc_nod nod, float time);
extern float SC_MANM_GetLength(dword manm_id, dword manm_index);

extern void SC_MANM_Camera_Set(dword manm_id, dword manm_index, float time);

extern dword SC_CedMovie_Play(char *cedFileName, char *manmFileName);	// zatim nic nevraci :-)
extern dword SC_CedMovie_Stop(void);									// zatim nic nevraci :-)

extern void SC_NOD_FillRespawnPos(sc_nod nod, s_SC_P_RespawnPos *respawn_pos);
			// fills structure used for SC_P_Respawn for example

// scene rendering
extern void SC_NOD_Set_DoNotRender(sc_nod nod, BOOL do_not_render);

extern void SC_DUMMY_Set_DoNotRenHier(char *dummy_name, BOOL do_not_render_hiearchy);
extern void SC_DUMMY_Set_DoNotRenHier2(sc_nod nod, BOOL do_not_render_hiearchy);


// Ladders

extern void SC_Ladder_Enable(sc_nod ladder_nod, BOOL enable);    // invalid on MP client

// Doors
extern void SC_Door_SetState(sc_nod door_nod, dword state);		// invalid on MP client
																// state is SC_DOOR_STATE_
extern dword SC_Door_GetState(sc_nod door_nod);					// return value is SC_DOOR_STATE_
extern float SC_Door_GetOpenState(sc_nod door_nod, float *cur_change);
																// returns values from 0 to 1 ( 0.0f is fully clossed, 1.0f is fully open )
																// cur_change - returns current change in openstate per second ( usefull for deciding opening/closing )
																//				- can be NULL
extern void SC_Door_Impulse(sc_nod door_nod, float power);		// invalid on MP client
																// power :  1.0f means OPEN the same as user presses USE
																//			-1.0f means CLOSE the same as user presses USE

extern void SC_Door_SetOpenState(sc_nod door_nod, float val);	// val is <0,1>, 0 means fully closed, 1 means fully open
																// be careful using this function - script should be sure there are no objects to collide
																// invalid on MP server


// speech

extern void SC_Speech_BatchBegin(dword flags);									// when any speech from batch is stoped, remove all batch
																				// flags - SC_SPEECH_BATCH_FL_
extern void SC_Speech_BatchEnd(void);

extern void SC_Speech_Add(s_SC_SpeechAdd *info);								// adds speech
extern void SC_Speech_Remove(s_SC_Speech_Author *author, BOOL active_too);		// removes speech of selected author
extern void SC_Speech_RemoveAll(BOOL active_too);								// removes all speech

extern BOOL SC_Speech_IsTalking(s_SC_Speech_Author *author);	// returns TRUE if selected author is speaking right now
extern float SC_Speech_GetTalkTime(s_SC_Speech_Author *author);	// returns time when selected author will finished his last buffered speech

extern void SC_Speech_GetProps(s_SC_SpeechProps *props);
extern void SC_Speech_SetProps(s_SC_SpeechProps *props);

// SP objectives

extern void SC_SP_SetObjectives(dword objectives, s_SC_SP_Objective *objective);


// radar settings
extern void SC_Radar_SetProps(s_SC_RadarProp *prop);
extern void SC_Radar_GetProps(s_SC_RadarProp *prop);

extern void SC_Radar_SetTarget(c_Vector3 *pos);		// use NULL to disable

extern dword SC_Radar_ItemAdd(c_Vector3 *pos, dword icon_id, float time, dword flags);
				// icon_id - index from hud_01.tga, 0 is ally in coma, 2 is airstrike, 5 is US flags for example
				// time - 0 means just one frame, negative values mean for ever
				// flags - SC_RADARITEM_FL_
				// returns ID, used for removing
extern void SC_Radar_ItemRemove(dword item_id);
extern void SC_Radar_ItemUpdatePos(dword item_id, c_Vector3 *pos);



// general level functions


extern void SC_InitSide(s_SC_InitSide *info);
extern void SC_SetSideAlly(dword s1, dword s2, BOOL is_enemy);

extern dword SC_GetRndHideout(s_SC_Area *area, dword flags, c_Vector3 *found_pos);
									// find an Hideout in specified area, position is returned into *found_pos
									// flags SC_GETHIDEOUT_FL_
									// return value is Hideout Ptr, should be used in SC_P_Ai_MoveAt to  force the player to occupy that Hideout
									// Hideout Ptr is not save compatible value, do not store it in the script ( just get and use )


extern void SC_ObjectScriptMessage(sc_nod nod, dword param1, dword param2);
extern void SC_ObjectScriptMessage(sc_nod nod, dword param1, dword param2, dword param3, c_Vector3 *param4);

extern void SC_ObjectScriptMessage_toSRV(sc_item item, void *data, dword datasize);
			// sends SC_OBJ_MSG_FROMCLNMESSAGE message to the item script on the server
			// used for using info ( by ENTER ) sending to the server for example
			// valid in MP game only

extern void SC_ObjectScriptMessage_NodToSRV(sc_nod nod, void *data, dword datasize);
						// valid on MP clients only, invalid on MP server and in SP
						// sends data message to server - SC_OBJ_MSG_FROMCLNNOD
extern void SC_ObjectScriptMessage_NodToCLNs(sc_nod nod, void *data, dword datasize);
						// valid on MP server only, invalid on MP client and in SP						
						// sends message to all non-local clients - SC_OBJ_MSG_FROMSRVNOD

extern BOOL SC_Scene_InsertBES(sc_nod target_nod, char *bes_filename, BOOL as_subentity, char *set_loaded_no_name);
									// as_subentity - has sence when target_nod is entity ( it it's subentity, new BES will be inserted as subentity everytime )

// loud shots


extern void SC_LoudShot_Add(s_SC_Area *area, dword callback_id);	// when any player shoots at the area, callback SC_LEV_MSG_LOUDSHOTCALLBACK is called
extern void SC_LoudShot_AddEx(s_SC_Area *area, dword callback_id, dword flags);	// when any player shoots at the area, callback SC_LEV_MSG_LOUDSHOTCALLBACK is called
																	// flags are SC_LOUDSHOT_FL_
extern BOOL SC_LoudShot_Remove(dword callback_id);
extern void SC_LoudShot_ReleaseAll(void);



// vehicles

extern BOOL SC_VEH_Create(s_SC_VehicleInit *info);								// returns FALSE when vehicle cannot be created
extern BOOL SC_VEH_Remove(sc_nod vehicle_nod);									// returns FALSE when vehicle not found
extern BOOL SC_VEH_AddSeat(sc_nod vehicle_nod, s_SC_VehicleSeatInit *info);		// returns FALSE when vehicle not found or seat cannot be created
extern void SC_VEH_EnableSeatForPC(sc_nod vehicle_nod, dword seat_index, BOOL enable);
																				// valid for SP only !
																				// clears/sets SC_VEHICLESEAT_FL_DISABLED_FOR_PC flag for seat
extern float SC_VEH_ChangeStativAnimation(sc_nod vehicle_nod, dword seat_index, char *anim_stativ, BOOL make_force_animation);
																				// changes stativ animation

extern void SC_VEH_WheelControlInit(s_SC_Vehicle_WheelControl *info);			// initializes wheels and user control ( engine, brake, ... )

extern void SC_VEH_AddTrack(s_SC_Vehicle_TrackDefinition *info);				// defines track on the vehicle ( pasive wheels, track parts, settings )
																				// all wheels ( both passive and active ) and all segments must have the same parent and their scale must be 1 and rotations must be 0

extern float SC_VEH_StartAnim(sc_nod vehicle_nod, char *anim_filename);			// starts to play vehicle animation
																				// returns animation length in seconds
extern void SC_VEH_StopAnim(sc_nod vehicle_nod);								// stops vehicle animation
extern float SC_VEH_GetAnimCurTime(sc_nod vehicle_nod);							// returns -1.0f when no animation is playing
extern BOOL SC_VEH_SetAnimCurTime(sc_nod vehicle_nod, float time);				// updates animation time ( for synchro in MP )
																				// returns FALSE when no animation is playing
																				// display msgbox when time is greater then total animation time or smaller then zero
extern void SC_VEH_SetAtEndAndStopAnim(sc_nod vehicle_nod);						// sets vehicle at the end of the animation and stops the animation
																				// SC_LEV_MSG_VEHANIM_END callback is called then
extern void SC_VEH_SetHealthInfo(sc_nod vehicle_nod, float health);				// sets health ( 0.0f-1.0f) for Hud information
																				// valid for SP and MP server only - in MP the value is sent to clients by the game engine
extern float SC_VEH_GetHealthInfo(sc_nod vehicle_nod);							// valid on all SP, MP cln and MP srv, returns value 0.0f-1.0f
extern void SC_VEH_DoRepair(sc_nod vehicle_nod, float perc);					// valid on all SP, MP cln and MP srv
extern ushort *SC_VEH_GetName(sc_nod vehicle_nod);


// mounted weapons


extern void SC_MWP_Create(s_SC_MWP_Create *info);					
extern void SC_MWP_Remove(sc_nod master_nod);
extern BOOL SC_MWP_GetEntryPoint(sc_nod master_nod, c_Vector3 *pos);					
					// returns TRUE/FALSE - mwp found/not found
					// filles pos with world position of mwp entry point
extern sc_player SC_MWP_GetUsing(sc_nod master_nod);					
					// returns player which is using selected mwp

extern void SC_MWP_PlaceIngame(char *besname, c_Vector3 *pos, float rz, sc_player link_pl, dword from_weap_type);

// player detector

extern dword SC_PlDet_Create(sc_player pl_id, s_SC_Area *area, dword callback_id);
				// creates detector that will send SC_LEV_MSG_PLDETECTOR to level.c
				// returns PlDet id ( is save/load compatible )
extern void SC_PlDet_Remove(dword pldet_id);
extern void SP_PlDet_ReleaseAll(void);


// Active objects

extern void SC_ActiveObj_Create(sc_nod nod, float max_dist, dword text_id);
extern void SC_ActiveObj_Remove(sc_nod nod);


// players scripting



extern BOOL SC_PlScr_Add(char *filename);	// returns FALSE when cannot add player script ( script not found )
extern void SC_PlScr_GetInfo(sc_plscript scr, s_SC_Plscr_info *info);
			// return info about script - name, scene s_NOD ( for respawn for example )

extern sc_player SC_PC_Get(void);
extern sc_player SC_P_Get(dword side, dword group, dword member_id);

extern void SC_PC_MakeViewShake(float power);	// make shaking of player's view ( the same is caused by explosions )
												// values can be from 0 to X, power 1.0f is quite strong

extern sc_nod SC_PC_IsWatchingVehicle(float *veh_distance);	// wrote for wrench tool
															// veh_distance is filled by distance from user view to the vehile collision, can be NULL


extern dword SC_EnumPlayers(dword side, dword group, sc_player *list, dword max_items, dword flags);
extern dword SC_EnumPlayersArea(dword side, dword group, sc_player *list, dword max_items, dword flags, s_SC_Area *area);	// flag SC_ENUMPLS_FL_RESPAWNEDONLY is force set here, flag SC_ENUMPLS_FL_NORESPAWNEDONLY is cleared - has no sence ( cannot check area when player is not respawned )
			// returns nr of players enumerated
			// side can be also SC_P_SIDE_ALL to enum all sides, group has no sence then ( it doesn't support enumaration of groups nr 3 from all sides for example )
			// group can be SC_P_GROUP_ALL to enum all groups of defined side(s)
			// list will be filled
			// max_items is size of list array
			// flags - SC_ENUMPLS_FL_



extern BOOL SC_P_Create(s_SC_P_Create *info);
			// creates a player
extern void SC_P_Release(sc_player pl_id);
			// deletes a player
extern void SC_P_Respawn(sc_player pl_id, s_SC_P_RespawnPos *respawn_pos);
			// respawns player
			// respawn_pos can be filled by SC_NOD_FillRespawnPos or by hand
extern void SC_P_Derespawn(sc_player pl_id);
			// derespawns player ( player will not be in the game anymore but will still exist )

extern dword SC_P_GetHandle(sc_player pl_id);
extern sc_player SC_P_GetByHandle(dword pl_handle);

extern void SC_P_MakeDamage(sc_player pl_id, float hp);		// hit player into body by selected hp
															// valid in SP only !

extern void SC_P_CollisionsEnable(sc_player pl_id, BOOL enable);
															// can be used for enabling/disabling collisions															
															// be very carefull when enabling from previously disabled, player shouldn't collide with anything
															// this state is also changed when player is entering/leaving vehicles and ladders, so best is for script mode without moving
											

extern sc_player SC_P_GetByEntityName(char *ent_name);	// returns player created from ent_name entity, 0 when not found

extern BOOL SC_P_IsAi(sc_player pl_id);

extern void SC_P_SetScriptProps(sc_player pl_id, s_SC_P_ScriptProps *props);
extern void SC_P_GetScriptProps(sc_player pl_id, s_SC_P_ScriptProps *props);

extern void SC_P_GetName(sc_player pl_id, char *ansi_name, ushort *uni_name);

extern BOOL SC_P_GetStatus(sc_player pl_id, s_SC_P_status *status);	// returns FALSE when player is not respawned

extern dword SC_P_GetMovingState(sc_player pl_id, s_sphere *prevpos, s_sphere *curpos);
																	// returns number of moving spheres, 0 means no moving
																	// when moving, prevpos and curpos are filled with 3 collision sphere positions
																	// prevpos and curpos must be able to store 3 spheres

extern void SC_P_ChangeSideGroupMemberId(sc_player pl_id, dword side, dword group, dword member_id);
											// player's side/group/member_id is changed
											// member_id can be SC_P_CREATE_MEMID_AUTO
											// when changing side of AI player, all AI_situation is cleared ( enemies, dangers, visuals )

extern void SC_P_GetSideGroupMemberId(sc_player pl_id, dword *side, dword *group, dword *member_id);
															// any of ptrs can be NULL ( if you're interested in side only, just fill (pl_id,&side,NULL,NULL) )
extern BOOL SC_P_SetHp(sc_player pl_id, float hp);			// is ignored when player is dead
															// if hp is higher then player's max hp, max hp is set
															// returns FALSE when player is not respawned
extern BOOL SC_P_SetPos(sc_player pl_id, c_Vector3 *pos, dword *phase, float *rz);
															// any ptr can be NULL - then current value will be used, so it can be used to force player to rotate somewhere only
															// returns FALSE when player is not respawned


extern BOOL SC_P_GetHeadPos(sc_player pl_id, c_Vector3 *head_pos);
															// returns FALSE when player is not respawn, otherwise fills *head_pos with world head position
extern dword SC_P_GetSelectedWeapon(sc_player pl_id);		
															// returns 0 when no weapon
															// respawned - returns currently selected weapons
															// no respawned - returns weapon that is selected as favorite for respawn
extern BOOL SC_P_SetSelectedWeapon(sc_player pl_id, dword weapon_type, BOOL immediately);		
															// changes player's favorite weapons after respawn and also changes currently selected weapons for respawned player
															// returns FALSE when has no weapon_type in the inventory of respawned player
															// immediately - TRUE means weapon is selected immediatelly, otherwise changing process started the same way as the player chooses it ( all animation from fpv view are visible)															


extern void SC_P_UnselectCurWeapon(sc_player pl_id, BOOL no_hide_anim, BOOL local_player);		// for example, when the last grenade is thrown
extern void SC_P_SelectBestWeapon(sc_player pl_id, BOOL no_hide_anim, BOOL local_player);		// for example, when the last grenade is thrown
extern void SC_P_SelectLastUsedWeapon(sc_player pl_id, BOOL no_hide_anim, BOOL local_player);		// for example, when the medkit is used

extern void SC_P_CurWeapon_Release(sc_player pl_id);					// for example, when the last medkit is used
extern void SC_P_CurWeapon_ReleaseEx(sc_player pl_id, BOOL send_to_server);

extern dword SC_P_GetWeapons(sc_player pl_id, dword *weapons_list, dword weapons_list_max_size);
															// returns number of weapons in the list
															// when player is respawned, the list includes weapons player has in his inventory
															// when player is not respawned, the list is filled with weapons he will have next time he will respawn
extern void SC_P_SetWeapons(sc_player pl_id, dword *weapons_list, dword weapons, dword choose_weapon_type);
															// sets weapons to player
															// choose_weapon_type became active ( can be 0 )
															// when player is not respawned, the list of weapons he will have after respawn is changed
															// if player is respawned both lists ( current inventory and list_after_respawn) are changed
extern void SC_P_AddAllAmmo(sc_player pl_id, BOOL current_weapons_only);
															// add all ammo for all weapons or for all weapons in invetory
															// works for respawned players only


extern dword SC_P_CanPickupWeapon(sc_player pl_id, dword weap_type, dword *swap_for);
															// returns SC_P_CANPICKUPWEAP_
extern BOOL SC_P_CanPickupAmmo(sc_player pl_id, dword ammo_type);

extern void SC_P_PickupWeapon(sc_player pl_id, dword weap_type, dword swap_for);
extern void SC_P_PickupWeaponEx(sc_player pl_id, dword weap_type, dword swap_for, BOOL do_selection_change);

extern void SC_P_PickupAmmo(sc_player pl_id, dword ammo_type, dword ammount);

extern void SC_P_AddWeapon(sc_player pl_id, dword weap_type);				// invalid call on MP client
extern void SC_P_AddAmmo(sc_player pl_id, dword ammo_type, dword ammount);	// invalid call on MP client


extern void SC_P_AmmoRedefine_Add(sc_player pl_id, s_SC_P_AmmoRedefine *redefine);
extern void SC_P_AmmoRedefine_Remove(sc_player pl_id, dword ammo_type);


extern void SC_P_ScriptMessage(sc_player pl_id, dword param1, dword param2);
															// sends SC_PLSCR_MSG_SCRIPT_MESSAGE to the script of the player
extern void SC_P_ScriptMessage(sc_player pl_id, dword param1, dword param2, dword param3, c_Vector3 *param4);

extern void SC_P_GetView(sc_player pl_id, c_Vector3 *view_pos, c_Vector3 *view_dir, c_Vector3 *view_up);
			// fills FPV view of player, any of (c_Vector3 *) can be NULL


extern sc_player SC_GetNearestPlayer(s_sphere *sph, dword flags, float *distance);
extern sc_player SC_GetNearestPlayerEx(s_sphere *sph, dword flags, float *distance, sc_player no_this_pl);
															// returns nearest player to sph->pos, 0 when no player
															// players are searched in the defined sphere only
															// supported flags: 
															//		SC_ENUMPLS_FL_DEADONLY
															//		SC_ENUMPLS_FL_ALIVEONLY
															//		SC_ENUMPLS_FL_AI_ONLY
															//		SC_ENUMPLS_FL_PC_ONLY
															// distance is filled by the distance of nearest player ( if !=NULL and player is found )


extern float SC_P_GetDistancePos(sc_player pl_id, c_Vector3 *pos);
															// returns distance of the player from pos
															// returns FLT_MAX when player is not respawned
extern float SC_P_GetDistancePl(sc_player pl_id1, sc_player pl_id2);
															// returns distance of 2 players
															// returns FLT_MAX when any player of them is not respawned	

extern BOOL SC_P_IsAlly(sc_player pl1, sc_player pl2);

extern void SC_P_Mwp_Link(sc_player pl_id, sc_nod mwp_nod);
extern void SC_P_Mwp_Unlink(sc_player pl_id);

extern void SC_P_Vehicle_Link(sc_player pl_id, sc_nod vehicle_nod, dword seat_index);
extern void SC_P_Vehicle_Unlink(sc_player pl_id);

extern void SC_P_Vehicle_Leave(sc_player pl_id);		// leaves vehicle

extern sc_nod SC_P_IsUsingVehicle(sc_player player, dword *seat_index);	
															// seat_index can be NULL when not needed
															// returns 0 when not using vehicle
extern sc_nod SC_P_IsUsingMwp(sc_player player);			// returns 0 when not using mwp



extern BOOL SC_P_CanSeePos(sc_player pl_id, c_Vector3 *pos, float max_distance, dword flags);
					// executes visibility test
					// uses pl_id's field of view settings ( visibility settings for AI, view settings for PC)
					// flags SC_P_CANSEEPOS_FL_

extern void SC_P_Eqp3pv_Add(sc_player pl_id, dword slot_id, dword preload_bes_id, char *eqp_filename);
					// slot id is from 0 to SC_P_EQP3PV_ID_MAX-1
					// preload_bes_id - must be initialized by SC_PreloadBES
					// eqp_filename - filename of EQP to be used
extern void SC_P_Eqp3pv_Remove(sc_player pl_id, dword slot_id);

extern BOOL SC_P_Eqp3pv_GetWorldPos(sc_player pl_id, dword slot_id, c_Vector3 *pos, c_Vector3 *rot);
					// return FALSE when slot_id is incorrect or unsused
					// return value should be check, because when returning FALSE values pos and rot and not filled


extern void SC_PC_GetControl(s_SC_PC_Control *control);
extern void SC_PC_SetControl(s_SC_PC_Control *control);			// enabled/disables various actions
extern void SC_PC_FillControlAllOn(s_SC_PC_Control *control);	// fills by all enable


extern void SC_PC_GetCommandMenu(s_SC_PC_CmdMenu *menu);
extern void SC_PC_SetCommandMenu(s_SC_PC_CmdMenu *menu);

extern void SC_PC_SetFpvCameraFrom3pvAnim(BOOL enable);			// sets fpv camera for PC player from 3pv animation

extern void SC_P_PC_SetMainTask(sc_player pl_id, s_SC_P_PC_MainTask *maintask);


extern void SC_P_Healing(sc_player medik, sc_player wounded, BOOL heal_by_medik);
extern void SC_P_GiveMedkit(sc_player medik, sc_player receiver);
			// medik can be NULL when calling on MPserver - for use with FirstAidStation for example
			

extern sc_player SC_P_GetLookingAt(sc_player pl, float max_dist);


extern BOOL SC_P_CouldAmmoBeRefilled(sc_player pl);	// check for ammo for current weapons ( any must be not-full and allowed to take from ammo-box)
extern void SC_P_AmmoRefill(sc_player engineer, sc_player receiver);

extern void SC_P_SetMoveSpeed(sc_player player, dword phase, dword style, float val);
							// phase is SC_P_PHASE_
							// style is SC_P_MOVESPEED_STYLE_
							// val means speed in m/s , 0.0f means use player default
extern void SC_P_SetSystemAnim(sc_player player, char style, dword anim_id, char *stg_filename);
							// changes system animation for this player
							// style is 'A','B',.. 'X' means all styles
							// anim_id is anim ID :-)
							// filename is stg_filename, NULL means use default


extern float SC_P_Play3pvAnim(sc_player player, char *stg_filename);
							// returns animation length in seconds
extern float SC_P_Play3pvAnimLooped(sc_player player, char *stg_filename, dword stop_id);
							// returns animation length in seconds
							// passed stop_id value is used for stopping the animation by SC_P_Stop3pvAnimLooped
							// stop_id must be >0 and is stored in p3g (so sequence play, save/load and stop is ok )
extern void SC_P_Stop3pvAnimLooped(sc_player player, dword stop_id);

extern float SC_P_Play3pvAnimExt(sc_player player, s_SC_P_Play3pvAnim *info);	// returns length of the animation ( not the length is will be player if there is redefinition in info )
extern void SC_P_Stop3pvAnimExt(sc_player player, dword callback_id);			// stops anim started by SC_P_Play3pvAnimExt
																				// do not calls SC_PLSCR_MSG_ANIM_CALLBACK

extern void SC_P_SetAnimsVariations(sc_player player, dword flags);				// SC_P_ANIMVARIATION_
extern dword SC_P_GetAnimsVariations(sc_player player);

extern void SC_P_SendWeapScriptMsg(sc_player player, dword weap_type, void *data, dword datasize);	// causes SC_WEAP_EVENT_MSG

extern void SC_P_SetInteraction(sc_player player, s_SC_P_Interaction *info);	
									// info==NULL means disable interaction
									// when PC player interacts msg SC_PLSCR_MSG_INTERACTION comes into "sc_player player"s script
																					

extern void SC_P_GenSpch_Play(sc_player player, dword generic_id);
extern void SC_P_GenSpch_Set(sc_player player, dword disable_groups);	// SC_P_GENSPCH_GROUP_
extern dword SC_P_GenSpch_Get(sc_player player);			// player default value is 0 ( all enabled )

extern void SC_P_Grimace_Set(sc_player player, char *grimace_name, float in_time, float duration);
								// duration 0.0f means for ever ( until not overwriten by new grimace set )


extern BOOL SC_P_IsActiveOne(sc_player player, BOOL *fpv_view);		// returns TRUE when player is the active one ( the one user is watching thru )

extern void SC_P_SetForceClosedEyes(sc_player pl, BOOL force_close);

// AI scripting


extern dword SC_AI_FakeDanger_Add(dword side, dword group, s_SC_AI_FakeDanger *fakedanger);
extern BOOL SC_AI_FakeDanger_Remove(dword side, dword group, dword fakedanger_id);		// fakedanger_id is value returned by SC_AI_FakeDanger_Add
extern void SC_AI_FakeDanger_ReleaseAll(dword side, dword group);

extern void SC_AI_SetGroupProps(dword side, dword group, s_SC_AI_GroupProps *props);
extern void SC_AI_GetGroupProps(dword side, dword group, s_SC_AI_GroupProps *props);

extern void SC_AI_SetGroupStealthMode(dword side, dword group, BOOL stealth);
extern BOOL SC_AI_GetGroupStealthMode(dword side, dword group);
		// stealth rusi vystrel nekoho z groupy ( kdekoliv ) nebo nepratelska kulka letici max 8m od nekoho z groupy

extern dword SC_AI_Peril_Add(dword side, dword group, s_SC_AI_Peril *peril);
extern void SC_AI_Peril_Remove(dword side, dword group, dword peril_id);		// peril_id is return value from SC_AI_Peril_Add
extern void SC_AI_Peril_ReleaseAll(dword side, dword group);

extern dword SC_AI_MovingPeril_Create(s_SC_AI_MovingPeril *moveperil);	// adds when the new one, update if already exists
																		// returns moveperil_id, use in _Update and _Remove functions
extern void SC_AI_MovingPeril_Update(dword moveperil_id, s_SC_AI_MovingPeril *moveperil);			// adds when the new one, update if already exists
extern void SC_AI_MovingPeril_Remove(dword moveperil_id);											// removes peril

extern dword SC_AI_Blocker_Add(char *entity_name, c_Vector3 *add_pos);		// creates dynamic blocker
																				// entity_name is the name is AIhole in the editor
																				// add_pos can be NULL ( blocker will be created at the exact hole position)
																				// when add_pos != NULL - created at coordinations moved add_pos
extern BOOL SC_AI_Blocker_Remove(dword blocker_id);							// removes dynamic blockers, blocker_id is the value returned by SC_AI_Blocker_Add
extern void SC_AI_Blocker_ReleaseAll(void);

extern void SC_AI_GetProps(s_SC_AI_props *props);
extern void SC_AI_SetProps(s_SC_AI_props *props);


// PL AI scripting

extern void SC_P_Ai_GetProps(sc_player pl_id, s_SC_P_AI_props *props);
extern void SC_P_Ai_SetProps(sc_player pl_id, s_SC_P_AI_props *props);

extern void SC_P_Ai_TeamCmds_Set(sc_player pl_id, dword state);	// SC_P_AI_TEAMCMD_STATE_xxxx
extern dword SC_P_Ai_TeamCmds_Get(sc_player pl_id);
extern void SC_P_Ai_TeamCmd_SetModeFollow(sc_player pl_id);		// player has to be in SC_P_AI_TEAMCMD_STATE_ENABLED state

extern void SC_P_Ai_SetMoveStyle(sc_player pl_id, s_SC_P_AI_MoveStyle *movestyle);
extern void SC_P_Ai_GetMoveStyle(sc_player pl_id, s_SC_P_AI_MoveStyle *movestyle);

extern void SC_P_Ai_SetStandStyle(sc_player pl_id, s_SC_P_AI_StandStyle *standstyle);
extern void SC_P_Ai_GetStandStyle(sc_player pl_id, s_SC_P_AI_StandStyle *standstyle);


extern void SC_P_Ai_SetMainTask(sc_player pl_id, s_SC_P_Ai_MainTask *maintask);

extern void SC_P_Ai_SetScriptMode(sc_player pl_id, BOOL script_mode);
extern BOOL SC_P_Ai_GetScriptMode(sc_player pl_id);
extern void SC_P_Ai_SetScriptModeProps(sc_player pl_id, s_SC_P_AI_ScriptModeProps *props);
extern void SC_P_Ai_GetScriptModeProps(sc_player pl_id, s_SC_P_AI_ScriptModeProps *props);

extern void SC_P_Ai_StopMoving(sc_player pl_id);										// valid for script and peace modes, generates message box when used in fakedanger,danger or battle modes
extern void SC_P_Ai_MoveAt(sc_player pl_id, c_Vector3 *target, dword target_hideout, dword callback_id);		// valid for script and peace modes, generates message box when used in fakedanger,danger or battle modes
											// target_hideout can be 0 ( no hideout specified) or value returned by SC_GetRndHideout()
											// when callback_id!=0, event SC_PLSCR_MSG_AI_MOVEAT_CALLBACK is called into player's script when moving is finished, failed or stopped

extern void SC_P_Ai_OccupyHideout(sc_player pl_id, dword hideout_ptr);
											// occupies hideout_ptr ( return value of SC_GetRndHideout ) by player
											// creates msgbox when hideout is already occupied for someone else
											// player must already stay on the hideout when calling this function ( otherwise he could deselect it in the next game frame )

extern void SC_P_Ai_SetWatchShoot(sc_player pl_id, s_SC_P_AI_WatchShoot *info);			// ma nejvyssi prioritu, funguje ve vsech modech i v presunu
																						// NULL means stop it

extern BOOL SC_P_Ai_GetStatus(sc_player pl_id, s_SC_P_AI_status *status);		// returns FALSE when player is not respawned




extern void SC_P_Ai_Situation_Forget(sc_player pl_id, dword flags);
											// flags are SC_P_AI_SIT_FORGET_
extern dword SC_P_Ai_Situation_KnowsAbout(sc_player pl_id, sc_player target);
											// pl_id is AI asked for his knowledge about target (should be enemy, otherwise SC_P_AI_SIT_TYPE_NONE is returned )
											// returns SC_P_AI_SIT_TYPE_ , priority is: enemy,danger,visual,sharedenemy
extern sc_player SC_P_Ai_Situation_GetNearest(sc_player pl_id, dword type, float max_dist, float *ret_dist);
											// returns nearest enemy/danger/visual/sharedenemy
											// type is SC_P_AI_SIT_TYPE_
											// max_dist is maximum search distance
											// ret_dist can be NULL, otherwise includes distance to returned player ( if any )
extern void SC_P_Ai_Situation_UpdateEnemy(sc_player pl_id, sc_player enemy_player);
											// adds or update info about enemy_player as if is seen
extern BOOL SC_P_Ai_CanSeePlayer(sc_player pl_id, sc_player target, float max_distance);
											// executes visibility tests
											// uses pl_id's field of view settings

extern void SC_P_Ai_EnterVehicle(sc_player pl_id, sc_nod vehicle_nod, dword seat_index);

extern BOOL SC_P_Ai_EnterMwp(sc_player pl_id, sc_nod mwp_nod);
												// return FALSE when 
												//			- already occupied - the error msgbox will be displayed too
												//			- some AI is already going to occupy this ( no error msg box, just returns info that 'entermwp' is ignored

extern void SC_P_Ai_Medik_GetProps(sc_player pl_id, s_SC_P_Ai_Medik *props);
extern void SC_P_Ai_Medik_SetProps(sc_player pl_id, s_SC_P_Ai_Medik *props);

extern void SC_P_Ai_GotoHeal(sc_player pl_id, sc_player target);
extern void SC_P_Ai_GiveAmmo(sc_player pl_id, sc_player target);

extern dword SC_P_Ai_GetSpecTask(sc_player pl_id);	// SC_P_AI_SPECTASK_

// Multiplayer scripting


extern void SC_MP_InitSides(s_SC_MP_SideInfo *side, dword sides);// sides can be 1 or 2

extern void SC_MP_Side_SetPoints(dword side_id, int value);
			// valid on MP srv only, updates points to client automaticly
extern int SC_MP_Side_GetPoints(dword side_id);
			// valid on both server and clients

extern void SC_MP_Classes_Init(char *class_ini_file);		// initialised the list of available classes
extern void SC_MP_Class_SetLimit(char *class_name, dword limit);
				// changes class limit ( but can be overwrite by ClassLimit _mutator )
				// valid on MP server only
extern void SC_MP_RPG_Init(char *ini_filename);
				// initializes RPG data for current map, use just once when starting the map
																				

//==============================
// All SC_MP_RespawnGroup_ functions are valid on MP server only
//==============================

extern void SC_MP_RespawnGroup_Create(s_SC_MP_RespawnGroupCreate *info);
	// creates respawn group, auto fills
	
extern void SC_MP_RespawnGroup_SetSide(dword group_script_id, dword side_id);

extern void SC_MP_RespawnGroup_Remove(dword group_script_id);
	// removes respawn group

extern void SC_MP_RespawnGroup_SetAsDefaultForSide(dword group_script_id, dword side_id);
				// set's this respawn_group as a default for side_id - when new player joins or when his resp_group is not valid anymore for example
extern void SC_MP_RespawnGroup_SetForSide(dword group_script_id, dword side_id);
				// set all players from the side to respawn at selected resp_group
extern void SC_MP_RespawnGroup_SetForPlayer(dword group_script_id, dword player_handle);
extern dword SC_MP_RespawnGroup_GetFromPlayer(dword player_handle);	// returns group_script_id

//==============================
// All SC_MP_RespawnGroup_ functions are valid on MP server only
//==============================


extern void SC_MP_RespawnPlayer(dword pl_handle, dword respawngroup_script_id);
	// respawns player, valid on MP server only
extern BOOL SC_MP_RespawnPlayer_Vehicle(dword pl_handle, sc_nod vehicle_nod, dword seat_index);
	// respawns player in vehicle, valid on MP server only
	// returns FALSE when vehicle not found or seat is already occupied
extern void SC_MP_DerespawnAllPlayers(void);
	// valid on MP server only

extern void SC_MP_SwitchToNextMap(void);
		// valid on MP server only


extern void SC_MP_MsgToSrv(dword from_pl_handle, void *data, dword data_size);		// message comes to server as SC_MODESCRIPT_EVENT_MSG_TO_SRV, is guaranted with guaranted messages order
		// data_size limit is 255 bytes, use as less data as possible, every single byte counts in network speed...
extern void SC_MP_MsgToCln(dword to_pl_handle, void *data, dword data_size);		// message comes to client as SC_MODESCRIPT_EVENT_MSG_TO_CLN, is guaranted with guaranted messages order
		// to_pl_handle - use SC_MP_MSG_TOALL to send message to all clients connected
		// data_size limit is 255 bytes, use as less data as possible, every single byte counts in network speed...

extern void SC_MP_Synch_Create(dword mp_id, void *data, dword data_size);
		// creates MP synchro object, must be called on both server and client
extern void SC_MP_Synch_Remove(dword mp_id);
		// removes MP synchro object
extern void SC_MP_Synch_SendChanges(dword mp_id, BOOL force_whole);
		// must be called after the change to data is made, valid on server only
		// force_whole - send all data ( for cases where client is changing synch object localy ( timers for example )

extern void SC_MP_ModeSettings_Add(dword settings_ptr, char *ini_filename);
extern void SC_MP_ModeSettings_SetItem(char *keyword, dword *data);
extern void SC_MP_ModeSettings_GetItem(char *keyword, dword *data);

extern void SC_MP_P_ChangePoint(dword mp_id, int value);
		// changes player's points and experience
		// valid on MP server only

extern void SC_MP_P_AddPointFloat(dword mp_id, float val);
		// changes player's points and experience
		// valid on MP server only
		// for special bonuses, like when engineer adds ammo, it's not everytime worth of the whole one point
		// val must be >0, decreasing in float is not supported

extern int SC_MP_P_GetPoints(dword mp_id);
extern BOOL SC_MP_GetHighestPointsPlayer(dword *mp_id, int *points);
		// returns FALSE when there is no player
		// mp_id is filled with players mp_id, points is filled with his actual points
		// valid on both server and client

extern void SC_MP_P_GetPlayStats(dword mp_id, s_SC_MP_P_PlayStats *stats);
		// is valid on both server and clients


extern void SC_MP_P_PressFireRequest(dword mp_id, BOOL enable);
		// valid on MP server, send request to display "Press Fire to respawn" type text and to check that press
		// when enabled, msg SC_MODESCRIPT_EVENT_GET_PRESSFIRE_TEXT is called on client every frame to allow time counting for example
		// when user presses fire, msg SC_MODESCRIPT_EVENT_PRESSFIRE_PRESSED is called on server

extern void SC_MP_ActivateScenePlayersScripts(void);

extern void SC_MP_GetProps(s_SC_MP_Props *props);
extern void SC_MP_SetProps(s_SC_MP_Props *props);

extern void SC_SetWeaponsPickup(s_SC_WeapPickupLimits *info);

extern void SC_MP_RestartRound(void);
		// valid on srv only, restarts game round

extern void SC_MP_ModeScriptLocalMsg(dword param1, dword param2, dword param3, dword param4);
		// calls SC_MODESCRIPT_EVENT_LOCALMSG into local mode script

extern void SC_MP_GetUniqueId(dword *a, dword *b);		// unique id consists of both dwords, is used for various identification in MP


extern void SC_MP_Map_Init(s_SC_MP_Map_Init *info);
extern dword SC_MP_Map_AddItem(s_SC_MP_Map_Item *item);	// return item id
extern void SC_MP_Map_RemoveItem(dword map_item_id);	// map_item_id is value returned from SC_MP_Map_AddItem
extern void SC_MP_Map_AddObjective(s_SC_MP_Map_Objective *objective);
extern void SC_MP_Map_ChangeObjectiveStatus(dword objective_id, BOOL finished);				// valid on server only, is sent to all clients
extern void SC_MP_Map_ChangeObjectiveTextsPictures(s_SC_MP_Map_Objective *objective);		// is made locally, need to be set on all clients too

extern char *SC_MP_GetModeName(void);

extern void SC_MP_AddMsgToKillList(ushort *txt, dword pl_mp_id, float time);
		// adds line to right upper 'kills' list - for info about adding experiece
		// pl_mp_id - is used for choosing of correct color, 0 means default font color
		// time - time the msg to be displayed, 0 means default ( = the same as "killed" msgs )

extern dword SC_MP_P_GetCurrentRanking(dword pl_mp_id);	// returns poradi hrace ve hre - cislovano od 1
														// returns 0 when player not found

extern void SC_MP_EnableResultsMode(s_SC_MP_ResultsMode *info);	// NULL means switch it off ( but is automaticly switched off on nextmap, restartmap and restart round
																// valid on MP server only



// NOT FOR PUBLIC RELEASE !!!!!!

extern BOOL SC_NotPInit(void *init);		// calls GAM_Init() - used in the demo security

#endif  //#ifndef SC_GLOBAL_H




