#ifndef SHIGORLEVELLIBRARY
#define SHIGORLEVELLIBRARY
//shigor's level library
#include <inc/shigor/speeches.cxx>


#define MAXOBJECTIVES 15

//variables

int						gPhase=0;							//level gphase
s_SC_SP_Objective		gObjectives[MAXOBJECTIVES];			//objectives
int						gObjcount=0;						//objectives count


//sets gphase of the level

void SetLevelPhase(int tophase){

	SC_Log(3,"Level gPhase changed from %d to %d", gPhase, tophase);
	SC_Osi("Level gPhase changed from %d to %d", gPhase, tophase);
	gPhase = tophase;
	SC_sgi(SGI_LEVELPHASE,gPhase);
}

//objective functions

void Clear_OBJ(){
	CLEAR(gObjectives);		
	gObjcount=0;
}

void Add_OBJ(dword textid){
	int i;
	for (i=0;i<gObjcount;i++) if (gObjectives[i].text_id==textid) {
		SC_Log(1,"Duplicite objective added - %d",textid);
		return;
	}
	gObjectives[gObjcount].text_id=textid;
	gObjectives[gObjcount].state=SC_SP_OBJECTIVE_STATE_ACTIVE;
	gObjcount++;
	SC_SP_SetObjectives(gObjcount,gObjectives);
}

void Complete_OBJ(dword textid){
	int i;
	for (i=0;i<gObjcount;i++) {
		if ((gObjectives[i].text_id==textid)&&(gObjectives[i].state==SC_SP_OBJECTIVE_STATE_ACTIVE)){
			gObjectives[i].state=SC_SP_OBJECTIVE_STATE_FINISHED;
			SC_SP_SetObjectives(gObjcount,gObjectives);		 
			return;
		}
	}	
}

void Fail_OBJ(dword textid){
	int i;
	for (i=0;i<gObjcount;i++) if (gObjectives[i].text_id==textid) 
		gObjectives[i].state=SC_SP_OBJECTIVE_STATE_FAILED;
	SC_SP_SetObjectives(gObjcount,gObjectives);
}


int Get_OBJ_Stat(dword textid){
	int i;
	for (i=0;i<gObjcount;i++) 
		if (gObjectives[i].text_id==textid) 
			return gObjectives[i].state;
	return SC_SP_OBJECTIVE_STATE_NONE;
}


void AutoSave(dword name, dword desc, BOOL disable){
	s_SC_MissionSave savedata;
	
	CLEAR(savedata);
	savedata.savename_id=name;
	savedata.description_id=desc;
	savedata.disable_info=disable;
	SC_MissionSave(&savedata);
}

void Menu_EnableMedicEng(){
	s_SC_PC_CmdMenu menu;
	
	SC_PC_GetCommandMenu(&menu);
	menu.flags = SC_PC_CMDMENU_FL_ENABLEMEDIC | SC_PC_CMDMENU_FL_ENABLEAMMO;
	menu.medik_max_call_distance=40;
	menu.ammo_max_call_distance=40;
	SC_PC_SetCommandMenu(&menu);
}

void Menu_EnableMedicEng2(float distance){
	s_SC_PC_CmdMenu menu;
	
	SC_PC_GetCommandMenu(&menu);
	menu.flags = SC_PC_CMDMENU_FL_ENABLEMEDIC | SC_PC_CMDMENU_FL_ENABLEAMMO;
	menu.medik_max_call_distance=distance;
	menu.ammo_max_call_distance=distance;
	SC_PC_SetCommandMenu(&menu);
}


void Menu_DisableMedicEng(){
	s_SC_PC_CmdMenu menu;
	
	SC_PC_GetCommandMenu(&menu);
	menu.flags = 0;
	SC_PC_SetCommandMenu(&menu);
}

//show standard subtitles for the cutanim
void Titles(int first, int second){
	s_SC_ScreenInfo		sinfo;
	ushort				*texts[2];

	CLEAR(sinfo);
	sinfo.txts=2;
	sinfo.txt=texts;
	sinfo.chars_per_sec=18;
	texts[0]=SC_Wtxt(first);
	texts[1]=SC_Wtxt(second);
	sinfo.show_time=3;
	SC_ScreenInfo_Set(&sinfo);
}

#define ClearTitles SC_ScreenInfo_Set(NULL) 

dword AddFake(dword side, dword group, float vertime, char *name){
	s_SC_AI_FakeDanger fd;
	CLEAR(fd);
	fd.name=name; fd.verify_time=vertime;
	return SC_AI_FakeDanger_Add(side,group,&fd);
}

float	gHintTime=0,gSecHintTime=0;
dword	gSecondaryHint=0, gSecHintParam=0;

void SetHintTime(dword text, dword param, float time){
	ushort buf[60], buff[600];

	gHintTime=time;	
	if (!param){
		SC_HintSet(SC_Wtxt(text));
	} else {
		if (!SC_GetUserKeyName(param,buf,30)) return;
		swprintf(buff,SC_Wtxt(text),buf);
		SC_HintSet(buff);
	}
}

void SetDualHint(dword text, dword param1, dword param2, float time){
	ushort buf[60], bufx[60],buff[600];
	gHintTime=time;
	if (!SC_GetUserKeyName(param1,buf,30)) return;
	if (!SC_GetUserKeyName(param2,bufx,30)) return;
	swprintf(buff,SC_Wtxt(text),buf,bufx);
	SC_HintSet(buff);
}

#define SetHint(text) SetHintTime(text,0,8)

#define SetParamHint(text,param) SetHintTime(text,param,8)

void SetSecHintTime(dword text, dword param, float time){
	gSecondaryHint=text;
	gSecHintTime=time;
	gSecHintParam=param;
}

#define SetSecHint(text) SetSecHintTime(text,0,8)
#define SetSecParamHint(text,param) SetSecHintTime(text,param,8)

void ClearHint(){
	SC_HintSet(NULL);
	gSecondaryHint=0;
	gSecHintParam=0;
}

void CheckHints(float timech){
	gHintTime-=timech;
	if (gHintTime<0){		
		if (gSecondaryHint){
			SetParamHint(gSecondaryHint,gSecHintParam);
			gHintTime=gSecHintTime;
		}
		else ClearHint();
		gSecondaryHint=0;
		gSecHintParam=0;
	}
}



#endif
