//generic US soldier
//accepts redefinitions:
//GROUP, MEMBERID, NAME_NR
//CLASS, RANK, AIFLAG

//can use RESPAWNGPHASE to specify levelphase when soldier will be respawned
//can use GENERICVOICE to redefine generic voice group for player
//can use VEHICLELINK (position) and VEHICLENAME to link after start to vehicle
//can use DISABLEPLAYER to disable player creation (for debug);
//can use NOWEAPONS to disable all weapons
//can use MGUNNAME to link on MWP after respawn
//can use NOAIBLOCKER to disable creation of ai blocker under the player
//can use FORCEMAINGUN	to force use selected weapon
//can use ADDGRENADE
//use #define REDEFINEMAIN for user main, main function from this file will be renamed to SoldierMain()


#include <inc\sc_global.h>
#include <inc\sc_def.h>
#include <inc\shigor\library.cxx>
#include <inc\all\ai.cxx>

#ifndef GROUP
#define GROUP	0
#endif

#ifndef MEMBERID
#define MEMBERID SC_P_CREATE_MEMID_AUTO
#endif

#ifndef NAME_NR
#define NAME_NR		2728
#endif

#ifndef RANK
#define RANK RNK_3
#endif

#ifndef CLASS
#define CLASS CLS_SOLDIER
#endif

#ifndef AIFLAG
#define AIFLAG 0
#endif

dword		gPhase = 0;
c_Vector3	startpos;

void CreatePlayer(s_SC_Pscript_info *info){
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;
	s_PlayerIniEqp		ini_eqp;
	s_SC_P_CreateWeap	weap[3];
	s_SC_P_AmmoRedefine	amred[1];

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);
#ifdef SPAWNCROUCHED
	resp_pos.flags=SC_P_RESPPOS_FL_CROUCH;
#endif


	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
#ifndef NOAIBLOCKER
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER; 
#endif
#ifdef ALLOWCOMA
	create_info.flags |=	SC_P_CREATE_FL_ALLOW_COMA;
#endif
#ifdef DEATHINIK
	create_info.flags |= SC_P_CREATE_FL_FORCE_USE_IK_DEATH;
#endif
	create_info.side =		SC_P_SIDE_US;
	create_info.group =		GROUP;
	create_info.member_id =	MEMBERID;
	create_info.name_nr =	NAME_NR;
#ifdef RESPAWNGPHASE
	create_info.respawn = NULL;
#else
	create_info.respawn = &resp_pos;			
	startpos=resp_pos.pos;
#endif

#ifdef GENERICVOICE
	create_info.genvoice_group=GENERICVOICE;
#endif

	if (CLASS==7){
		 //pilot
			usGetPlayerIniEqp(RANK,CLS_SOLDIER,SUB_RND,&ini_eqp);
			sprintf(ini_eqp.bodyIni,"cup_pilot01");
			sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_pilot01\\pilot\\eqp.ini");
			sprintf(ini_eqp.headIni,"hvm_001");
			sprintf(ini_eqp.headEqp,"G\\characters\\_heads\\_eqpini\\uhg018.ini");
	} else if (CLASS==8){
		 //apc driver
			usGetPlayerIniEqp(RANK,CLS_SOLDIER,SUB_RND,&ini_eqp);
			sprintf(ini_eqp.bodyIni,"cup_pilot01");
			sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_pilot01\\apc\\eqp.ini");
			sprintf(ini_eqp.headIni,"hvm_009");
			sprintf(ini_eqp.headEqp,"G\\characters\\_heads\\_eqpini\\uhg019.ini");
	} else if (RANK==7){
		//MACV
			usGetPlayerIniEqp(5,CLS_SOLDIER,SUB_RND,&ini_eqp);
			if (rand()%2) {
				sprintf(ini_eqp.bodyIni,"cup_macv01");
				if (rand()%2)
					sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_macv01\\soldier_a\\eqp.ini");
				else 
					sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_macv01\\soldier_b\\eqp.ini");
			} else {
				sprintf(ini_eqp.bodyIni,"cup_macv04");
				if (rand()%2)
					sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_macv04\\soldier_a\\eqp.ini");
				else 
					sprintf(ini_eqp.bodyEqp,"g\\characters\\cup_macv04\\soldier_b\\eqp.ini");			
			}
	}else 
			usGetPlayerIniEqp(RANK,CLASS,SUB_RND,&ini_eqp);

#ifdef FORCEMAINGUN
	weap[0].weap_id=FORCEMAINGUN;
	if (FORCEMAINGUN==43){
		amred[0].ammo_type=33;
		amred[0].max_ammo=8;
		create_info.ammo_redefines = 1;
		create_info.ammo_redefine = amred;
	}
#else
	weap[0].weap_id=ini_eqp.weapon;
#endif
#ifdef NOWEAPONS	
	create_info.weapons = 0;
#else 
	create_info.weapons = 1;
#endif
	create_info.weap = weap;

#ifdef ADDGRENADE
	weap[create_info.weapons].weap_id=59;
	create_info.weapons++;
#endif
	create_info.inifile=ini_eqp.bodyIni;
	create_info.eqp_inifile=ini_eqp.bodyEqp;
	create_info.head_name=ini_eqp.headIni;
	create_info.head_eqp_inifile=ini_eqp.headEqp;
#ifdef REDEFINIFILENAME
	create_info.inifile=REDEFINIFILENAME;
#endif
#ifdef BODYEQP
	create_info.eqp_inifile=BODYEQP;
#endif
#ifdef HEAD
	create_info.head_name=HEAD;
#endif
#ifdef HEADEQP
	create_info.head_eqp_inifile=HEADEQP;
#endif
	if (!(rand() % (SC_GetDifficulty()+3))){
		weap[create_info.weapons].weap_id=60;
		create_info.weapons++;
	}
	SC_P_Create(&create_info);
}


#ifdef REDEFINEMAIN
int SoldierMain(s_SC_Pscript_info *info){
#else
int ScriptMain(s_SC_Pscript_info *info){
#endif

	s_SC_P_status				status;
	s_SC_P_RespawnPos			resp_pos;
	s_SC_Plscr_info				plscr_info;
	s_SC_P_ScriptProps			sc_props;

#ifdef DISABLEPLAYER
	return 1;
#endif

	switch(info->message){

		case SC_PLSCR_MSG_SCRIPT_INIT:					
			CreatePlayer(info);
			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:			
			break;

		case SC_PLSCR_MSG_PL_CREATED:			
			break;

		case SC_PLSCR_MSG_PL_RELEASED:			
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
			gPhase = 2;			
			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			gPhase = 666;			
			
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:
			switch(gPhase) {
			case 0:
				#ifdef RESPAWNGPHASE				
				if (GetLevelPhase >= RESPAWNGPHASE ){
					CLEAR(plscr_info);
					SC_PlScr_GetInfo(info->script, &plscr_info);
					CLEAR(resp_pos);
					SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);					
#ifdef SPAWNCROUCHED
					resp_pos.flags=SC_P_RESPPOS_FL_CROUCH;
#endif
					SC_P_Respawn(info->player, &resp_pos);
					startpos=resp_pos.pos;
					gPhase=1;
				}
				#endif			
				
				break;						
			case 2:
				CLEAR(status);
				if (!SC_P_GetStatus(info->player, &status)) return 0;
				if (CLASS>6) {
					SetRankClass(info->player,SC_GetDifficulty(),RANK,CLS_SOLDIER,AIFLAG);
				}
				else if (RANK==7) {
					SetRankClass(info->player,SC_GetDifficulty(),5,CLASS,AIFLAG);
				}
				else SetRankClass(info->player,SC_GetDifficulty(),RANK,CLASS,AIFLAG);
				
#ifdef VEHICLELINK
				SC_P_Vehicle_Link(info->player, SC_NOD_Get(NULL,VEHICLENAME),VEHICLELINK);

#endif

#ifdef MGUNNAME
				 SC_P_Mwp_Link(info->player,SC_NOD_Get(NULL,MGUNNAME));
#endif

#ifdef SCRIPTMODEON
				SC_P_Ai_SetScriptMode(info->player,TRUE);
#endif

#ifdef IMMORTAL
				CLEAR(sc_props);
				SC_P_GetScriptProps(info->player, &sc_props);
				sc_props.received_damage_mult	= 0.0f;
				SC_P_SetScriptProps(info->player, &sc_props);
#else
#ifdef TOUGHGUY
				CLEAR(sc_props);
				SC_P_GetScriptProps(info->player, &sc_props);
				sc_props.received_damage_mult	= 0.1f;
				SC_P_SetScriptProps(info->player, &sc_props);
#endif
#endif

				gPhase = 10;
				break;
			case 10:
				break;
			case 666:
				//I am derespawned
				break;

			}
			break;

		case SC_PLSCR_MSG_PL_HIT:			
			break;

		case SC_PLSCR_MSG_PL_KILLED:
			gPhase=999;
			break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)