//generic VC soldier
//accepts redefinitions:
//GROUP, MEMBERID, NAME_NR
//CLASS, RANK, AIFLAG
//SECONDARYCLASS - with RANDOMCLASS percent chance will set the secondary class

//can use RESPAWNGPHASE to specify levelphase when soldier will be respawned
//can use GENERICVOICE to redefine generic voice group for player
//can use VEHICLELINK (position) and VEHICLENAME to link after start to vehicle
//can use MEDIK or ENGINEER to make soldier medic or engineer
//can use IMMORTAL to make player immortal
//can use #define TOUGHGUY to make player much more stronger

//use #define REDEFINEMAIN for user main, main function from this file will be renamed to SoldierMain()


#include <inc\sc_global.h>
#include <inc\sc_def.h>
#include <inc\shigor\library.cxx>
#include <inc\all\ai.cxx>

#ifndef GROUP
#define GROUP	0
#endif

#ifndef MEMBERID
#define MEMBERID SC_P_CREATE_MEMID_AUTO
#endif


#ifndef NAME_NR
#define NAME_NR		2739
#endif

#ifndef RANK
#define RANK RNK_1
#endif

#ifndef CLASS
#define CLASS CLS_SOLDIER
#endif

#ifndef AIFLAG
#define AIFLAG 0
#endif

dword	gPhase = 0;
int		aiclass=0;
dword	myweapon;


void CreatePlayer(s_SC_Pscript_info *info){
	s_SC_P_Create		create_info;
	s_SC_P_RespawnPos	resp_pos;
	s_SC_Plscr_info		plscr_info;
	s_PlayerIniEqp		ini_eqp;
	s_SC_P_CreateWeap	weap[3];
	s_SC_P_AmmoRedefine	amred[1];

	CLEAR(plscr_info);
	SC_PlScr_GetInfo(info->script, &plscr_info);
	CLEAR(resp_pos);
	SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);

	CLEAR(create_info);
	create_info.script =	info->script;
	create_info.type =		SC_P_CREATE_TYPE_AI;
	create_info.flags =		SC_P_CREATE_FL_GENERATE_AI_BLOCKER; 
#ifdef ALLOWCOMA
	create_info.flags |=	SC_P_CREATE_FL_ALLOW_COMA;
#endif
#ifdef ONLYCOMA
	create_info.flags |=	SC_P_CREATE_FL_NODEADJUSTCOMA;
#endif
#ifdef ALWAYSDEATHINIK
	create_info.flags |=	SC_P_CREATE_FL_FORCE_USE_IK_DEATH;

#endif
	create_info.side =		SC_P_SIDE_VC;
	create_info.group =		GROUP;
	create_info.member_id =	MEMBERID;
	create_info.name_nr =	NAME_NR;
#ifdef CLASSNAME
	create_info.class_name_id = CLASSNAME;
#endif


#ifdef RESPAWNGPHASE
	create_info.respawn = NULL;
#else
	create_info.respawn = &resp_pos;			
#endif

#ifdef GENERICVOICE
	create_info.genvoice_group=GENERICVOICE;
#endif


	aiclass=CLASS;
#ifdef SECONDARYCLASS
	if ((rand()%100)<=RANDOMCLASS) aiclass=SECONDARYCLASS;
#endif
	
	vcGetPlayerIniEqp(RANK,aiclass,SUB_RND,&ini_eqp);
	
#ifdef FORCEMAINGUN
	weap[0].weap_id=FORCEMAINGUN;
#else
	weap[0].weap_id=ini_eqp.weapon;
#endif
	myweapon=weap[0].weap_id;
	create_info.weapons = 1;
#ifdef MEDIK
	weap[1].weap_id=60;
	create_info.weapons = 2;
	amred[0].ammo_type = 22;				//medkit 'ammo'
	amred[0].max_ammo = 1000;				//ammo amount
	create_info.ammo_redefines = 1;
	create_info.ammo_redefine = amred;
#else
	if (!(rand() % (SC_GetDifficulty()+3))){
		weap[create_info.weapons].weap_id=60;
		create_info.weapons++;
	}

#endif

#ifdef ENGINEER
	weap[1].weap_id=61;
	create_info.weapons = 2;
	amred[0].ammo_type = 23;				//'ammo'
	amred[0].max_ammo = 1000;				//ammo amount
	create_info.ammo_redefines = 1;
	create_info.ammo_redefine = amred;
#endif

#ifdef ADDGRENADE
	weap[create_info.weapons].weap_id=70;
	create_info.weapons++;
#endif

	create_info.weap = weap;
	create_info.inifile=ini_eqp.bodyIni;
	create_info.eqp_inifile=ini_eqp.bodyEqp;
	create_info.head_name=ini_eqp.headIni;
	create_info.head_eqp_inifile=ini_eqp.headEqp;

#ifdef REDEFINIFILENAME
	create_info.inifile=REDEFINIFILENAME;
#endif
#ifdef BODYEQP
	create_info.eqp_inifile=BODYEQP;
#endif
#ifdef HEAD
	create_info.head_name=HEAD;
#endif
#ifdef HEADEQP
	create_info.head_eqp_inifile=HEADEQP;
#endif

	
	
	SC_P_Create(&create_info);
}


#ifdef REDEFINEMAIN
int SoldierMain(s_SC_Pscript_info *info){
#else
int ScriptMain(s_SC_Pscript_info *info){
#endif

	s_SC_P_status				status;
	s_SC_P_RespawnPos			resp_pos;
	s_SC_Plscr_info				plscr_info;
	s_SC_P_ScriptProps			sc_props;
	s_SC_P_Ai_Medik				mp;
	

	switch(info->message){

		case SC_PLSCR_MSG_SCRIPT_INIT:					
			CreatePlayer(info);
			break;

		case SC_PLSCR_MSG_SCRIPT_RELEASE:			
			break;

		case SC_PLSCR_MSG_PL_CREATED:			
			break;

		case SC_PLSCR_MSG_PL_RELEASED:			
			break;

		case SC_PLSCR_MSG_PL_RESPAWNED:
			gPhase = 2;			
			break;

		case SC_PLSCR_MSG_PL_DERESPAWNED:
			gPhase = 666;			
			
			break;

		case SC_PLSCR_MSG_SCRIPT_TIMETICK:
			switch(gPhase) {
			case 0:
				#ifdef RESPAWNGPHASE				
				if (GetLevelPhase >= RESPAWNGPHASE ){
					CLEAR(plscr_info);
					SC_PlScr_GetInfo(info->script, &plscr_info);
					CLEAR(resp_pos);
					SC_NOD_FillRespawnPos(plscr_info.nod, &resp_pos);					
					SC_P_Respawn(info->player, &resp_pos);
					gPhase=1;
				}
				#endif			
				
				break;						
			case 2:
				CLEAR(status);
				if (!SC_P_GetStatus(info->player, &status)) return 0;
#ifdef FAKERANK
				SetRankClass(info->player,SC_GetDifficulty(),FAKERANK,aiclass,AIFLAG);
#else
				SetRankClass(info->player,SC_GetDifficulty(),RANK,aiclass,AIFLAG);
#endif

#ifdef VEHICLELINK
				SC_P_Vehicle_Link(info->player, SC_NOD_Get(NULL,VEHICLENAME),VEHICLELINK);

#endif

#ifdef IMMORTAL
				CLEAR(sc_props);
				SC_P_GetScriptProps(info->player, &sc_props);
				sc_props.received_damage_mult	= 0.0f;
				SC_P_SetScriptProps(info->player, &sc_props);
#else
#ifdef TOUGHGUY
				CLEAR(sc_props);
				SC_P_GetScriptProps(info->player, &sc_props);
				sc_props.received_damage_mult	= 0.1f;
				SC_P_SetScriptProps(info->player, &sc_props);
#endif
#endif

#ifdef MEDIK
				SC_P_Ai_Medik_GetProps(info->player, &mp);
				mp.peace.range			= 30;
				mp.peace.hp_percentage	= 0.8f;
				mp.battle.range			= 12;
				mp.battle.hp_percentage	= 0.5f;
				SC_P_Ai_Medik_SetProps(info->player, &mp);
#endif

#ifdef SCRIPTMODEON
				SC_P_Ai_SetScriptMode(info->player,TRUE);
#endif
#ifdef STANDSTATIV
				SC_P_SetAnimsVariations(info->player, SC_P_ANIMVARIATION_DISABLE_ALL);
				SC_P_SetSystemAnim(info->player, 'X', 0, STANDSTATIV);
#endif

#ifdef FACETYPE
				SC_P_Grimace_Set(info->player,FACETYPE,0,0);
#endif
				gPhase = 10;
				break;
			case 10:
				break;
			case 666:
				//I am derespawned
				break;

			}
			break;

		case SC_PLSCR_MSG_PL_HIT:
			break;

		case SC_PLSCR_MSG_PL_KILLED:
			gPhase=777;
			break;

	}// switch(info->message)

	return 1;

}// int ScriptMain(s_SC_P_info *info)